;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;<    |'\   |'\   |  |  |  |'\               |     |'\   |'\    /'\  |  |'\    >
;<    |  \  | /   |  |  |  |  \              |     |  \  | /   |  |  |  |  \   >
;<    |  /  | \   |  |  |  |  /     '| |'\  /|     |  /  | \   |  |  |  |  /   >
;<    |_/   |  \  \_/   |  |_/     ( | | | |_|     |_/   |  \  \_/   |  |_/    >
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;<    A game for Amstrad CPC by Leosoft.       Code, gfx & music by Arnolde    >
;<                     === Entry for CPCRetrodev 2022 ===                      >
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;	dd-code.asm - the whole program code in one big fat ugly file
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
; DISCLAIMER - I'm not a programmer and I never learned how to write
; beautiful code. I'm over-optimizing, always proud to save a bytes.
; I'm sorry if this program is not easy to read...
;
; 	- some terms & acronyms I use in the code & comments -
;
; ascii = index of character (actually a little different than ascii)
; avatar or av = the protagonists (wiz & bot)
; bot = used instead of "droid" in the code
; curr = current
; FOOBAR = placeholder for SMC variables
; index = usually means the x'th element of a table, map or list
; lut = lookup table
; M = (HL) - like in 8008 asm
; sfx = sound effect
; SMC = self modifying code (and there's a lot of it ;-O)
; stats = stat(u)s table
; STBIT = status bit
; txt = text
; wiz = used instead of "druid" in the code


nolist
org #80
run #80


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                           CONSTANTS AND INITVALUES
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

;LOGIC
;some stuff for better readability
EOL 				equ #80
EOT 				equ #ff
FOOBAR 				equ #00
ASCII0 				equ "3"

;opcodes for self modifying code
OPCODE_NOP			equ #00			;nop
OPCODE_INC_D 		equ #14			;inc d
OPCODE_JRNZ			equ #20			;jr nz
OPCODE_JRZ			equ #28			;jr z
OPCODE_LDnnA		equ #32			;ld (nn),a
OPCODE_INC_M 		equ #34			;inc (hl)
OPCODE_DEC_M 		equ #35			;dec (hl)
OPCODE_SETCARRY 	equ #37			;scf
OPCODE_BIT0A		equ #47			;2nd byte of bit 0,a
OPCODE_RESCARRY 	equ #A7			;and a
OPCODE_RES6D		equ #B2			;2nd byte of res 6,d
OPCODE_JP 			equ #C3			;jp
OPCODE_SET4D		equ #CB			;2d byte of set 4,d
OPCODE_RET 			equ #C9			;ret


;general game values
TOTAL_MISSIONS 		equ 7
LEVELS_PER_MISSION 	equ 7
TOTAL_LEVELS 		equ TOTAL_MISSIONS*LEVELS_PER_MISSION
DEFAULT_LIVES 		equ 3
DEFAULT_CREDITS 	equ 3
MAX_ITEMS 			equ 8 		;maximal amount of displayable items
BOT_LOWBYTE  		equ #10 	;lowbyte of the bot's info-tables
;the two game modes are:
;	lets play = 1
;	challenge = 0

;status_screen var bits
STBIT_GAME_RUNNING	equ 0
STBIT_PALETTE_MENU	equ 1
STBIT_PALETTE_GAME	equ 2
STBIT_DRAW_AVATARS	equ 3
STBIT_SHOW_ANIM		equ 4
STBIT_MACHINE_FG	equ 7

;screen modes (common combinations of these bits)
SCRMODE_BLACK		equ 0
SCRMODE_MENU 		equ %00010
SCRMODE_GAME 		equ %11101
SCRMODE_INFO 		equ %00100
SCRMODE_AVATARS 	equ %01100
SCRMODE_INTRO		equ %11100
SCRMODE_CUTSCENE	equ %10001100

;_status_game var BITs
STBIT_TIME_OUT		equ 1
STBIT_ABORT_GAME 	equ 2
STBIT_GAME_OVER		equ 3
STBIT_UPDATE_SCORE	equ 4
STBIT_ENEMY_DEAD 	equ 5

;offsets (and contents) of each avatar's status table
AV_STATUS 			equ #00		;movement & position status
		;meaning of the bits:
		AV_MOVE_UP_BIT 		equ 0
		AV_MOVE_DOWN_BIT 	equ 1
		AV_MOVE_LEFT_BIT 	equ 2
		AV_MOVE_RIGHT_BIT 	equ 3
		AV_FALLING_BIT 		equ 4
		AV_UNDERWATER_BIT 	equ 5
		AV_BLOCKED_TOP 		equ 6
AV_Y_COORD 			equ #01		;y coord (2px/unit)
AV_X_COORD 			equ #02		;x coord
AV_SPRITETYPE 		equ #03		;current sprite index, that is:
		AVATAR_FRONT 		equ 0
		AVATAR_HAPPY 		equ 1
		AVATAR_DEAD 		equ 2
		AVATAR_CLIMB1 		equ 3
		AVATAR_CLIMB2 		equ 4
		AVATAR_RIGHT_EVEN 	equ 5
		AVATAR_RIGHT_ODD 	equ 6
		AVATAR_LEFT_EVEN 	equ 7
		AVATAR_LEFT_ODD 	equ 8
		AVATAR_INVISIBLE 	equ -1
AV_LUT_SPRITES 		equ #04		;Lookup table of this avatars sprites (word)
AV_LIVES 			equ #06
AV_LIFE_ADDR_LO 	equ #07		;scraddress for the life symbols in statusline
AV_LIFE_SYMBOL 		equ #08 	;bitmap of life symbol (word)
AV_ITEMS 			equ #0A		;in BCD
AV_ITEM_ADDR_LO 	equ #0B		;scraddress for displaying the item status
AV_STRUCK_ANIM		equ #0C		;counter for animation life loss
AV_HAPPY_ANIM 		equ #0D		;counter for animation happy

;values for the level map
TILE_AIR 			equ #00
TILE_SEA 			equ #08
TILE_PLATFORM 		equ #10
TILE_LADDER 		equ #20
TILE_OBSTACLE 		equ #40
TILE_ENEMY 			equ #80

;significant bits for the level tiles
TILE_SEA_BIT 		equ 3
TILE_PLATFORM_BIT	equ 4
TILE_LADDER_BIT		equ 5
TILE_OBSTACLE_BIT	equ 6
TILE_ENEMY_BIT		equ 7

;GRAPHICS
;scraddresses
SCRBASE_GAME 		equ #C100
SCRBASE_STATUS 		equ #CE00
SCRBASE_BACKUP		equ #8100
TIMEMACHINE_POS		equ #F498
TIMEMACHINE_X		equ 48
TIMEMACHINE_Y		equ GAMEFLD_HGHT-21
AND_MASK_TABLE		equ #FF00
ANDMASK_TABLE_HI	equ #FF


;Graphic DIMENSIONS
;1 unit = 2 pixels !!!
GAMEFLD_WDTH 		equ 128
GAMEFLD_HGHT 		equ 80
GAME_TILE_WDTH 		equ 8
GAME_TILE_HGHT	 	equ 8
AVATAR_WDTH 		equ 8		;wiz or bot sprites
AVATAR_HGHT 		equ 12
ITEM_WDTH			equ 6		;item sprites
ITEM_HGHT			equ 6
TIMEMACHINE_WDTH 	equ 8		;bytes à 4 px
TIMEMACHINE_HGHT 	equ 42		;lines (1px)
JUEZ_HGHT			equ 32
;speech bubble width
BUBBLE_WDTH			equ #30		;bytes

;animation values
ANI_LEN_HAPPY		equ 8
ANI_LEN_STRUCK		equ 18
ANI_SPEED_MACHINE	equ 8
ANI_FLASH_LEN	equ 14

;calc xor value to swap item sprite
;(shifted for even or odd x value)
SPREBAS 			equ sprite_items_even/#100
SPROBAS 			equ sprite_items_odd/#100
SWAP_SPRITES_HORI 	equ SPREBAS xor SPROBAS

;TEXT
;text shortcuts
SHC_year 			equ 0	;year of curr mission
SHC_location 		equ 1	;location - " -
SHC_wiz_item 		equ 2	;wiz's item - " -
SHC_bot_item 		equ 3	;bot's  - " -
SHC_message 		equ 4	;level message / title
SHC_passcode 		equ 5
SHC_itemsstatus 	equ 6	;2 digits ascii
SHC_itemsgoal 		equ 7	;2 digits ascii
SHC_mission 		equ 8	;1 digit ascii
SHC_level 			equ 9	;1 digit ascii
SHC_timertext 		equ 10	;2 digits ascii

;SOUND
;sound effects
SFX_WIZUP			equ 1
SFX_BOTUP			equ 2
SFX_SCREAM			equ 3
SFX_BOMB			equ 4
SFX_LEVELCLEARED	equ 5
SFX_GAMEOVER		equ 6
SFX_DING			equ 7
SFX_BEEP			equ 8

;music
;MISSION MUSIC -> 0-6
SONG_INTRO			equ 7
SONG_TIMEMACHINE	equ 8
SONG_SILENCE		equ 9
SONG_MENU			equ 10




;this is where we start:
jp init_start_program

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                                   INCLUDES, I
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

read "dd-macros.asm"
read "dd-data1.asm"					;This are level & mission data.
									;I put them here in order to keep the same
									;passcodes when changing the program code

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                                    MAIN MENU
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

;#############
;# MAIN MENU #
;#############

menu_main:
	call clear_gamefield
	ld de,__colors_header			;main menu has same
	call screen_copy_bg_color		;palette as header (inks 0-3)
	call screen_set_black			;turn colors to 0 before
	ld a,SCRMODE_MENU				;setting screen to
	ld (_status_screen),a			;"menu" mode

menu_main_no_cls:
	;always select tune in case music was set On/Off to take action
	ld a,SONG_MENU					;set menu tune
	call sound_select_tune
	ld hl,input_read_numbers		;select input routine
	ld (_input_routine),hl			;that ready number keys
	call txt_set_pen_2
	ld hl,__textpage_menu			;load menu text
	ld b,11							;11 items to display
	call display_textpage
	menu_wait_valid_input:
	call input_wait_key
	sub ASCII0+1					;1 show intro
	jp z,csc_show_prologue
	dec a							;2 play for fun
	jr z,menu_game_fun
	dec a							;3 play for points
	jr z,menu_game_points
	dec a							;4 input device toggle
		ld hl,__toggle_input
		ld de,__text_input
	jr z,menu_toggle_text
	dec a							;5 define keyboard
	jr z,menu_define_custom
	dec a							;6 toggle monitor
		ld hl,__toggle_monitor
		ld de,__text_monitor
	jr z,menu_toggle_text
	dec a							;7 toggle music
		ld hl,__toggle_OnOff
		ld de,__text_music
	jr z,menu_toggle_text
	dec a							;8 toggle sfx
		;hl=__toggle_OnOff still
		ld de,__text_sfx
	jr z,menu_toggle_text
	dec a:jp z,0					;9 Exit
	jr menu_wait_valid_input

menu_toggle_text:
	;toggle text in the menu textpage by
	;xor'ing with a certain string
	;de = text address, hl = xor string (1st byte=length)
	ld b,(hl)						;read length
	menu_toggletxt_lp:
		inc hl
		ld a,(de)					;read original character
		xor (hl)					;xor with toggle value
		ld (de),a					;save modified character
		inc de
		djnz menu_toggletxt_lp
	jr menu_main_no_cls				;back to menu without clearing screen

menu_game_fun:
	inc a 							;lets play = 1
	ld (_curr_game_mode),a
	jr menu_input_passcode

menu_game_points:
	ld (_curr_game_mode),a 			;set game mode to points = 0
	ld (_curr_mission),a			;reset level (challenge...
	ld (_curr_level),a				;...always starts @ 1/1)
	ld hl,_score_bcd				;reset score
	ld (hl),a
	inc hl:ld (hl),a
	inc hl:ld (hl),a
	call convert_score_to_ascii		;reset ascii score
	ld a,ASCII0+DEFAULT_CREDITS
	ld (_game_credits),a			;set credits to default
	call setup_mission_direct		;no dialogue in first level
	jp main_loop

menu_define_custom:
	ld hl,input_scan_kb_lines
	ld (_input_routine),hl
	call draw_bubble_with_caption
__text_press_key:
		db "p",44,"s",35,"ke",40+EOL;"press key "
	call txt_write_this_string
		db 42+EOL					;"for"
	ld hl,__bigtxt_directions
	ld bc,__keyboard_keymap
		menu_define_custom_lp:
		push bc
		ld bc,#C35A					;scraddr
		ld a,5						;length
		call txt_big_write_set_len
		call input_wait_key
		pop bc						;restore keymap addr
	scanned_keyline equ $+1
		ld a,FOOBAR					;is written by input_scan_kb_lines
		ld (bc),a					;save line
		inc bc
		ld a,(_user_input)			;get bitmask
		ld (bc),a					;save bitmask
		inc bc
		ld a,__keyboard_keymap+12
		cp c
		jr nz,menu_define_custom_lp
	jp menu_main

menu_input_passcode:
	call draw_bubble_with_caption
		db 15,"t",26,"_",12+EOL		;"enter passcode"
	ld hl,txadr_passcode-1
	push hl
	ld b,5							;prepare underscores for 5 digits
		inc hl
		ld (hl),"O"					;fill placeholders with "_"s
		djnz $-3
	menu_input_passcode_lp:
	ld bc,#C35A						;scraddr
	ld a,5							;length
	ld hl,txadr_passcode			;text
	call txt_big_write_set_len
	pop hl							;restore last position
	inc hl							;advance to next
	ld a,txadr_passcode+5			;check if
	cp l							;through
	jr z,menu_input_passcode_end
	call input_wait_key
	ld (hl),a						;save digit
	push hl
	ld hl,_sfx_to_play
	ld (hl),SFX_BEEP				;beep
	jr menu_input_passcode_lp		;loop
	menu_input_passcode_end:
	call wait_one_second			;show full passcode for a moment

	;The "passcode" is actually the address of the level data
	;but with exchanged hi & lowbyte and converted to decimal
	call convert_dectobin			;convert string to hl
	ex de,hl 						;reversed passcode in de
	;look for this address in the level lookup table
	ld hl,__levels_lookuptable
	ld b,TOTAL_LEVELS				;count backwards
		menu_look_for_addr:
		ld a,d
		cp (hl) 					;check lowbyte (in d!)
		inc hl
		jr nz,menu_look_for_addr_no
			ld a,e
			cp (hl)					;check hibyte (in e!)
			jr z,menu_found_passcode
		menu_look_for_addr_no:
		inc hl
		djnz menu_look_for_addr
	ld b,TOTAL_LEVELS				;invalid input -> M1/L1

	menu_found_passcode:
	;calculate mission & level
	ld a,TOTAL_LEVELS:sub b			;a=level index
	ld bc,#FF00+LEVELS_PER_MISSION	;b=-1, c=LEVELS_PER_MISSION
		inc b:sub c
		jr nc,$-2					;divide by LEVELS_PER_MISSION
	add c							;b=mission, a=remainder=level

	ld (_curr_level),a
	ld a,b
	ld (_curr_mission),a
	call setup_mission_direct

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                                MAIN LOOP
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


main_loop:
	call setup_level
	call display_level_info			;info page
	call screen_set_black
	call draw_mission_bg
	call draw_level_map
	call screen_save_backup			;save to backup screen
	call draw_statusline
	ld a,SCRMODE_GAME				;set screen to
	ld (_status_screen),a			;"game" mode

game_loop:
	halt							;have a break, Z80 !
	;evaluate game status
_status_game equ $+1
	ld a,FOOBAR
	rra
	rra:jr c,game_end_time_out		;=STBIT_TIME_OUT
	rra:jr c,game_end_abort			;=STBIT_ABORT_GAME
	rra:jr c,game_end_gameover		;=STBIT_GAME_OVER
	rra 							;=STBIT_UPDATE_SCORE
	jr nc,game_loop
	;update_statusbar:
	ld hl,_status_game				;first, reset status bit
	res STBIT_UPDATE_SCORE,(hl)
	;check the lives and items
	call game_check_livesandpoints
	call draw_statusline

_items_goal equ $+1
	ld a,FOOBAR
	dec a							;for >= comparision
	ld hl,__stats_wiz+AV_ITEMS
	cp (hl)							;check if wiz has enough items
	jr nc,game_loop
	set 4,l							;HL points to bot items
	cp (hl)
	jr nc,game_loop					;check if bot has enough items
	;if both avatars have reached the items goal, fall through

;#####################
;# GAME END MESSAGES #
;#####################

game_end_level_clear:
	ld a,SFX_LEVELCLEARED			;play happy jingle
	ld (_sfx_to_play),a
	ld a,(_curr_level)
	inc a							;go to next level
	cp LEVELS_PER_MISSION			;check if mission done
	jr z,game_mission_clear
	ld (_curr_level),a
	ld hl,__bigtxt_levelcleared		;text for bubble
	call draw_game_end_bubble
	call game_end_check_mode
	jr main_loop

game_end_abort:
	ld hl,__bigtxt_aborted			;text for bubble
	call draw_game_end_bubble
	call input_key_ret_mode
	or a							;in challenge mode, lose 1 credit
	jr z,game_decrement_credits		;if game is aborted
	jr main_loop

game_end_time_out:
	ld hl,__bigtxt_timeout			;text for bubble
	jr game_lost

game_end_gameover:
	ld hl,__bigtxt_gameover			;text for bubble
	;fall through

game_lost:
	ld a,SFX_GAMEOVER				;play sad jingle
	ld (_sfx_to_play),a
	call draw_game_end_bubble
	ld a,SFX_GAMEOVER				;jingle once again
	ld (_sfx_to_play),a				;(echo effect)
	call input_key_ret_mode
	jp nz,main_loop					;if lets play, retry level
	;in challenge mode, fall through

game_decrement_credits:
	ld hl,_game_credits
	dec (hl)						;take away 1 credit
	ld a,ASCII0
	cp (hl)							;and check if 0
	push af
	ld hl,__bigtxt_credits			;text for bubble
	call draw_game_end_bubble
	call input_press_key
	pop af							;if credits = 0
	jp z,display_score_game_summary	;go to score summary
	jp main_loop					;else retry level

game_mission_clear:
	ld a,(_curr_mission)
	inc a
	push af							;don't update mission number yet, else...
	xor a							;	...items of next mission might appear
	ld (_curr_level),a				;reset level
	ld hl,__bigtxt_missioncleared	;text for bubble
	call draw_game_end_bubble
	call game_end_check_mode
	pop af							;restore mission number
	ld (_curr_mission),a			;update (after bubble delay)
	cp TOTAL_MISSIONS
	jr z,game_end_win
	call setup_mission_w_dialogue	;setup next mission & show dialogue
	jp main_loop

game_end_check_mode:
	ld a,SFX_LEVELCLEARED			;play happy jingle for the
	ld (_sfx_to_play),a				;second time (echo effect)
	call input_key_ret_mode		;branch to score processing routine
	call z,score_process_points		;if challenge
	ret

game_end_win:
	ld hl,csc_show_epilogue
	ld (_score_summary_jump),hl
	ld hl,__bigtxt_gamewon
	ld (_score_summary_text),hl
	ld a,(_curr_game_mode)
	or a
	jp z,display_score_game_summary
	call draw_game_end_bubble
	call input_press_key
	jp csc_show_epilogue

draw_game_end_bubble:
;hl=address of text message
	push hl							;backup text data
	push de
	;wait a while for animations & disappearing items
	ld bc,#0B02						;c = height for bubble later
		ld a,3:call wait_for_interrupt
		djnz $-5
	call screen_set_info
	ld hl,#E307						;address for bubble
	call draw_bubble_wiz			;game end bubble is in wiz's color
	pop de							;restore text data
	pop hl
	jp txt_big_write

;####################
;# SCORE MANAGEMENT #
;####################

score_process_points:
;no input
	call screen_restore_backup
	call draw_statusline
	;display captions - first one automatically
	call draw_bubble_with_caption
		db "B",39,"u",35,13,"m",34,"x4","["+EOL		;"Bonus Time"
	ld de,SCRBASE_GAME+#1215
	call txt_write_this_string
		db "Extr",19,"i",11,35,"x6","["+EOL		;"Extra Items"
	ld de,SCRBASE_GAME+#2253
	call txt_write_this_string
		db "Enemie",35,"ki",24,"e",37,"x8","["+EOL 	;"Enemies killed"
	call txt_swap_pen
	xor a
	ld (_points_to_add),a			;reset level total points
	;calculate and add points for extra time
	ld a,(_timer_game)
	ld de,SCRBASE_GAME+#01E9		;scraddr to display points
	call score_add_to_total_no_mult	;x1, skip multiplication
	;calculate & add points for extra items
	ld a,(_items_goal)
	add a
	daa								;items are counted in bcd
	ld b,a							;b=items_goal*2
	ld a,(__stats_wiz+AV_ITEMS)
	ld hl,__stats_bot+AV_ITEMS
	add (hl)
	daa
	sub b
	daa								;a=amount extra items
	ld b,3							;multiplicator
	ld de,SCRBASE_GAME+#1229		;scraddr to display points
	call score_add_to_total
	;calculate points for killed enemies
_score_enemies_killed equ $+1
	ld a,FOOBAR
	ld b,5							;multiplicator
	ld de,SCRBASE_GAME+#2269		;scraddr to display points
	call score_add_to_total
	call wait_one_second
	;show score "rising" animation
	call draw_bubble_with_caption
		db "_sco",44,"["+EOL
		scoreanim:
		call wait_frameflyback
		ld hl,_score_bcd+2			;start with highest double-digit
		score_add_points:			;do this once for every added point
			ld a,(hl)
			add 1					;increase score (by 1)
			daa
			ld (hl),a
			jr nc,$+5				;if carry, recursively repeat
				dec hl				;for next double digit(s)
				jr score_add_points
		;display score
		call convert_score_to_ascii
		ld a,6						;6 digits score
		ld bc,#C319					;scraddr
		call txt_big_write_set_len	;(hl already = __game_score_ascii)
		ld a,SFX_BEEP
		ld (_sfx_to_play),a
		ld hl,_points_to_add
		dec (hl)
		jr nz,scoreanim
	jp input_press_key

score_add_to_total:					;...and display on screen
;a=points, b=multiplicator, de=scraddr
	ld c,a
	xor a
		add c						;multiply with b
		daa
		djnz $-2
	score_add_to_total_no_mult:
	push de
	push af
	or a							;if a=0
	jr z,score_points_after_conv	;skip conversion
	ld hl,_points_to_add
	score_countdown_a_in_bcd:		;dumbest way to convert bin to bcd
		inc (hl)
		sub 1
		jr z,score_points_after_conv
		daa
		jr score_countdown_a_in_bcd
	score_points_after_conv:
	call wait_one_second
	ld a,SFX_DING
	ld (_sfx_to_play),a
	pop af
	call convert_bcdtoascii			;returns character codes in C & B
	ld hl,_decimal_pair_ascii+1
	ld (hl),b
	dec hl
	ld (hl),c
	pop de
	jp txt_write_string 			;hl=_decimal_pair_ascii



;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                          SETUP AND INITIALIZATION
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

;####################
;# INITIAL SETTINGS #
;####################

init_start_program:
	ld sp,#C000						;stack was dislocated by loader, move back

	;set screen size to 32*25 (256*200px)
	ld hl,__screen_dimension
	ld bc,#bd04
		init_set_screensize_lp:
		outi:ld b,#be
		outi
		dec c:jr nz,init_set_screensize_lp

	call clear_gamefield			;clear screen

	;build table with andmasks for transparency
	ld hl,AND_MASK_TABLE
	init_andmasks_lp:
		ld (hl),l					;use lowbyte of address as counter and index
		rrd:or (hl):xor h
		ld (hl),a:rld
		inc l
		jr nz,init_andmasks_lp

	;complete the symmetric images of time machine and "Larcena" juez
	ld hl,__Half_TimeMachine
	ld de,__machine_bitmap
	ld ixl,TIMEMACHINE_HGHT
	call mirror_machine
	ld de,__juez_bitmap				;hl already @ __Half_Juez
	ld ixl,JUEZ_HGHT
	call mirror_machine

	;draw mode 0 header graphics to top of screen
	ld de,#c000						;screen dest
	ld hl,Game_Header				;source
	ld b,31							;height
	init_draw_game_header_lp:
		push bc
		push de
		ld bc,64
		ldir
		pop de
		call calc_nextscanline_de
		pop bc
		djnz init_draw_game_header_lp

	;install interrupt handler
	di
	init_wait_vsy:
		ld b,#F5
		in a,(c)
		rra
		jr nc,init_wait_vsy
	djnz $							;wait a moment for ideal CRT beam position
	ld a,OPCODE_JP
	ld (#0038),a
	ld hl,interrupt_handler
	ld (#0039),hl					;save jp address
	ei

	;initialize sound effects
	ld hl,DD_SFX_SOUNDEFFECTS
	call PLY_AKM_INITSOUNDEFFECTS

	jp menu_main

;#################
;# MISSION SETUP #
;#################

setup_mission_w_dialogue:
	xor a							;jr 0 -> show the dialogue
	jr $+4							;(but skip loading the other value)
setup_mission_direct:
;setup all the texts, backgrounds and colors for the current mission.
;input		mission number in _curr_mission
	ld a,no_dialogue			;jr value to skip the dialogue
	ld (_show_dialogue_toggle),a	;SMC it after the jr opcode

_curr_mission equ $+1				;value of current mission-1
	ld a,FOOBAR						;0-6 for Z80 = 1-7 for player

	add "4"+EOL						;convert to ascii
	ld (txadr_mission),a			;and write for level info screen
	sub "4"+EOL+4
	ld b,a							;b=mission-4 (for comparision with djnz)

	;setup special conditions and code for missions 6 & 7
	;MISSION 6:
	xor a							;default no flip wiz/bot control
	ld c,OPCODE_JRNZ				;default jr nz for symmetric mvt
	ld hl,avatar_looses_life		;default 1 life less if enemy contact
	djnz setup_mission_6_opcodes	;skip if not 5
		ld a,#10					;xor #10 -> flip fire
		ld c,OPCODE_JRZ
		ld hl,avatar_dies			;instant death by guillotine
	setup_mission_6_opcodes:
	ld (_flip_fire_SMC),a
	ld a,c:ld (_sym_mvt_mission6),a
	ld (_subroutine_if_enemy_hit),hl

	;MISSION 7:
	djnz setup_mission_not_7
		;movement changes for mission 7:
		;opcode for perpetual motion & not falling (set AV_FALLING_BIT,d):
		ld bc,OPCODE_BIT0A*#100+OPCODE_SET4D
		;for the opcodes for bouncing off borders, we use the fact that
		;the bytes after cb prefix are sequential in #8 increments.
		ld a,OPCODE_RES6D			;"res AV_BLOCKED_TOP,d"
		ld de,#0800+OPCODE_RET		;"res" byte increment & ladder invisible
		;(the ladder is the standard bg tile in mission 7, but ivisibly)
		jr setup_mission_7_opcodes
	setup_mission_not_7:			;standard opcodes for other levels:
	ld bc,#E200						;no perpetual motion, but fall
	ld e,c							;ladder visible
	ld a,OPCODE_BIT0A				;set bounce opcode to OPCODE_BIT0A (bit 0,a)
	ld d,c							;bounce opcodes increment=0 -> stays bit 0,a
	setup_mission_7_opcodes:
	ld hl,draw_tile_ladder			;SMC if ladder is drawn
	ld (hl),e
	ld hl,_mission_7_movement		;SMC if falling happens
	ld (hl),c
	ld hl,_avatar_floats_miss7		;SMC for perpeutal motion
	ld (hl),b
	;opcodes for bouncing off in space:
	ld (_avatar_bnc_up_miss7+3),a 	;(#cb,)#b2 = res AV_BLOCKED_TOP,d
	add a,d:add a,d
	ld (_avatar_bnc_up_miss7+1),a	;#c2 = set AV_MOVE_UP_BIT,d
	add a,d
	ld (_avatar_bnc_down_miss7+1),a ;#ca = set AV_MOVE_DOWN_BIT,d
	add a,d
	ld (_avatar_bnc_left_miss7+1),a ;#d2 = set AV_MOVE_LEFT_BIT,d
	add a,d
	ld (_avatar_bnc_right_miss7+1),a;#da = set AV_MOVE_RIGHT_BIT,D

	;read mission info table address from lut
	ld a,(_curr_mission)
	ld hl,__lut_missions
	call load_HL_from_HLplus2a

	;setup mission texts (year, location, items)
	ld de,__txt_leveltexts_lookup
	ld b,4
		setup_mission_texts_lp:
		;load address of current string to lut with shortcut addresses
		ex de,hl
		ld (hl),e:inc hl			;load current address to shortcut lut
		ld (hl),d:inc hl			;and advance to next position in lut
		ex de,hl
		call txt_skip_string		;-> hl points to next string
		djnz setup_mission_texts_lp

	push hl
_show_dialogue_toggle equ $+1
	jr $+FOOBAR						;0=show, no_dialogue=don't show
		setup_mission_dialogue:
		push hl
		call draw_mission_bg
		call screen_save_backup		;display_dialogue works needs that
		pop hl						;hl=dialogue data
		call csc_display_dialogue
		call csc_mission_end_animation	;time machine appears etc.
	no_dialogue equ $-setup_mission_dialogue;jump here if dialogue is skipped

	call screen_set_black			;make black


	pop hl							;restore address of dialogue data
	ld a,EOT						;skip until EOT byte
	ld b,a							;(dummy value to have enough cpir steps)
	cpir							;-> hl=after dialogue

	ld a,(hl)						;default bg tile
	ld (_mission_default_tile),a	;(placed instead of dead enemies)

	inc hl							;next in data table -> misson graphics
	ld de,__curr_mission_tiles
	ld bc,#100:ldir					;copy object tiles
	ld de,__enemyR2
	ld c,#C0:ldir					;copy enemy sprites
	ld de,__curr_bg_map
	ld c,160:ldir					;copy background picture tilemap

	ld a,(hl)						;info byte about enemy sprites animation
	push af							;save for later

	inc hl							;-> mission colors
	ld a,(__text_monitor)			;check monitor setting
	cp "C"
	jr z,setup_mission_colors		;color monitor
		ld hl,__colors_header_mono	;if not color monitor
	setup_mission_colors:
	ld de,__curr_mission_colors
	push de
	ld bc,4:ldir					;copy 4 colors
	pop de
	call screen_copy_bg_color		;copy bg color to __curr_bg_color

	pop af							;setup enemy sprites
	;__enemyR2-R0 are mirrored to __enemyL0-L2, by default horizontally
	;if bit 7 is set, also vertically (for snakes in level 4)
	;bits 0-3 of a are the amount of frames (usually 10:
	;R2 R1 R0 L0 L1 L2 L1 L0 R0 R1)
	add a							;load double mirror flag to c
	;default values for vertical mirroring (R0->L0, R1->L1, R2->L2)
	ld hl,__enemyR0					;start with R0
	ld ix,#0400						;ixh=4 - read pixel lines from top to bottom
									;ixl=0 - end of tile if l ^ #3F = 0
	ld iyh,-#80						;offset for next enemy tile (R1, then R2)
	jr nc,setup_mission_do_mirror
		;if bit 7 is set, load values for double mirror
		ld hl,__enemyR1-4			;start with last line of R0
		ld ix,#FC3C					;ixh=-4 - lines from bottom to top
									;iyh=#3C end of tile if l ^ #3F = #3C
		ld iyh,#80					;offset = +#80
	setup_mission_do_mirror:
	srl a							;restore frame amount (without bit 7)
	ld (_anim_amount_enemy_frames),a;and save it

	ld de,__enemies_mirrored		;destination
	ld b,3*16						;mirror 3 sprites à 16 lines total
		setup_mission_mir_ene_lines:
		push bc
		ld b,4						;set length for mirror function
		ld a,b:add l:ld l,a			;advance hl to rightmost byte
		call mirror_pixel_line
		ld a,l:add ixh:ld l,a		;default +4 (next line), double mirror -4
		and #3F:cp ixl				;check if last line
		jr nz,$+6
			ld a,l:add iyh:ld l,a	;if so, go to next sprite
		pop bc
		djnz setup_mission_mir_ene_lines

		ld a,(_curr_mission)			;setup mission tune
		call sound_select_tune
ret								;mission setup finished

;###############
;# LEVEL SETUP #
;###############

setup_level:
	call avatar_status_set_default	;reset avatar stats
	xor a							;reset game status
	ld (_status_game),a
	ld (_score_enemies_killed),a
	ld (_counter_item_switch),a
	ld hl,__anim_sparkle_table
	setup_level_reset_sparkles:		;reset sparkles
		ld (hl),a
		inc l
		jr nz,setup_level_reset_sparkles
	call item_delete_all			;clear item table

	call get_randombyte				;randomize first item
	rra								;use bit 0 to decide if
	ld b,wizitems_hi				;wiz item
	jr c,$+3						;or
		inc b						;bot item
	;use rest of random number for length of 1st streak
	and 1:inc a						;1 or 2
	ld (_counter_item_streak),a		;length of first streak
	ld a,b
	ld (_curr_item_streak),a		;for which avatar is the streak

_curr_level equ $+1					;start processing the actual level
	ld a,FOOBAR						;0-6 (for user -> 1-7)
	ld c,a							;backup for later
	add "4"+EOL						;convert to ascii
	ld (txadr_level),a				;save text

	;calculate level address in lookup table - LEVELS_PER_MISSION is hardcoded
	;address = (mission * 7 + level) * 2
	ld hl,_curr_mission
	ld a,(hl)
	Calc_Ax8:sub (hl)				;*7
	add c							;+level
	ld hl,__levels_lookuptable
	call load_HL_from_HLplus2a		;load level address from lut
	push hl
	ld a,h:ld h,l:ld l,a			;swap hi/lo for passcode calculation
	call convert_bintodec			;store passcode
	pop hl							;hl points to the current level data
									;first data are the starting coords
	ld de,__stats_wiz+AV_Y_COORD
	call calc_avatar_coords_by_tile	;calculate starting coord wiz
	ld e,BOT_LOWBYTE+AV_Y_COORD
	call calc_avatar_coords_by_tile	;calculate starting coord bot

	ld a,(hl)						;next are variety, switch & items goal
	ld b,OPCODE_RESCARRY			;default only this mission's items
	rlca:jr nc,$+4					;check variety bit
		ld b,OPCODE_SETCARRY 		;all items
	rlca:rlca						;get the 2 switch bits to the right & backup
	and %11:ld (_speed_item_switch),a	;if 0, never happens, else val=seconds
	ld a,b:ld (_item_variety),a		;write SMC opcode for variety
	ld a,(hl):and %11111			;5 right bits are items goal (0-19 in bcd)
	ld (_items_goal),a
	call convert_bcdtoascii			;prepare the text for shortcut
	set 7,b							;set end byte ->
	ld (txadr_itemsgoal),bc			;save shortcut

	inc hl							;next is game speed
	ld a,(hl):and #F0				;isolate high nibble = delay new items
	rrca:rrca						;=delay*4 is what we actually use
	ld (_delay_new_items),a
	ld (_counter_delay_new_item),a

	ld a,input_close_read-_symmetric_mvt_toggle-1
	bit 3,(hl)						;check symmetric mvt bit
	jr z,$+3:xor a					;don't skip jump if set
	ld (_symmetric_mvt_toggle),a

	ld a,(hl):and #07				;isolate low nibble = level speed
	ld (_level_speed),a
	ld (_clock_item),a



	inc hl							;next is probability for 1up and bomb
	;these values are stord *16 in code and will be compared with random byte
	ld a,(hl):and #F0				;high nibble = probability 1up
	ld (_probability_1UP),a			;is already *16
	ld a,(hl):and #0F				;low nibble = probability bomb
	Calc_Ax8:add a					;*16
	ld (_probability_BOMB),a



	;next are origin sectors for items. create a list of allowed origins
	inc hl:ld a,1					;first direction = 1
	ld de,__items_allowed_origins+1	;first byte of the list will be the amount
	push de							;of origins, save address for later
	ld c,20							;in the middle of the 3rd byte, we change...
	setup_level_make_origin_table:	;...direction, c is the countdown (8*3-4)
		ld b,8						;8 bits per byte
			setup_level_check_regions_lp:
			rlc (hl)				;bit set -> this origin is allowed
			jr nc,$+4				;if so
				ld (de),a			;save it to the table
				inc e
			add #10					;next origin (of this direction)
			dec c					;check if change to 4th direction
			jr nz,$+4
				ld a,#4				;set direction nibble to 4
			djnz setup_level_check_regions_lp
		inc hl
		add #81						;next direction (hi nibble 0, lo nibble inc)
		bit 7,c						;if c is negative, we are done
		jr z,setup_level_make_origin_table
	ld a,e							;calc length of table
	pop de							;reload list+1
	sub e							;a-e = amount of allowed origins
	dec e							;go to begin of list
	ld (de),a						;save amount

	ld a,(hl)						;next byte is level timer
	ld (_timer_game),a
	call convert_bcdtoascii
	ld (txadr_timerastext),bc
	ld a,50							;reset clock to full second (50 frames)
	ld (_clock_game_timer),a

	inc hl							;next is the level title (string)
	ld (txadr_level_title),hl
	call txt_skip_string			;go to address after level message

	;hl now points to the compressed level map, it's formatted like this:
	;tile number (1-6) is stored in the bits 0-2 of the nibbles from left to right
	;0=AIR, 1=SEA, 2=PLATFORM, 3=LADDER 4=OBSTACLE 5=ENEMY (so, except for AIR
	;tile nuber+2=significant bit of the value in the level map)
	;f.i. #23,#03 means PLATFORM,LADDER,AIR,LADDER
	;if bit 3 is set, this tile is repeated [next nibble+2] times
	;f.i. #8F,#38,#24 means 18xAIR,1xLADDER,4xAIR,1xPLATFORM
	ld ix,__curr_level_map			;prepare destination to decompress to
	ld de,160*#100+%01010101		;d=level size
									;e=toggle left/right nibble, start with left
	setup_level_decompress_lp:
	call setup_level_get_nibble
	ld c,a							;backup nibble
	and %0111						;isolate tile number
	jr z,setup_level_after_shift	;if a=0, it stays TILE_AIR, skip conversion
	ld b,a							;counter
	ld a,#04						;1 shift before TILE_SEA (#08)
		setup_level_decomp_shift:
		add a						;shift bit left until we reach the value
		djnz setup_level_decomp_shift
	setup_level_after_shift:
	ld b,1							;default = single = 1 repetition
	bit 3,c							;check if repeat bit is set
	jr z,setup_level_tile_rep_lp
	ld c,a							;if rep -> backup tile value
	call setup_level_get_nibble
	add 2:ld b,a					;get counter (0 -> 2 etc.)
	ld a,c							;restore tile
	setup_level_tile_rep_lp:		;b as counter
		cp TILE_ENEMY-1				;if enemy, get random sprite (frame)
		jr c,setup_level_store_tile_to_map
			ld a,(_anim_amount_enemy_frames)
			dec a					;because how get_random_in_range works
			call get_random_in_range
			add TILE_ENEMY
		setup_level_store_tile_to_map:
		ld (ix),a:inc ix
		dec d						;check if all tiles of map done (we do it
									;here in case compressed map is faulty)
ret z								;if through, level setup is finished
		djnz setup_level_tile_rep_lp;next repetition
	jr setup_level_decompress_lp	;next tile

setup_level_get_nibble:
;input 	hl=pointer to current byte in compressed map (is modified)
;output a contains nibble on right side
;all other registerss preserved
	ld a,(hl)						;get whole byte
	inc hl							;point to next byte
	rlc e							;get left/right toggle
	jr c,setup_level_isolate_nibble	;if left nibble ->
		dec hl						;1. undo pointer incremet (stay @ same byte)
		rrca:rrca:rrca:rrca			;2. shift right 4 bits
	setup_level_isolate_nibble:
	and #0F							;isolate right nibble
ret

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                                SCORE & INFO PAGES
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



display_textpage:
	ld e,b
	call txt_set_pen_2
	ld b,e
display_textpage_lp:
;hl=address of textpage, b=amount of text lines
	push bc
	textpage_readaddress:
	ld a,(hl)
	inc hl
	cp #FF							;#ff means swap pen
	jr nz,txt_after_pen_swap
		call txt_swap_pen
		jr textpage_readaddress		;read next byte
	txt_after_pen_swap:
	ld e,a							;a was lowbyte
	ld d,(hl)						;de=scraddr for text line
_textpage_pos_inc_d:
	nop								;is modified to "inc d" for score summary
	inc hl
	call txt_write_string			;write text line
	pop bc
	djnz display_textpage_lp			;count down lines
ret


display_level_info:
	call clear_gamefield
	ld b,12							;default 12 lines to display
	ld a,(_item_variety)			;check if level with all items
	rla								;if so, cf = 0
	jr c,$+3
		inc b						;display one more line ("& previous items")
	call screen_set_info			;set screen to info mode
	ld hl,__textpage_level
	call display_textpage
	call wait_frameflyback			;else di will make distortions
	ld a,(_curr_mission)			;draw item sprites...
	call calc_item_sprite_lowbyte
	ld h,wizitems_hi:ld l,a			;(hl=addr of wiz item sprite)
	push hl
	ld de,SCRBASE_GAME+#130C		;...next to the label
	di								;(routine uses stack misuse)
	call draw_item
	pop hl:inc h					;hl -> bot item sprite
	ld de,SCRBASE_GAME+#334C
	call draw_item
	ei
	call check_game_mode
	jr nz,level_info_waitkey		;if play mode, done
	call txt_swap_pen				;if challenge mode
	ld de,SCRBASE_STATUS+#10
	call txt_write_this_string
		db "Sc",14,34+EOL		;"Score_"
	ld hl,__game_score_ascii
	call txt_write_string
	call txt_write_this_string
		db "C",44,"d",29,35+EOL		;"Credits_"
	ld hl,_game_credits
	call txt_write_string
	level_info_waitkey:
	call input_press_key
	ld a,(_user_input)
	ld hl,__keyboard_keymap+11		;bitmask of abort key
	cp (hl):ret nz					;compare bitmask
	ld a,(scanned_keyline)
	dec hl:cp (hl)					;compare keyline
	ret nz
	pop hl							;if abort key pressed ->
	jp menu_main

display_score_game_summary:
	call clear_gamefield
	ld c,2							;bubble height (in lines)
	ld hl,#E147						;scraddr
	call draw_bubble_wiz			;Wiz color bubble for...
	ld bc,#C195
_score_summary_text equ $+1
	ld hl,__bigtxt_gameover
	call txt_big_write_set_addr		;..."GAME OVER"
	ld c,2
	ld hl,#E407
	call draw_bubble_bot			;bot color bubble for...
	ld bc,#C450
	ld hl,__bigtxt_score			;...Score
	call txt_big_write_set_addr
	call screen_set_info
	ld hl,_textpage_pos_inc_d		;modify code to inc hibyte of scraddr
	push hl							;so that the level info is 4 lines
	ld (hl),OPCODE_INC_D			;below (between the bubbles)
	ld hl,__textpage_level
	ld b,6							;display only the first 6 lines
	call display_textpage
	pop hl
	ld (hl),OPCODE_NOP				;reset display_textpage routine to normal
	call input_press_key
_score_summary_jump equ $+1
	jp menu_main


;##############
;# STATUS BAR #
;##############

draw_statusline:
	ld b,1
	call txt_set_pen				;green
	ld hl,__stats_wiz+AV_LIVES		;start with wiz's status
	ld a,(hl) 						;lives
	inc a
	call draw_status_avatar

	ld a,(_timer_game)				;draw timer:
	call convert_bcdtoascii
	ld (txadr_timerastext),bc
		ld a,c						;for "time low" effect
		cp ASCII0					;if left digit = 0
		call z,txt_swap_pen			;change to magenta pen
	ld e,#1C						;advance scraddr to middle of statusbar
	call txt_write_this_string
		db 13,"me["					;"time"
		db SHC_timertext+EOL		;timer
	call txt_set_pen_2				;change to magenta (if not already)

	;draw the bot's status
	ld hl,__stats_bot+AV_LIVES		;get bot lives
	ld a,4
	sub (hl)						;reverse bot lives (mirrored display)
	;fall through

draw_status_avatar:
;a=amount lives + 1 (if bot -> reversed)
;hl=stats table of curr avatar + AV_LIVES
	;draw life symbols
	ld iyh,a						;counter for live symbols
	inc l
	ld e,(hl)						;scraddr low for 1st live symbol
	inc l
	ld a,(hl)						;lowbyte sprite address of 1st symbol
	inc l							;	(life for wiz, dead for bot)
	push hl
	ld h,(hl)						;hibyte sprite address
	ld l,a
	ld bc,DEFAULT_LIVES*#100+#FF	;b=counter for all symbols
									;c=to save b from being decremented in ldis
	draw_status_avatar_symbol:		;hl=spriteadr
		ld d,SCRBASE_STATUS/#100	;go to first pixel line of status bar
		dec iyh
		jr nz,$+3					;if through all "lives"
			inc h 					;change to other symbol (one page apart)
		push hl						;	(dead for wiz, life for bot)
		draw_status_avatar_line:
			ldi:ldi					;copy two bytes
			dec e:dec e				;go back two bytes
			Addbytetoreg 8,d		;and one line down
			cp SCRBASE_STATUS/#100+#38	;check if last line
			jr nz,draw_status_avatar_line
		inc e:inc e					;advance to next symbol position
		pop hl
		djnz draw_status_avatar_symbol

	;draw amount items
	pop hl							;restore avatars stats table
	inc l
	ld a,(hl)						;items caught
	call convert_bcdtoascii
	set 7,b
	ld (txadr_items_status),bc
	inc l
	ld e,(hl)						;lowbyte scraddr for item display
	ld d,SCRBASE_STATUS/#100
	call txt_write_this_string
		db SHC_itemsstatus,92,SHC_itemsgoal+EOL
ret



;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                    CALCULATIONS, CONVERSIONS & UTILITIES
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


;########################
;# GRAPHIC CALCULATIONS #
;########################

calc_avatar_coords_by_tile:
;only used by level setup. calculates the starting position
;of the avatars in every level.
;	input:
;de=__status_table of concerned avatar + AV_Y_COORD
;(hl)=tile index (high nibble=y, low nibble=x - in tiles!)
;	returns:
;x & y coords in avatar status table
;a=x coord, de=de+1, hl=hl+2
;all othes preserved
	ld a,(hl)						;get coord byte
	and #F0							;hi nibble = y
	rrca							;/2 = y*8
	sub 4							;align bottom of avatar sprite to tile
	ld (de),a						;save y to status table
	ld a,(hl)						;get coord byte again
	and #0F							;x
	Calc_Ax8						;x*8
	inc e							;advance to x pos
	ld (de),a						;and save x
	inc hl							;advance to next pos in level data table
ret

calc_tile_by_coords:
;calculates the index of tile @ given x y coord. used by the collision control
;	input:
;b=x,c=y of left top corner of requested tile
;	returns:
;a=tile index, hl=tile address in level map
;all othes preserved
	ld l,b
	srl l:srl l:srl l				;l=x/8
	ld a,c
	and #F8							;int(y/8)
	add a							;*2 (16 x tiles make one y tile)
	add l							;add x=low nibble
	ld l,a
	ld h,__curr_level_map/#100
ret

calc_scraddr_by_tile:
;calculate the screen address of a given tile by index
;	input:
;l=tile index (#YX) - destroyed
;	output:
;de=scraddr, a & hl destroyed, all othes preserved
	ld a,l							;get index
	and #0F							;isolate tile-x
	add a:add a						;*4
	ld e,a							;offset for screen adr
	ld a,l							;restore index
	and #F0							;isolate y (*#10)
	sbc hl,hl						;h=0
	ld l,a
	add hl,hl:add hl,hl:add hl,hl	;*8 = y*#80 (=2 charlines)
_calc_scraddr_set_base equ $+1		;SMC
	ld d,SCRBASE_GAME/#100			;offset (#81 or #c1)
	add hl,de
	ex de,hl
ret

calc_scraddr_by_coords_M:
;calculates the screen address of an avatars current coordinates
;	input:
;hl=avatar status table (@ pos 0)
;	returns:
;de=scraddr, ab=de, hl=hl+3, all others preserved
	inc l:ld a,(hl)					;read y
	inc l:ld b,(hl)					;read x
	inc l

calc_scraddr_by_coords_BA:
;calculates the screen address of coordinates in B,A
;	input:
;b=x, a=y
;	output:
;de=scraddr, ab=de, all others preserved
	rrca:rrca:rl b:rra:rr b:rra:rr b
	or #c0
	inc a							;+#100 for SCRBASE_GAME (hardcoded!)
	ld d,a:ld e,b
ret

calc_item_sprite_lowbyte:
;calculate the lowbyte of the address of an item sprite by multiplying with 30
;input 		a=mission (= sprite "index")
;returns	a=sprite lowbyte
	ld b,a
	Calc_Ax8
	add a							;*16
	sub b							;*15
	add a							;*30
ret

calc_nextscanline_hl:
;hl=next scanline, a=modified, all others preserved
	bit 6,h							;check if hl is in backup screen
	jr z,calc_nextline_backup_scr	;if so, take other routine
	Addbytetoreg 8,h				;adr+#800
	ret nc							;if not over #ffff, return
	;else fall through

calc_charlinebreak_hl:
;add #c040 to hl for correction of wrong value after eighth pixelline
;input hl, returns new addr in hl, a modified, all others preserved
	Addbytetoreg #40,l
	Adcbytetoreg #C0,h
ret

calc_nextline_backup_scr:
	Addbytetoreg 8,h				;adr+#800
	bit 6,h:ret z					;if over #bfff,
	jr calc_charlinebreak_hl		;correct value

calc_nextscanline_de:
;self explaining
	ex de,hl
	call calc_nextscanline_hl
	ex de,hl
ret


;######################
;# NUMBER CONVERSIONS #
;######################

convert_bcdtoascii:
;input 		a=2 digit bcd number ("CB")
;output 	c,b = char codes (in THIS order)
;all other registers preserved
	ld c,a							;backup
	and #0F							;isolate right digit
	add ASCII0						;add code of char "0"
	ld b,a							;save a
	ld a,c							;restore
	rrca:rrca:rrca:rrca				;isolate left digit
	and #0F							;etc.
	add ASCII0
	ld c,a
ret

convert_score_to_ascii:
;no input
;modifies string in __game_score_ascii
;c, ix & iy preserved
	ld de,_score_bcd+2				;from right to left (least signif. first)
	ld hl,__game_score_ascii+6		;dito
	ld b,3							;3 bcd numbers = 6 decimal digits
		convert_bcd_pair:
		push bc
		ld a,(de)					;get number
		dec de
		call convert_bcdtoascii
		dec hl
		ld (hl),b					;less significant digit first
		dec hl
		ld (hl),c					;then the Other
		pop bc
		djnz convert_bcd_pair
	ret

convert_bintodec:
;input 		hl=16 bit value
;returns 	decimal value is in txadr_passcode
;a & bc destroyed
	ld a,convert_bin_to_dec-convert_digit-2	;set value for jump
	jr convert_number_start

convert_dectobin:
;input 		value in decimaldigit_string
;returns 	hl=16 bit value
;a & bc destroyed
	xor a							;value for jump
	ld l,a							;reset hl
	ld h,a

convert_number_start:
;main routine followed by convert_bintodec and convert_dectobin
;a=jr value for either bin2dec or dec2bin subroutine
	ld de,txadr_passcode
	ld (convert_digit+1),a			;save SMC value for subroutine
	ld	bc,10000
	call convert_digit
	ld	bc,1000
	call convert_digit
	ld	bc,100
	call convert_digit
	ld	c,10 						;b=0 already
	call convert_digit
	ld	c,1 						;b=0 already
	;fall through

convert_digit:
 	jr $+FOOBAR						;either dectobin or bintodec

;convert dec to bin:
	ld a,(de)						;get digit from string
	inc de
	sub ASCII0
ret z								;if 0, don't add this digit to result
	bit 7,a							;EOL sign -> after 5th digit
	ret nz
		add hl,bc					;multiply with current power of 10 (in BC)
		dec a
		jr nz,$-2
ret

convert_bin_to_dec:
	ld a,ASCII0-1					;reset counter
		;divide by current power of 10
		inc	a						;increase result
		or a 						;reset carry
		sbc	hl,bc
		jr nc,$-4
	add hl,bc						;undo last subtraction
	ld (de),a						;wite digit to array
	inc de
ret


;######################
;# DIV GAME UTILITIES #
;######################

tiles_evaluate_vertical:
;check the tiles that cover the width of an avatar sprite (1 or 2),
;starting at the given coordinates, going from left to right.
;this is called twice, for the tiles over avatars head and the ones
;below his feet.
;if avatar touches the edge of an obstacle or enemy (4px),
;shift him so he can pass from below or top.

;input 		b,c (coords)
;returns 	a = all tile(s) or'ed together

	call calc_tile_by_coords 		;get the leftmost tile
	ld a,6
	and b							;calc x % 8, only even
	rra								;/ 2
	ld e,a							;counter for the conditional jumps
	ld a,(hl)						;load first tile
	ret z							;if x % 8=0, it's the only tile
	tiles_eval_x_mod_8_not0:
	inc l
	dec e							;if e was 1 -> x % 8 = 2
	jr nz,tiles_eval_x_mod_8_not2
		bit TILE_OBSTACLE_bit,a
	ret nz							;if main tile is obs, return it
		call tiles_check_shift_side	;main tile is free -> check neighbor
									;if sub returns, shift left,
		bit AV_MOVE_RIGHT_BIT,d		;but only if right is not pressed
	ret nz
		set AV_MOVE_LEFT_BIT,d
	ret

	tiles_eval_x_mod_8_not2:
	dec e							;if e was 2 -> x % 8 = 4
	jr nz,tiles_eval_x_mod_8_is_6
		or (hl)						;avatar is in the middle of 2 tiles
	ret								;-> just "or" them together

	tiles_eval_x_mod_8_is_6:
		ld a,(hl)					;do the same thing as in x % 8 = 2,
		bit TILE_OBSTACLE_bit,a 	;but mirrored
	ret nz
		dec l
		call tiles_check_shift_side
		bit AV_MOVE_LEFT_BIT,d
	ret nz
		set AV_MOVE_RIGHT_BIT,d
	ret

	tiles_check_shift_side:			;check if neighbor tile is
		bit TILE_OBSTACLE_BIT,(hl)	;obstacle or
	ret nz
		bit TILE_ENEMY_BIT,(hl)		;enemy
	ret nz
		pop hl						;else remove return address
	ret								;and return the main tile

tiles_check_obs_side:
	ld iyl,TILE_OBSTACLE
	;fall through

tiles_check_side:
;search for tile iyl from b,c down the whole avatar height
;(that's 2 or 3 tiles)

;input 		b,c = coords, iyl = tile type
;returns	if found, z is reset and hl points to the found tile

	call calc_tile_by_coords 		;get address of top tile
	ld e,2							;default search 2 tiles
	ld a,7:and c:cp 5				;if y % 8 > 5
	jr c,$+3
		inc e						;search 3 tiles
	tiles_side_lp:
		ld a,iyl					;and instead of cp, because enemies
		and (hl)					;have some additional bits set
	ret nz							;return nz if found
		Addbytetoreg #10,l			;move down one row
		dec e
		jr nz,tiles_side_lp
	ret								;z set -> tile not found



load_HL_from_HLplus2a:
;input		hl=base address, a=index
;returns	l=(hl+2a), h=(hl+2a+1)
	add a							;a*2
	add l
	ld l,a
	jr nc,$+3
		inc h
	LdHLfromHL
ret

game_check_livesandpoints:
;	input:
;hl = _status_game
	ld de,__stats_wiz+AV_LIVES
	call game_do_check_livesandpoints
	ld e,BOT_LOWBYTE+AV_LIVES
	;and fall through

	game_do_check_livesandpoints:
	ld a,(de):ld b,a				;backup for next check
	dec a
	jp p,$+7						;check <0 too, in case multiple hits at once
		xor a:ld (de),a
		set STBIT_GAME_OVER,(hl)
	ld a,DEFAULT_LIVES:cp b			;check if over maximum lives (by 1up)
ret nc
	ld (de),a						;if so, cut down to max lives
ret

set_update_score_bit:
;set the bit to inform the main loop that something happened with items or lives
;all registers preserved
	push hl
	ld hl,_status_game
	set STBIT_UPDATE_SCORE,(hl)
	pop hl
ret

avatar_status_set_default:
	ld hl,__avatar_status_default
	ld de,__stats_wiz
	ld bc,#20:ldir
ret

input_key_ret_mode:
;just a shortcut because these two function are often called after each other
	call input_press_key
	;fall through

check_game_mode:
;returns 	a=game mode, z is set if challenge
_curr_game_mode equ $+1
	ld a,FOOBAR						;SMC, is written by main menu
	or a
ret

game_clocks_process:
;process the different clocks and counters
;a and hl are modified
	ld hl,_clock_game_timer
	dec (hl)						;once per frame, 50x = 1 second
	jr nz,no_timer_action
	;else decrease timer
	ld (hl),50 						;reset clock to 50 (=interrupts/second)

_counter_item_switch equ $+1
	ld a,FOOBAR
	inc a
_speed_item_switch equ $+1
	cp 1 ;FOOBAR
	call z,item_switch_all
	ld (_counter_item_switch),a



_timer_game equ $+1
	ld a,FOOBAR						;this value is in BCD and modified via SMC
	sub 1:daa						;dec a doesn't work with daa
	ld (_timer_game),a				;save decreased value
	ld hl,_status_game
	set STBIT_UPDATE_SCORE,(hl)		;update status bar & display new time
	cp #99:jr nz,no_timer_action
		set STBIT_TIME_OUT,(hl)		;if time is zero
	no_timer_action:
	ld hl,_clock_item				;counter for new items
	dec (hl)
ret p								;if < 0
_level_speed equ $+1
	ld (hl),FOOBAR					;reset items clock to default level speed
ret

;##########
;# DELAYS #
;##########

wait_one_second:
	ld b,150

wait_bx2_halts:
	halt:halt:djnz $-2
ret

wait_frameflyback:
	ld a,1
	;fall through

wait_for_interrupt:
	;input A
	ld (_interrupt_to_wait_for),a
	wait_until_interrupt:
		halt
		ld a,(_curr_interrupt)
	_interrupt_to_wait_for equ $+1
		cp FOOBAR
		jr nz,wait_until_interrupt
ret

;##################
;# RANDOM NUMBERS #
;##################

get_randombyte:						;routine by Grim in 64NOPs
;no input, returns "random" byte in a, c is modified
    ld a,51 						;Seed
    add a
    jr nc,$+4
    	xor %00011101
	ld (get_randombyte+1),a
    ld c,a:ld a,r:add c				;crapification
ret

get_random_in_range:
;get random number in a range by 16-bit multiplying max with random bit
;input a=maximum (range=[0..a]), returns a=value, c is modified
	push hl
	push de
	ld h,a
	inc h							;maximum is included
	call get_randombyte
	ld e,a
	;multiply random with max
	ld d,0							;de=random #00-#ff
	ld l,d							;hl=multiplyer (range)
	ld c,8
	get_random_mult_lp:				;simple multiplication
		add hl,hl
		jr nc,$+3
			add hl,de
			dec c
		jr nz,get_random_mult_lp
	ld a,h							;get hibyte of result
	pop de
	pop hl
ret



;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                               PROCESSING AVATARS
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

avatar_process_movement:
;all movements are in two parts (usually 2px+2px). wiz and bot are processed
;alternating, one is always starting a movement, the other continuing.
;If input (fire or not) matches with starting avatar, he can initiate a movement
;the "continuing" avatar only finishes the movement initiated before. This
;saves some ressources, especially in the last missionm, where both keep moving
;all the time.

;numerical representation of avatars is the address of their statustable
;and mostly only the lowbyte - WIZ=#00, BOT=#10

	ld a,(_clock_flash)
	or a							;if bomb flash is active,
ret nz								;avatars freeze

	ld hl,_avatar_starting			;firstly, we are switching the roles:
	ld a,(hl)						;the avatar who was starting the last time
	ld (_avatar_continuing),a		;is now continuing the movement
	xor BOT_LOWBYTE:ld (hl),a		;and vice versa
_avatar_continuing equ $+2
	ld ix,__stats_wiz
	ld b,1							;we'll need this for the sprites later
	call avatar_apply_movement		;first, process the continuing avatar
_avatar_starting equ $+2			;and now the starting one:
	ld ixl,BOT_LOWBYTE
_user_input equ $+1					;process input - bit 5-0 in a:
	ld a,FOOBAR						;abort, fire, right, left, down, up
_flip_fire_SMC equ $+1				;default is 0, but in mission 5:
		xor 0						;xor %10000 - flip "fire" bit
	bit 5,a							;abort key
	jr z,avatar_not_abort
		ld hl,_status_game			;if abort key pressed
		set STBIT_ABORT_GAME,(hl)
		ret
avatar_not_abort:
	ld d,a							;d = "direction" register
	and %1111						;if none of the directions are active
	jr z,avatar_no_input

	;does input match active avatar?
	ld a,ixl						;fire=bit 4 - bit 4 also signifies bot (#10)
	xor d							;if bit 4 matches, it will be reset
	bit 4,a
	jr nz,avatar_no_input			;if it's not reset, input not valid

	;there is valid input for current avatar:
	ld d,a							;we only need the 4 movement bits
	ld a,ixl						;when moving, th active avatar...
	ld (_foreground_avatar),a		;	...goes to the foreground
	jr avatar_start_collision_check

avatar_no_input:					;doesn't mean that there is no movement!
	ld d,0							;but the input direction byte is 0
_mission_7_movement equ $+1
		db #DD,#CB,AV_STATUS,#A2	;this opcode doesn't mean anything, (4 NOPS)
		;but in mission 7, #00 is replaced by #cb -> "res 4,(ix+AV_STATUS),d"
		;whereby the last movement direction is repeated (foating)
	ld (ix+AV_SPRITETYPE),d			;update sprite type
	;fall through

avatar_start_collision_check:
	ld b,(ix+AV_X_COORD)			;for faster processing, x and y
	ld c,(ix+AV_Y_COORD)			;are going to registers
	;check if collision with enemy
	ld iyl,TILE_ENEMY				;iyl is the tile to check for
	call tiles_check_side			;check left side
	jr nz,avatar_enemy_collision
	Addbytetoreg AVATAR_WDTH-1,b	;move b to other side
	call tiles_check_side			;check right side
	ld b,(ix+AV_X_COORD)			;restore b
	jr z,avatar_check_movement
	;else fall through

avatar_enemy_collision:
;input hl=address of enemy in level map
	ld (_anim_dying_enemy),hl		;save address for shading animation
_subroutine_if_enemy_hit equ $+1	;default avatar_looses_life, in mission 6:
	call avatar_looses_life			;avatar_dies (instant death by guillotine)
	ld hl,_status_game
	set STBIT_ENEMY_DEAD,(hl)		;inform main loop about dead enemy

avatar_check_movement:
;check if the intended movement of avatar can be executed in relation to
;the tiles (ladder, obstacle etc.) around him and if any tiles (air f.i.)
;provoque additional movement (falling)
;we only check this @ starting movement. A full movement (starting+continuing)
;is 2 units, so we process in a grid of 2 units = 4px

;This whole thing is horrible and unreadable - but it works.

;	input
;b=x, c=y coords of avatar, d=intended movement (will be modified)

	ld a,%1100						;check if R/L is pressed simultaneously
	and d							;(bit 3 & 2)
	cp %1100
	jr nz,check_behind_feet
	xor d							;if so, reset both bits
	ld d,a

;1. check tile "behind feet"
	check_behind_feet:
	Addbytetoreg AVATAR_HGHT-1,c
	call tiles_evaluate_vertical
	ld c,(ix+AV_Y_COORD)			;restore y
	bit TILE_LADDER_bit,a			;if it's ladder
	jr nz,avatar_check_move_up		;go on with movement check
	bit TILE_PLATFORM_bit,a			;if platform
	jr z,$+5						;	-> load "standard" empty tile
		ld a,(_mission_default_tile);	(air or water)
	bit TILE_SEA_bit,a				;if in water
	jr z,$+6
		set AV_UNDERWATER_BIT,d		;set underwater bit
		jr avatar_check_move_up		;and go on with movement check
	res AV_MOVE_UP_BIT,d			;in all other cases, movin up is not valid

;2. check movement up
	avatar_check_move_up:
	bit AV_MOVE_UP_BIT,d			;is movement up intended?
	jr z,avatar_check_move_down		;no -> check down
	dec c							;check ABOVE head if possible
	call tiles_evaluate_vertical
	inc c							;restore y coord and check if 0
	jr z,$+6						;if so (border above head), skip
		bit TILE_OBSTACLE_bit,a		;if no obstacle
		jr z,avatar_check_horiztl	;go on with horizontal check
	set AV_BLOCKED_TOP,d			;else blocked is set
	res AV_MOVE_UP_BIT,d			;and move up bit is cleared
	;but in mission 7, we bounce off:
	_avatar_bnc_down_miss7:			;this useless opcode is modified in space:
		bit 0,a 					;-> set AV_MOVE_DOWN_BIT,d

;3. check move down and fall
	avatar_check_move_down:
	ld a,c
	add AVATAR_HGHT					;pixel under feet
	cp GAMEFLD_HGHT					;check if below bottom
	jr nc,avatar_tile_below_blocked
	ld c,a							;if ok, apply to y
	call tiles_evaluate_vertical
	ld e,a							;backup result in e
	ld c,(ix+AV_Y_COORD)			;restore old y
	ld a,(_curr_mission)			;check if we are in space
	cp 6							;air there is actually ladders
	jr nz,$+6						;but we have to change one behaviour:
		bit TILE_ENEMY_bit,e		;if we are on the bottom of space tile
		jr nz,avatar_move_down		;we can actually fall on an enemy below
	bit TILE_OBSTACLE_bit,e			;check if obstacle blocks
	jr nz,avatar_tile_below_blocked
	bit TILE_LADDER_bit,e			;on ladder, moving down is possible
	jr nz,avatar_move_down
	bit TILE_PLATFORM_bit,e			;if not platform
	jr z,avatar_dont_move_down		;don't move down
		ld a,7:and c:cp 4			;if platform, check if exactly above, then
		jr z,avatar_move_down		;we can "jump off" (i.e. move 1 unit down)
	jr avatar_dont_move_down		;else don't
	avatar_tile_below_blocked:
	res AV_MOVE_DOWN_BIT,d			;neither move down nor fall
	;but, again, in mission 7, we bounce off:
	_avatar_bnc_up_miss7:			;these useless opcodes are modified in space
		bit 0,a						;-> set AV_MOVE_UP_BIT,d
		bit 0,a						;-> res AV_BLOCKED_TOP,d
	jr avatar_check_horiztl			;and continue with horizontal check
	avatar_move_down:
	bit AV_MOVE_DOWN_BIT,d			;only apply if move down actually pressed
	jr z,avatar_check_horiztl
	inc c:inc c						;if pressed, apply to y & go on with check
	jr avatar_check_horiztl
	avatar_dont_move_down: 			;but can be falling
	res AV_MOVE_DOWN_BIT,d

	;check if fall or float:
	ld a,TILE_LADDER+TILE_OBSTACLE
	and e							;e=still tile(s) below
	jr nz,avatar_check_horiztl		;if either ladder or obstacle dont fall
	bit AV_BLOCKED_TOP,d			;if movement up blocked
	jr nz,avatar_check_horiztl		;dont fall (else wiggles on top of sea)
	_avatar_floats_miss7 equ $+1	;in mission 7 -> "bit 0,a" (void)
	set AV_FALLING_BIT,d			;avatar falls, except in space.
	inc c:inc c
	bit AV_UNDERWATER_BIT,d
	jr nz,avatar_check_horiztl
	res 1,(ix+AV_Y_COORD)			;if not under water, align y to 8px

;4. check left/right
	avatar_check_horiztl:
	bit AV_MOVE_LEFT_BIT,d
	jr z,avatar_check_move_right
	dec b
	jp m,avatar_dont_move_left		;if y-1 < 0 - left border, don't move left
		dec b						;check if left neighbor (y-2)
		call tiles_check_obs_side	;is obstacle
		jr z,avatar_movecheck_done	;if movement possible, finish
	avatar_dont_move_left:
	res AV_MOVE_LEFT_BIT,d			;else reset bit
	;or in mission 7, bounce off:
	_avatar_bnc_right_miss7:		;this useless opcode is modified in space
		bit 0,a						;-> set AV_MOVE_RIGHT_BIT,d
	jr avatar_movecheck_done		;avoid processing the bounce right away

	avatar_check_move_right:
	bit AV_MOVE_RIGHT_BIT,d
	jr z,avatar_movecheck_done
	ld a,GAMEFLD_WDTH-AVATAR_WDTH
	cp b							;check right border
	jr z,avatar_dont_move_right
		Addbytetoreg 8,b			;check right neighbor
		call tiles_check_obs_side
		jr z,avatar_movecheck_done	;if movement possible, finish
	avatar_dont_move_right:
		res AV_MOVE_RIGHT_BIT,d		;else reset bit
	;or in mission 7, bounce off:
	_avatar_bnc_left_miss7:			;this useless opcode is modified in space
		bit 0,a						;-> set AV_MOVE_LEFT_BIT,d

	avatar_movecheck_done:
	ld (ix+AV_STATUS),d				;save modified status byte

	;avoid troubles with border collision and even/odd sprites:
	res 0,(ix+AV_X_COORD)			;set x to even
	bit AV_UNDERWATER_BIT,d			;and, if not underwater
	jr nz,$+5
		res 0,(ix+AV_Y_COORD)		;...y as well
	ld b,0							;reset sprite even/odd offset

	avatar_apply_movement:
	ld a,(ix+AV_STRUCK_ANIM)		;check if life loss animation is on
	or a
	jr z,avatar_check_happy
	dec (ix+AV_STRUCK_ANIM)
	and %100						;every 4 times change front/dead sprite
	rrca							;0->0 or 4->2
	add AVATAR_FRONT				;(AVATAR_FRONT+2=AVATAR_DEAD)
	ld (ix+AV_SPRITETYPE),a
ret

	avatar_check_happy:
	add (ix+AV_HAPPY_ANIM)			;check if caught item or 1up (a was 0)
	jr z,avatar_process_input		;if not, proceed normally
	dec (ix+AV_HAPPY_ANIM)
	ld (ix+AV_SPRITETYPE),AVATAR_HAPPY
ret


avatar_process_input:
	ld d,(ix+AV_STATUS)				;get moving direction
	ld c,AVATAR_CLIMB1				;prepare climbing sprite type 1 or 2
	ld a,(_clock_bg_anim)			;get alternating value
	bit 3,a							;change type every 16 frames
	jr z,$+3						;if bit 3 is set
		inc c						;use AVATAR_CLIMB2
	xor a							;reset a

	bit AV_BLOCKED_TOP,d			;if top blocked
	jr z,avatar_check_mvt_up
		ld a,c						;do climbing anim but dont change y
		jr avatar_check_mvt_down

	avatar_check_mvt_up:
	bit AV_MOVE_UP_BIT,d
	jr z,avatar_check_mvt_down
		ld a,(ix+AV_Y_COORD)
		dec a:jp m,$+6
			ld (ix+AV_Y_COORD),a
	   ld a,c						;load climbing sprite
		bit AV_UNDERWATER_BIT,d
		jr z,avatar_check_mvt_left	;if underwater,
		res AV_MOVE_UP_BIT,(ix+AV_STATUS)	;don't continue moving (half speed)

	avatar_check_mvt_down:
	bit AV_MOVE_DOWN_BIT,d
	jr z,avatar_check_mvt_left
		ld a,(ix+AV_Y_COORD)
		inc a:cp GAMEFLD_HGHT-AVATAR_HGHT+1
		jr nc,$+5
			ld (ix+AV_Y_COORD),a
		ld a,c

	avatar_check_mvt_left:
	bit AV_MOVE_LEFT_BIT,d
	jr z,avatar_check_mvt_right
		ld a,(ix+AV_X_COORD)
		dec a:jp m,$+6
			ld (ix+AV_X_COORD),a
		ld a,AVATAR_LEFT_ODD
		sub b						;use AVATAR_LEFT_EVEN if continuing

	avatar_check_mvt_right:
	bit AV_MOVE_RIGHT_BIT,d
	jr z,avatar_check_save_sprite
		ld a,(ix+AV_X_COORD)
		inc a:cp GAMEFLD_WDTH-AVATAR_WDTH+1
		jr nc,$+5
			ld (ix+AV_X_COORD),a
		ld a,AVATAR_RIGHT_ODD
		sub b						;use AVATAR_RIGHT_EVEN if continuing

	avatar_check_save_sprite:
	or a							;if a was loaded with any number
	jr z,$+5
		ld (ix+AV_SPRITETYPE),a		;write it as new sprite type

	bit AV_FALLING_BIT,d			;check if avatar is falling
	ret z
		inc (ix+AV_Y_COORD)			;default fall is 2 pixels
		bit AV_UNDERWATER_BIT,d
		jr nz,avatar_fall_slowly
			inc (ix+AV_Y_COORD)		;if in air, add another 2 pixels
	ret
		avatar_fall_slowly:
		res AV_FALLING_BIT,(ix+AV_STATUS)	;don't continue fall for half speed
	ret

avatar_dies:
	ld (ix+AV_LIVES),1				;1 last life
	;fall through					;and that's lost, too:

avatar_looses_life:
	dec (ix+AV_LIVES)
	ld (ix+AV_STRUCK_ANIM),ANI_LEN_STRUCK	;initialize animation
	ld a,SFX_SCREAM:ld (_sfx_to_play),a		;play scream effect
	jp set_update_score_bit					;inform main loop


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                               PROCESSING ITEMS
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

item_process_movement:
	ld a,(_clock_flash):or a	;first check if bomb was activated
	jp nz,item_delete_all
	ld hl,__list_items+2			;points to x-coord of 1st item
	item_process_this:
	ld b,(hl):dec l					;read x-coord
	ld c,(hl):dec l					;read y-coord
	ld a,(hl):or a					;check if first byte is a direction
	jr z,item_process_end			;if 0, item is not active

	;collision detection
	ld a,(_foreground_avatar)		;always begin with foreground avatar
	call item_check_collision		;(that's how to win mis. 6 lev. 6)
	;change to bg avatar
	ld a,ixl:xor BOT_LOWBYTE		;change avatar lowbyte
	call item_check_collision
	;if function returns -> no collision -> move on
	ld b,(hl)						;b = direction
	inc l							;hl points to y
	djnz item_check_2				;fancy way of "switch...case"
	;item_move_up:					;direction 1 = up
		dec (hl)					;dec y
		jp m,item_delete_item		;if across top border
		jr item_process_end
	item_check_2:
		djnz item_check_3			;direction 2 = down
		inc (hl)					;inc y
		ld a,GAMEFLD_HGHT-ITEM_HGHT+1
		cp (hl)						;if across bottom border
		jp c,item_delete_item
		jr item_process_end
	item_check_3:
	inc l							;hl points to x
	djnz item_check_4				;direction 3 = left
		dec (hl)					;if across left border
		jp m,item_delete_item
		jr item_shift_sprite
	item_check_4:					;direction 4 = right
		inc (hl)
		ld a,GAMEFLD_WDTH-ITEM_WDTH+2;if across right border
		cp (hl)
		jp z,item_delete_item
	item_shift_sprite:
	inc l:inc l						;hl points to spriteadr high
	ld a,(hl)						;exchange the highbyte for the
	xor SWAP_SPRITES_HORI			;sprites shifted by 2 px
	ld (hl),a						;(orig & shifted are 1 page apart)

item_process_end:
	ld a,l:and #F8					;-> pos 0 of item (from whererever)
	add 8+2							;advance to x-coord of next item
	cp MAX_ITEMS*8+2				;check if end of table
	ld l,a							;if not, load new lowbyte
	jr nz,item_process_this			;and process next item

	ld hl,_counter_delay_new_item	;after processing all items,
	dec (hl)						;check if time to create a new one
ret nz								;no new item

;new item:
	ld a,5:call get_random_in_range	;add 0-5 for irregular entrance
_delay_new_items equ $+1
	add FOOBAR						;add delay value of this level
	ld (hl),a						;reset counter
	ld hl,MAX_ITEMS*8+__list_items	;look for a free slot in the table
	item_new_search_free_slot:
		xor a						;look for zeros
		cp (hl)						;in the first bytes
		jr z,item_new_create		;slot found
		Addbytetoreg -8,l			;try next item
		jr nz,item_new_search_free_slot;until end
	ret								;max items reached -> no new item

item_new_create:
	ex de,hl						;backup position in item table
	ld hl,__items_allowed_origins
	ld a,(hl)						;get amount of origins
	dec a
	call get_random_in_range
	add l							;apply random to table
	inc a:ld l,a	 				;hl points to a random origin now
	ld a,(hl)						;read it
	and #F:ld b,a      				;b = direction
	call get_randombyte 			;rand for exact position in region
	and 14:add 6					;an even number between 6 and 20
	add (hl)						;add region = rest of (hl)-byte
	sub b							;a=random start coord now (x or y)
	ex de,hl						;back to the item table
	ld (hl),b						;SAVE direction of movement
	inc l							;HL points to to y coord now
	;calc starting coords c=x, a=y
	djnz $+5
		ld c,a						;moves up -> x is random
		ld a,GAMEFLD_HGHT-ITEM_HGHT ;y @ bottom
	djnz $+4
		ld c,a						;moves down -> x is random
		xor a						;y @ top
	djnz $+4
		ld c,GAMEFLD_WDTH-ITEM_WDTH	;left -> x @ right border, y random
	djnz $+4
		ld c,0						;right -> x @ left border, y random
	ld (hl),a:inc l:ld (hl),c		;save y & x
	inc l							;hl points to spriteadr low
	;find item type
_probability_1UP equ $+1
	ld b,FOOBAR						;give 1up a chance
	ld de,__item_special_1up
	call item_toss_random_extra
_probability_BOMB equ $+1
	ld b,FOOBAR						;give bomb a chance
	inc d							;=spriteadress of bomb
	call item_toss_random_extra
	;if routine returns, get a regular item
	ld a,(_curr_mission)			;default -> item of current mission
_item_variety:
	nop								;SMC set or reset carry (variety)
	call c,get_random_in_range		;if "all", get any mission
	call calc_item_sprite_lowbyte
	ld (hl),a						;save lowbyte to item table
	ex de,hl						;backup item table address
	ld hl,_counter_item_streak		;count down the current streak
	dec (hl)
	jr nz,item_new_calc_hibyte		;if streak over
		call get_randombyte			;get new streak length
		and 3:jr nz,$+3:inc a		;1-3 items, double probability for 1
		ld (hl),a					;save streak counter
		ld hl,_curr_item_streak
		ld a,(hl):xor 1:ld (hl),a	;and change avatar
	item_new_calc_hibyte:
_curr_item_streak equ $+1
	ld a,FOOBAR						;that's the hibyte of current avatar
	inc e:ld (de),a					;save it to the item info
ret

item_toss_random_extra:
;decide by random if an special item should appear
;	input:
;b=probability, de=special item sprite address, hl=spradr low in __list_items
;	returns:
;if no special item, nothing happens, return to item_new_create
;if special item, sprite address is saved to hl & return to interrupt
	call get_randombyte
	inc a:cp b						;probability 0 must not happen
ret nc								;regular item, nothing happens
	ld (hl),e:inc l:ld (hl),d		;save sprite address
	pop af							;don't return to the item function
ret									;but to the interrupt handler

item_check_collision:
;check if item touches avatar. If not, return. If yes, don't return but instead
;examine the consequences.
;	input:
;a=lowbyte of avatar table, b=x, c=y of item

	ld ixh,__stats_wiz/#100
	ld ixl,a						;ix=stats of examined avatar
 	ld a,b							;check x collision
	add ITEM_WDTH-1:sub (ix+AV_X_COORD)
	cp AVATAR_WDTH+ITEM_WDTH-1
ret nc
	ld a,c							;check y collision
	add ITEM_HGHT-1:sub (ix+AV_Y_COORD)
   	cp AVATAR_HGHT+ITEM_HGHT-1
ret nc
	;found collision
	pop af							;remove return adress from stack
	;read item sprite address
	inc l:inc l:inc l				;hl points to spriteadr low
	ld c,(hl)						;read sprite address
	inc l:ld b,(hl)
	ld a,__item_special_1up			;check if "special items" (both extras
	cp c							;have the same lowbyte)
	jr z,item_collision_special_item
 	xor a							;suppose the item is for wiz
	bit 0,b:jr z,$+4				;but if hibyte even ->
		ld a,BOT_LOWBYTE			;it's for bot
	cp ixl							;cp with lobyte of catching avatar
	jr z,item_collision_regular_item;a treat for one...
	call avatar_looses_life			;a threat for the other...
	jr item_delete_item

item_collision_special_item:
	bit 0,b							;check if hibyte even or odd
	jr z,item_collision_1up			;if even, it's 1up
	call screen_start_flash			;else itÄs bomb
	jr item_delete_item

item_collision_1up:
	inc (ix+AV_LIVES)				;game_check_livesandpoints will take
	jr item_make_avatar_happy		;	care if more than DEFAULT_LIVES

item_collision_regular_item:
	ld a,(ix+AV_ITEMS)
	add 1:daa
	ld (ix+AV_ITEMS),a
	;fall through

item_make_avatar_happy:
	xor a:cp ixl					;check if wiz
	inc a							;sound effect 1 for wiz
	jr nc,$+3:inc a					;sfx 2 for bot
	ld (_sfx_to_play),a
	ld (ix+AV_HAPPY_ANIM),ANI_LEN_HAPPY;setup happy animation
	call set_update_score_bit		;inform main loop
	;fall through

item_delete_item:
	ld a,#F8:and l:ld l,a			;go to item's status byte
	ld (hl),0
	jp item_process_end

item_delete_all:
	ld hl,__list_items
	ld de,#0008						;de=increment, e=0
	ld b,MAX_ITEMS
	item_delete_this:
		ld (hl),d
		add hl,de
		djnz item_delete_this
ret

item_switch_all:
;switch all items in the game to the corresponding item
;of the other avatar by xor'ing the hibyte with 1
;hl and a modified
	ld hl,__list_items+4			;spradr high
		item_switch_lp:
		ld a,(hl):xor 1:ld (hl),a
		Addbytetoreg 8,l
		cp MAX_ITEMS*8+4
		jr nz,item_switch_lp
	ld a,SFX_BEEP					;maike beep noise when switching
	ld (_sfx_to_play),a
	xor a							;value for reset _counter_item_switch
ret


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                               GRAPHICS
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

;############################
;# GENERAL GFX CALCULATIONS #
;############################

mirror_pixel_line:
;	input
;hl=end of source line+1, de=start of dest line, b=length in bytes
;	returns:
;hl @ start of line, de @ position after last, abc destroyed (b=0)
;lines must be aligned!
	push bc:dec hl:push hl
	ld h,(hl):ld l,h				;copy byte for mirroring
	xor a:ld c,a					;reset dest regs
	ld b,4							;bit counter
		tile_mirror_4bits:
		rlc h:rr a					;high nibble -> mirrored in a
		rrc l:rl c					;low nibble  -> mirrored in c
		djnz tile_mirror_4bits
	or c:ld (de),a					;merge nibbles & write byte
	inc de:pop hl:pop bc
	djnz mirror_pixel_line
ret


;#########################
;# CLEAR SCREEN OR PARTS #
;#########################

clear_status_line:
	ld hl,SCRBASE_STATUS
	ld c,7
	jr clear_part_of_screen

clear_gamefield:
	ld hl,SCRBASE_GAME
	ld c,168
	;fall through

clear_part_of_screen:
;input		hl=start address, c=amount of lines
;returns	bc=0, de=#7c1, a & hl=modified
	ld de,#7C1 						;offset for next pixel line #800-#3F
	clearlines:
		ld b,#3F					;one pixel line -1
		xor a						;fill with 0
			ld (hl),a:inc l
			djnz $-2
		ld (hl),a					;last byte witout inc l
		add hl,de					;instead next pixel line
		call c,calc_charlinebreak_hl
		dec c
	_delay_clearscreen:
		nop							;is replaced by halt for the last cls
		jr nz,clearlines
	ret

;#################
;# SCREEN COLORS #
;#################

;some shortcuts to quickly change screen modes
screen_set_black:
	xor a							;SCRMODE_BLACK=0
	jr screen_set

screen_set_info:
	ld a,(__curr_bg_color)
	ld (__curr_mission_colors),a
	xor a
	ld (_clock_flash),a				;stop flash if running
	ld a,SCRMODE_INFO
	jr screen_set

screen_set_avatars:
	ld a,SCRMODE_AVATARS

screen_set:
	ld (_status_screen),a
ret

screen_japan_water:
;change inks to water colors in the middle of the gamefield with waving effect
	ld a,(_curr_mission):cp 4		;only in mission 5
ret nz
	ld a,(_clock_bg_anim)			;convert main anim clock to delay
	and #7F:sub #40					;oscillate between #80 and #C0
	jr nc,$+4:neg
	add #80
	dec a:jr nz,$-1					;wait delay
	ld hl,__colors_japan_underwater	;do the actual palette change
	jr screen_setcolors0to3

screen_change_under_header:
;change to mode 1 and set colors (from 3 to 0)
;input 	a=status_screen byte
	ld hl,__curr_mission_colors+3	;default -> mission colors
	bit STBIT_PALETTE_GAME,a
	jr nz,$+5						;if game palette is not set,
		ld hl,__curr_bg_color+3 	;	... use 4 x bg color
	ld b,13:djnz $					;wait for exact scanline
	ld bc,#7FAD:out (c),c			;change to mode 1
	bit STBIT_PALETTE_MENU,a		;if menu palette...
ret nz								;don't change (inks 0-3 of header palette)
	ld a,3
	screen_setcolors3to0:			;(b=already crtc port)
		out (c),a:outd				;out ink & value
		dec a
	ret m
		inc b						;restore b
		jr screen_setcolors3to0

screen_change_under_gamefield:
	ld b,90:djnz $					;wait for exact scanline
	ld a,(_curr_game_mode):or a		;check if challenge mode
	jr nz,$+4						;if so, show raster bar
		ld a,(__curr_bg_color)		;with the current bg color
		jr $+4
			ld a,#54				;else raster bar is black = invisible
	ld bc,#7F10:out (c),c:out (c),a	;set border color
	ld hl,__text_monitor:bit 3,(hl)	;check if mono or color monitor
	jr nz,$+7						;set colors for status line
		ld hl,__colors_header
		jr $+5
	ld hl,__colors_header_mono
	;fall through

screen_setcolors0to3:
;speed-optimized version to avoid artifacts @ the borders of the sections
;input hl=inks table, abc destroyed
	ld b,#7F						;CRTC port
	xor a:ld d,4					;faster this way
	screen_setcolors0to3_lp:
		out (c),a:outi:inc b		;out ink & value
		inc a:cp d
		jr nz,screen_setcolors0to3_lp
	ret

screen_start_flash:
	ld a,SFX_BOMB
	ld (_sfx_to_play),a				;play sfx
	ld a,ANI_FLASH_LEN				;setup counter
	ld (_clock_flash),a
	ret

;#################
;# LEVEL TILEMAP #
;#################

draw_level_map:
	ld bc,__curr_level_map+160		;count down
	draw_level_map_lp:
		push bc
		dec c
		ld l,c						;for calc_scraddr
		call calc_scraddr_by_tile	;scraddr -> de
		ld a,(bc)					;tile type
		call draw_level_tile
		pop bc
		dec c
		jr nz,draw_level_map_lp
	ret

draw_level_tile:
;input	a=tile index (as in level map), de=scraddr
;all registerss destroyed
	rla:jr c,draw_tile_enemy
	rla:jr c,draw_tile_obstacle
	rla:jr c,draw_tile_ladder
	rla:jr c,draw_tile_platform
	;air or water -> don't draw anything
ret

draw_tile_ladder:
	nop								;or return if mission 7
	ld b,4
	draw_tile_ladder_4_parts:		;4 times the same 4 lines
		push bc
		ld bc,__curr_ladder			;reload graphic top
		call draw_transparent_fourliner	;de returns @ next line
		pop bc
		djnz draw_tile_ladder_4_parts
	ret

draw_tile_obstacle:
	ld a,2:call get_random_in_range
	rrca:rrca:add #40				;result = #00,#40 or #80
	ld b,__curr_platforms/#100
	ld c,a

	ld a,4:ld ixh,16				;set width & height
	jr draw_transparent_graphic

draw_tile_platform:
	ld a,#2F 						;choose randomly 1 of the 3 versions
	call get_random_in_range
	and #F0							;result = #00,#10 or #20
	ld b,__curr_platforms/#100
	ld c,a
	;fall through

draw_transparent_fourliner:
;just a shortcut for setting width & height
	ld a,4:ld ixh,a
	;fall through

draw_transparent_graphic:			;should be self explanatory
;	input:
;de=scraddress, bc=source, a=width, ixh=height
	ld (_transp_gfx_width),a		;SMC the width to the loop
	ld h,ANDMASK_TABLE_HI
	draw_transparent_olp:
	_transp_gfx_width equ $+2
		ld ixl,FOOBAR
		push de
		draw_transparent_ilp:
			ld a,(bc)
			Draw_transp_byte a
			inc bc:inc de
			dec ixl
			jr nz,draw_transparent_ilp
		pop de
		call calc_nextscanline_de	;also for next fourliner
		dec ixh
		jr nz,draw_transparent_olp
	ret

draw_tile_enemy:					;enemy tiles are opaque
	srl a							;shift back, but without bit 7
	;convert frame value to hl by adding the following value to __curr_enemy_sprites
	;0-000, 1-040, 2-080, 3-0c0, 4-100, 5-140, 6-100, 7-0c0, 8-080, 9-040
	cp 6							;if under 6, take value directly
	jr c,$+6						;else transform:
		sub 10:neg					;6 -> 4, 7 -> 3 etc.
	Calc_Ax8:Calc_Ax8				;* #40
	ld h,__curr_enemy_sprites/#100
	ld l,a
	jr nc,$+3						;if carry in last add a
		inc h
	;draw_opaque_tile:				;de=dest, hl=source, always 16 lines
	call draw_tile_opaque_8_lines	;upper eight lines
	;fall through					;bottom eight lines
	draw_tile_opaque_8_lines:
	ld bc,#8FF						;c=dummy so that ldi doesn't dec b
		draw_tile_opaque_lines:
		push de
		ldi:ldi:ldi:ldi				;copy 4 bytes
		pop de
		call calc_nextscanline_de
		djnz draw_tile_opaque_lines
	ret

draw_tile_shaded:
;shade a tile by turning the andmask of its bytes to color 3
;input 	de=scraddr, size always 4x16
	ex hl,de
	ld d,ANDMASK_TABLE_HI
	ld c,16							;lines
		draw_tile_shaded_lines:
		ld b,4						;bytes
		push hl
			draw_tile_shaded_line:
			ld e,(hl)				;read screenbyte
			ld a,(de)				;get its andmask
			cpl						;invert
			ld (hl),a				;replace screenbyte
			inc l					;next
		djnz draw_tile_shaded_line
		pop hl
		call calc_nextscanline_hl
	dec c
	jr nz,draw_tile_shaded_lines
ret

;############################
;# BACKUP SCREEN OPERATIONS #
;############################

;NOT DOUBLE BUFFERING!

screen_restore_bg_byte:
;restore a single screenbyte from the backup to the main screen
;input  de=scraddr (on main screen)
	res 6,d:ld a,(de)
	set 6,d:ld (de),a
ret

screen_restore_backup:
;restore the whole game field from backup
	ld hl,SCRBASE_BACKUP
	ld de,SCRBASE_GAME
	jr screen_copy

screen_save_backup:
;save the whole gamefield to backup
	ld hl,SCRBASE_GAME
	ld de,SCRBASE_BACKUP

screen_copy:
;linewise from top to bottom.
;8 x bc=#40*20 would be easier, but I don't like the window blind effect
_screen_copy_amount_lines equ $+1
	ld b,20*8						;20 charlines
	screen_copy_lp:
		push bc
		push hl:push de
		ld bc,#40:ldir				;copy one pixel line
		pop de:pop hl
		call calc_nextscanline_hl
		call calc_nextscanline_de
		pop bc
		djnz,screen_copy_lp
ret

screen_copy_tile_to_backup:			;4x16 bytes
;input hl=start scraddress, only a & x/y preserved
	call tile_copy_8lines_to_bg
	ld bc,#B840:add hl,bc			;next charline
	tile_copy_8lines_to_bg:
		tile_copy_line:
		ld d,h:ld e,l:res 6,d		;de=scraddr @ backup screen
		ldi:ldi:ldi:ldi				;copy 4 bytes
		ld bc,#7FC:add hl,bc		;next pixelline
		jr nc,tile_copy_line
	ret

screen_draw_mission_bg_to_backup:	;necessary to generate a picture of the bg
;no input, destroys all registers	;	without the time machine
	ld hl,_calc_scraddr_set_base
	ld (hl),SCRBASE_BACKUP/#100:push hl
	call draw_mission_bg
	pop hl:ld (hl),SCRBASE_GAME/#100
ret

;######################
;# MISSION BACKGROUND #
;######################

;The background images of the missions consist of 160 meta-tiles of 16x16px.
;every meta-tile is divided into 4 monochrome sub-tiles of 8x8px.
;this helps immensely to save memory beause most of the sub-tiles are used in
;several meta-tiles.

draw_mission_bg:
;no input, destroys all except index registers
	ld l,160						;count down = draw from bottom to top
	draw_mission_lp:
		push hl						;save l before decrementing, because...
		dec l
		call draw_mission_metatile
		pop hl
		dec l						;...check here if last tile WAS 0
		jr nz,draw_mission_lp
ret


draw_mission_metatile:
;input 	l=map index of the tile, destroys all except index registers
	ld c,l							;backup l
	call calc_scraddr_by_tile		;get scraddress in de
	ld l,c:ld h,__curr_bg_map/#100	;restore & complement l to full map addr
	ld l,(hl):ld h,0				;hl = meta-tile index nr
	add hl,hl:add hl,hl				;calc metatile address
	ld bc,__bg_meta_tiles:add hl,bc
	ld b,h:ld c,l					;bc points to 1st of 4 sub-tile indexes
	call draw_mission_2_subtiles	;draw upper 2
	Addbytetoreg #3E,e				;move scraddr to next charline
	;fall through					;draw the bottom 2
draw_mission_2_subtiles:
	call draw_mission_subtile
	inc e:inc e						;advance 8 bytes
	;fall through
draw_mission_subtile:
;input		bc points to sub-tile index, de=scraddr
;returns 	bc+=1, de intact, a,h,l destroyed
	ld a,(bc) 						;a = sub-tile index
	inc c							;advance to next sub-tile
	push bc:push de
	ld h,0:ld l,a					;calculate sub-tile address
	add hl,hl:add hl,hl:add hl,hl 	;*8
	ld bc,__bg_sub_tiles:add hl,bc
	ex de,hl
	ld b,8
	draw_mission_subtile_lp:		;hl=dest, de=source
		ld a,(de)					;convert 8px-bitmap to 2 bytes in pen 3:
		inc l:ld (hl),a:rld			;=lo nibble copied to both sides
		dec l:ld (hl),a				;=hi nibble copied to both sides
		Addbytetoreg 8,h			;next pixel line scraddr
		inc de						;next pixel byte source
		djnz draw_mission_subtile_lp
	pop de:pop bc
ret

screen_copy_bg_color:
	;copy contents of de to __curr_bg_color
	ld a,(de)
	ld de,__curr_bg_color
	ld b,3
		ld (de),a
		inc de
		djnz $-2
ret

;##################
;# AVATAR SPRITES #
;##################

draw_avatars_both:
;no input, destroys all registers
;interrupt must be disabled (messes with stack)

	;first set the jr @ _draw_sprite_def_return to default
	ld a,draw_avatar_scanlines-_draw_sprite_def_return-1
	ld (_draw_sprite_def_return),a

	ld h,__stats_avatars/#100		;(hibyte of status table)
	ld a,(_foreground_avatar)		;(lowbyte of status table)
	xor #10:ld l,a					;draw background avatar first
	call calc_scraddr_by_coords_M	;read xy from (HL) and save scraddr to DE
	ld (_avatar_scraddr_1),de		;backup scraddr for faster erasing
	call draw_avatar
_foreground_avatar equ $+1
	ld hl,__stats_avatars			;foreground avatar
	call calc_scraddr_by_coords_M
	ld (_avatar_scraddr_2),de		;backup as well
	;fall through

draw_avatar:
;input	hl=avatar stat table + AV_SPRITETYPE
	ld c,(hl)						;get sprite index
	inc c:ret z:dec c				;-1 means invisible
	inc hl:LdHLfromHL				;get LUT address from status table
	sla c							;double sprite index
	ld b,0:add hl,bc				;add to lut address
	LdHLfromHL						;read sprite address from lut
draw_24lines_sprite:
	ld iyl,24						;12 double-lines = 24 lines
	;de=scraddress, hl=sprite->SP
	ld (_sp_after_avatar_sprite),sp	;backup stack pointer
	ld sp,hl
	ld h,ANDMASK_TABLE_HI
	draw_avatar_scanlines:
		pop bc						;pop off 2 bytes
		Draw_transp_byte c:inc e	;and draw them
		Draw_transp_byte b:inc e
		pop bc						;and the other 2 bytes
		Draw_transp_byte c:inc e
		Draw_transp_byte b
		dec iyl
		jr z,draw_avatar_done
		dec e:dec e:dec e			;return scraddr to 1st position
	draw_avatar_calcnextline:
		Addbytetoreg 8,d			;calc linebreak directly here
		jr nc,$+9					;(it's faster and we have no working stack
			ld hl,#C040:add hl,de	;for call & return)
			ex de,hl
			ld h,ANDMASK_TABLE_HI
	_draw_sprite_def_return equ $+1
		jr draw_avatar_scanlines	;default -> return back to loop
		ld hl,12					;if drawing part of the timemachine, (intro)
		add hl,sp					;skip 12 bytes to get to the next line of
		ld sp,hl					;the source data
		jr draw_avatar_scanlines-2	;h has to be reloaded
	draw_avatar_done:
	_sp_after_avatar_sprite equ $+1
	ld sp,FOOBAR
ret

erase_avatars_both:
;by copying two 4x24 rectangles from the backup to the main screen
;starting @ the 2 defines scraddrs
_avatar_scraddr_1 equ $+1
	ld de,SCRBASE_GAME				;safe value for game start
	call erase_avatar
_avatar_scraddr_2 equ $+1
	ld de,SCRBASE_GAME				;safe value for game start
	;fall through
erase_avatar:
	ld bc,72						;3*24=96 ldis
	erase_avatar_lp:
		ld h,d:ld l,e:res 6,h		;HL=scraddr on backup screen
		erase_avatar_lp_later:		;(if hl & de are already set)
		ldi:ldi:ldi					;copy 3 bytes forward
		Draw_opaque_byte (hl)		;and one direct copy w/o incrementing
		set 3,h:set 3,d				;next line(s)
		ldd:ldd:ldd					;copy 3 bytes backwards
		Draw_opaque_byte (hl)		;and one direct
	ret po							;if bc = 0
		Addbytetoreg 8,d			;line down (faster without call)
		jr nc,erase_avatar_lp
		ld hl,#C040:add hl,de		;char linebreak
		ld d,h:ld e,l				;copy to de
		res 6,h						;and set hl to background screen
		jr erase_avatar_lp_later


;################
;# ITEM SPRITES #
;################

draw_items_all:
	ld a,(_clock_flash):or a
ret nz								;dont redraw if bomb is active
	ld hl,__list_items				;start of item list
	ld ix,__items_to_erase			;start of erase list
	draw_items_lp:
		xor a:cp (hl)				;if statusbyte=0, don't draw
		jr z,draw_items_next
		push hl
		call calc_scraddr_by_coords_M	;scraddr -> DE
		ld (ix),e:inc ixl			;save scraddress in erase-list
		ld (ix),d:inc ixl
		LdHLfromHL					;get sprite address
		call draw_item				;and draw the item
		pop hl						;restore current address in item list
	draw_items_next:
		Addbytetoreg 8,l			;advance to next item in list
		cp MAX_ITEMS*8				;check if end of list
		jr nz,draw_items_lp
		xor a:ld (ix+1),a
ret

draw_item:							;3*10 byte
;input 	de=scraddress, hl=sprite address (aligned)
;abcdehl & iyl destroyed
;interrupt must be disabled (messes with stack)

	ld (_sp_after_item_sprite),sp	;backup stack pointer
	ld sp,hl
	ld h,ANDMASK_TABLE_HI
	ld iyl,5						;5 x 2 lines
		draw_item_lines:			;2 lines actually
		;the items sprite data is already prepared for this fast routine
		;(every other line is reversed)
		pop bc
		Draw_transp_byte c:inc e
		Draw_transp_byte b:inc e
		pop bc
		Draw_transp_byte c:set 3,d	;1 line down
		Draw_transp_byte b:dec e
		pop bc
		Draw_transp_byte c:dec e
		Draw_transp_byte b
		dec iyl
		jr z,item_done
		Addbytetoreg 8,d
		jr nc,draw_item_lines
		Calc_char_linebreak d,e
		jr draw_item_lines
	item_done:
	_sp_after_item_sprite equ $+1
	ld sp,FOOBAR
ret

erase_items_all:
	ld hl,__items_to_erase
	erase_items_lp:
	ld e,(hl):inc l:ld d,(hl):inc l	;get scraddr
	ld a,d:or a						;if hibyte=0 -> end of list
ret z
	push hl
	;erase items routine - works exactly like erase_avatar
	ld bc,20						;10*2 for ldi (P/V Flag)
	erase_item_lines:				;actually 2 scanlines
		ld h,d:ld l,e:res 6,h		;set hl to backup screen
		erase_item_lines_later:		;hl & de already set
		ldi:ldi:Draw_opaque_byte (hl)
		set 3,h:set 3,d				;next line(s)
		ldd:ldd:Draw_opaque_byte (hl)
	jp po,erase_items_lp_end		;if bc=0
		Addbytetoreg 8,d
		jr nc,erase_item_lines
		ld hl,#C040:add hl,de
		ld d,h:ld e,l:res 6,h
		jr erase_item_lines_later
	erase_items_lp_end:
	pop hl
	jr erase_items_lp

;################
;# TEXT BUBBLES #
;################

draw_bubble_bot:					;draw a bubble in the color of wiz
	;c (height) and hl (scraddr) have to be set!
	ld de,__bubble_data_bot+2
	jr draw_bubble

draw_bubble_wiz:					;draw a bubble in the color of wiz
	;c (height) and hl (scraddr) have to be set!
	ld de,__bubble_data_wiz+2
	;fall through

draw_bubble:						;draw a bubble
;c=height (in char lines), hl=scraddr, de=design table (wiz or bot)
	call draw_bubble_line			;1st line
	call draw_bubble_line			;2nd line
	ld a,c:Calc_Ax8:ld c,a			;height = charlines * 8 scanlines
	draw_bubble_middle_lines:
		push de						;backup address of middle lines data
		call draw_bubble_line
		dec c
		jr z,$+5					;skip popping if done
		pop de
		jr draw_bubble_middle_lines
	pop af							;remove old address from stack
	call draw_bubble_line			;penultimate line
	;fall through					;-> last line

draw_bubble_line:
	push hl
	ld a,(de):inc de:ld (hl),a:inc l;copy left border byte
	ld a,(de):inc de				;bitmap to fill with
	ld b,BUBBLE_WDTH
	ld (hl),a:inc l:djnz $-2		;draw inside of bubble or line
	ld a,(de):inc de:ld (hl),a		;copy right border byte
	pop hl
	jp calc_nextscanline_hl

draw_bubble_tip:					;transparent, masks are in gfx data
	ld a,(de):inc de				;read bitmask
	inc a							;-1 = end of data
ret z
	dec a:and (hl):ld c,a			;c=mask AND scrbyte
	ld a,(de):inc de:or c			;OR with gfx
	ld (hl),a						;& draw
ret

draw_bubble_add_offset:
	ld a,(de):add l:ld l,a:inc de	;read offset from de (word)
	ld a,(de):adc h:ld h,a:inc de	;	...and add it to scraddr
ret

draw_bubble_with_caption:			;...and write the caption after the call
	ld bc,#0105						;pen 1, line height 5
	call txt_set_pen
	ld hl,SCRBASE_GAME+#0187
	call draw_bubble_wiz
	ld de,SCRBASE_GAME+#01D6
	jp txt_write_this_string		;"this" is after the call for

;###################
;# DIV. ANIMATIONS #
;###################

anim_avatar_faces:
;animate the faces of both avatars (wiz's eyes, bot's screen)
;by directly changing the concerned bytes in the sprite data
	call get_randombyte				;choose if and who to animate
	cp 5							;smaller probability for wiz eyeroll
jr c,anim_wiz_eyes
	cp 40							;bot's screen changes faster (higher prob.)
ret nc
	;change the pattern on the bot's screen (static/noisy/ordered/pretty)
	ld hl,__Spr_Bot_Front+21		;upper pixelline
	inc (hl):inc l:dec (hl)
	ld l,__Spr_Bot_Front+25			;lower pixelline
	dec (hl):inc l:inc (hl)
ret

anim_wiz_eyes:
	ld hl,__Spr_Wiz_Front+21		;change eyes looking to the left/right
	ld a,(hl):xor #66				;alternate #2d/#4b -> xor #66
	ld (hl),a:inc l:ld (hl),a
ret


anim_background_objects:
;diverse animations, some depending of the mission
	ld hl,_clock_bg_anim:inc (hl)	;advance general animation counter

_clock_flash equ $+1
	ld a,0:or a						;check if flash
	jr nz,anim_flashchange_bg
	ld a,(__curr_mission_colors-1)	;get the original bg color
	jr anim_flashsave_bg
	anim_flashchange_bg:		;if flash is active
	dec a						;count down
	ld (_clock_flash),a			;and save
	add #44						;transform to a valid color
	anim_flashsave_bg:
	ld (__curr_mission_colors+0),a	;save background color


;animate sparkles
	ld a,(_curr_mission)
	ld b,3:and b:cp 2 				;only in mission 3 & 7 (2 & 6)
	jr nz,anim_dead_enemy
	anim_sparkle_do:
_clock_bg_anim equ $+1				;this is the main counter for animations
	ld a,FOOBAR
	and b:jr nz,anim_dead_enemy		;update sparkle animation every 4 frames
	;every update erases the oldest sparkle, shifts the lists and sets a new one
	ld hl,__anim_sparkle_table		;start the update
	push hl							;backup for table shift
	ld e,(hl):inc l					;get sparkle address
	ld d,(hl):inc l
	inc d:dec d						;end of list (nothing more to erase)?
	jr z,anim_shift_sparkle_table
		anim_sparkles_erase:		;b is still 3
		call screen_restore_bg_byte	;erase sparkle by restoring the 3 lines
		call calc_nextscanline_de	;from backup screen
		djnz anim_sparkles_erase
	anim_shift_sparkle_table:
	pop de							;restore start of table address (hl is 2+)
	ld bc,14:ldir					;shift 7 words
	;find a new sparkle address
	ld a,127						;max x
	call get_random_in_range:ld b,a	;b=x
	ld a,77							;max y
	call get_random_in_range		;a=y
	call calc_scraddr_by_coords_BA
	ld (__anim_sparkle_table+14),de	;save new scraddr @ end of table
	ld hl,__anim_sparkle_gfx_data	;the 3 bytes & their bitmasks
	ld b,3
		anim_sparkles_draw:
		ld a,(de):and (hl):inc hl	;get screen content, and with mask
		or (hl):inc hl:ld (de),a	;or with sparkle gfx and draw
		call calc_nextscanline_de
		djnz anim_sparkles_draw

anim_dead_enemy:
	ld hl,_status_game				;first check if an enemy died
	bit STBIT_ENEMY_DEAD,(hl)
	jr nz,anim_shade_enemy			;if so, shade them first

;animation of enemies. look out for enemy tiles in __curr_level_map
;if alive, animate them. if shaded (1), set to 2. if 2, erase
	ld b,32							;look throug 2 lines per call
	anim_search_enemy_tile:
		ld hl,_bg_update_curr_tile
		dec (hl)					;count down tile counter
		jr nz,$+4:ld (hl),160
	_bg_update_curr_tile equ $+1
		ld l,FOOBAR+1:dec l			;initial value = 1
		ld h,__curr_level_map/#100
		ld a,(hl)
		bit TILE_ENEMY_bit,a		;check if its an alive enemy
		jr nz,anim_found_live_enemy
		dec a						;check if 1 (shaded)
		jr nz,anim_enemy_not_shaded
			inc (hl)				;if shaded, set to 2 (erase next time)
		anim_enemy_not_shaded:
		dec a						;check if (hl) was 2
		jr z,anim_erase_enemy
		djnz anim_search_enemy_tile	;else it wasn't an enemy tile
	ret

anim_found_live_enemy:
	sub TILE_ENEMY-1				;isolate frame count & decrement
_anim_amount_enemy_frames equ $+1	;default 10, mision 6->4, mission 4->6
	cp FOOBAR						;check if last frame
	jr nz,$+3:xor a
	add TILE_ENEMY					;complement with enemy bit
	ld (hl),a:ld c,a				;write & backup new sprite frame
	call calc_scraddr_by_tile
	push de							;backup scraddress
	ld a,c:rla						;restore & shift left, because...
	call draw_tile_enemy			;	...drawing routine will shift right
	pop hl
	jp screen_copy_tile_to_backup	;copy altered tile to backup screen
	;and finish (don't return to loop, change only one enemy per frame )

anim_shade_enemy:
	res STBIT_ENEMY_DEAD,(hl)		;reset dead enemy bit
	ld hl,_score_enemies_killed		;increase the kill count
	ld a,(hl):add 1:daa:ld (hl),a	;(in bcd!!)
_anim_dying_enemy equ $+1
	ld hl,FOOBAR					;get (map) address of dying ene
	ld (hl),1						;code for dying (shaded) enemy
	call calc_scraddr_by_tile
	call draw_tile_shaded
	ld de,-128						;offset to get back to starting scraddr
	jr anim_erase_enemy_end			;just to save some bytes

anim_erase_enemy:
_mission_default_tile equ $+1		;standard air, mission 3 -> sea, 7 -> ladder
	ld (hl),FOOBAR					;replace enemy with the default tile
	call draw_mission_metatile
	ld hl,-66						;offset to get back to starting scraddr
	anim_erase_enemy_end:
	add hl,de						;apply offset
	jp screen_copy_tile_to_backup


;################
;# TIME MACHINE #
;################

;custom jumps for the jump in csc_machine_random_lines
jr_fuzzy_line equ csc_machdrw_fuzzy_byte-csc_machine_end_lp
jr_timch_line equ csc_machdrw_timch_byte-csc_machine_end_lp
jr_bkgrd_line equ csc_machdrw_bkgrd_byte-csc_machine_end_lp
;two of these 3 are loaded into IX, whereby:
;IXH = jump more probable @ begin, IXL = jump more probable @ end of phase

csc_machine_appears:
    ld ix,jr_bkgrd_line*#100+jr_fuzzy_line
	call csc_machine_random_lines	;fuzzy lines cover/replace bg
	ld ix,jr_fuzzy_line*#100+jr_timch_line
	call csc_machine_random_lines	;machine lines cover/eplace fuzzy shape
	call draw_machine_full			;after anim draw full machine to main screen
	ld de,TIMEMACHINE_POS-#4000
	jr $+5							;...and to backup screen (skip ld de)

draw_machine_full:
	ld de,TIMEMACHINE_POS
	ld bc,(_time_machine_source)	;set values
	ld a,TIMEMACHINE_WDTH*2
	ld ixh,TIMEMACHINE_HGHT
	jp draw_transparent_graphic		;draw transparent

csc_machine_vanishes:
	ld ix,jr_timch_line*#100+jr_fuzzy_line
	call csc_machine_random_lines	;fuzzy lines cover/replace time machine
	ld ix,jr_fuzzy_line*#100+jr_bkgrd_line
    ;fall through					;background lines cover/replace fuzzy shape

csc_machine_random_lines:
	;is repeated 256 times (_counter_machine_lines)
	ld hl,anim_machine_delay:dec (hl)
	jr nz,csc_machine_after_counter ;if delay counter=0
	ld (hl),ANI_SPEED_MACHINE 		;reset it
	ld hl,_counter_machine_lines
	dec (hl) 						;& decrease animation counter (see below)
ret z								;return if the latter is 0

csc_machine_after_counter:
    ld a,TIMEMACHINE_HGHT-1			;get a random line < TIMEMACHINE_HGHT
	call get_random_in_range
	;calculate screenaddress and position in the timemachine bitmap
	ld l,a:ld h,0:srl a				;backup to hl & half value for screenaddr
	add TIMEMACHINE_Y:ld b,TIMEMACHINE_X
	call calc_scraddr_by_coords_BA	;de=scraddr
	bit 0,l:call nz,calc_nextscanline_de	;if line odd
	add hl,hl:add hl,hl
	add hl,hl:add hl,hl				;y*16 (bitmap is 16 bytes wide)
_time_machine_source equ $+1		;can be replaced by the juez address
	ld bc,__machine_bitmap			;add to origin
	add hl,bc						;and done
	call get_randombyte
	ld b,h:ld c,l
_counter_machine_lines equ $+1
    ;this value is decremented to gradually
    ;change the probability from 1st jump to 2nd
	cp #ff
	ld a,ixl 			;contains jump for action more likely @ begin
	jr nc,$+4
		ld a,ixh 		;jump for action more likely @ end
	ld (_draw_timemachine_custom_jump+1),a
	csc_machine_line:
		ld h,ANDMASK_TABLE_HI
	_draw_timemachine_custom_jump
		jr $+FOOBAR
	csc_machine_end_lp:
		inc e
		inc c
		ld a,15
		and c 		;bc is aligned, so c%15=0 means end of line
		jr nz,csc_machine_line
	jr csc_machine_random_lines

	;the three "subroutines":
	csc_machdrw_timch_byte:
		ld a,(bc):ld l,a			;standard and/or procedure for transparency
		res 6,d:ld a,(de):set 6,d	;but with bg from backup screen
		and (hl):or l
	 	ld (de),a
	 	jr csc_machine_end_lp

	csc_machdrw_bkgrd_byte:
	    call screen_restore_bg_byte	;copy byte from backup screen
	 	jr csc_machine_end_lp

	csc_machdrw_fuzzy_byte:
	    ld a,(bc):ld l,a 			;get bitmap byte
	    ld h,(hl) 					;get inverted "shape" of bitmap byte
		res 6,d:ld a,(de):set 6,d	;get bg byte
		and h:ld l,a				;bg pixels instead of bitmap bg
		ld a,r:or h:sub h			;random pixels in shape of bitmap
		or l 						;combine with original bg
		ld (de),a
	 	jr csc_machine_end_lp


draw_machine_part_over_avatar:
;this is horrible, i'm sure there's a better way to do that. And all that only
;because I want the avatars to appear behind and in the time machine...

	;check if coords are in scope of time machine
	ld b,h							;x-coord
	ld a,TIMEMACHINE_X:cp b			;to the left of machine?
	jr c,$+3:ld b,a					;if not, set left border
	ld a,TIMEMACHINE_X+25:cp b		;to the right?
	jr nc,$+3:ld b,a				;etc.
	ld a,l:ld l,TIMEMACHINE_Y:cp l	;for y only upper border has to be checked
	jr nc,$+3:ld a,l				;(bottom = also bottom of screen)
	ld c,a							;backup y
	;calc offset for hl (y*2*16+x)
	sub l:add a:ld h,0:ld l,a		;y*2
	add hl,hl:add hl,hl				;*8
	add hl,hl:add hl,hl 			;*32
	ld a,b:sub TIMEMACHINE_X:rra	;+x (coord/2=scrbyte)
	add l:ld l,a
	ld de,__machine_bitmap
	add hl,de						;hl=starting address for timemachine part
	ld a,c
	call calc_scraddr_by_coords_BA
	xor a:ld (_draw_sprite_def_return),a
	jp draw_24lines_sprite

mirror_machine:
; INPUT
;Complete it by decompressing & mirroring
	mirror_lines_lp:
	;first, decompress the data (values<9 means x repetition of 0s)
		ld bc,#0801					;b=total bytes counter, c=repetition counter
		mirror_copylines_lp:
			dec c					;if rep counter>0, don't read a new byte
			jr nz,mirror_copylines_writebyte
			mirror_copylines_readbyte:
			inc c					;set default value to 1 repetition
			ld a,(hl):inc hl
			cp 9					;check if repetition marker
			jr nc,mirror_copylines_writebyte
				ld c,a				;if so, copy amount to c
				xor a				;and set the graphics byte to 0
			mirror_copylines_writebyte:
			ld (de),a:inc de
			djnz mirror_copylines_lp
		push hl
		ld h,d:ld l,e:ld b,8		;(start of mirror=end of line+1)
		call mirror_pixel_line
		pop hl
		dec ixl
		jr nz,mirror_lines_lp
	ret




;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                               TEXT OUTPUT
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

;#################
;# STANDARD TEXT #
;#################

txt_write_shortcut:
	push hl
	add ASCII0-5
	jr nc,shortcut_under_5
	;shortcut>=5
	ld hl,__txt_shortcuts
	or a
	jr z,txt_shortcut_do_write
	ld b,a							;find pos of shortcut by skipping b EOL's
		call txt_skip_string
		djnz $-3
	jr txt_shortcut_do_write
	shortcut_under_5:
		add 5
		ld hl,__txt_leveltexts_lookup
		call load_HL_from_HLplus2a
	txt_shortcut_do_write:
	call txt_string_lp		;not the whole routine in order to keep l/r toggle
	jr txt_string_lp_end

txt_write_string:
;	input
;de=scraddr, HL=string address
	ld ixl,0						;reset left/right toggle (2 left side or 2
	txt_string_lp:					;	right side pixels of one mode 1 byte
		ld a,(hl)					;get next character
		res 7,a						;reset eol bit
		sub ASCII0					;if < ASCII0
		jr c,txt_write_shortcut		;it's a shortcut
		push hl						;backup current char addr
		;calculate character address (ascii*15)
		ld h,0:ld l,a
		ld b,h:ld c,a
		add hl,hl:add hl,hl			;*4
		add hl,hl:add hl,hl			;*16
		sbc hl,bc					;*15
		ld bc,__font_regular		;add offset to font base
		add hl,bc
		;process character
		push de						;backup scraddr
		ld a,(hl):ld ixh,a			;character width (0=2px,1=4px,2=6px)
		inc hl						;advance hl to bitmaps
		ex de,hl					;ex source & dest for subroutines
		;decide which routine to use depending on width and toggle position:
		ld c,ixl					;position toggle
		bit 0,c						;check bit 0
		ld bc,#0733					;b=7 lines, c=AND value
		jr z,txt_string_lp_pos_left
		;position_right:			;(toggle is odd)
			or a					;check if width =0
			jr nz,txt_char6px_right	;not 0 -> width=4px or 6px
			jr txt_char2px_right	;0 -> width=2px
		txt_string_lp_pos_left:		;(toggle is even)
			cp 2					;check if 2
			jr z,txt_char6px_left	;2 -> width=6px
			jr txt_char4px_left		;not 2 -> width=2px or 4px

	txt_string_lp_cont:
	;the txt_char routines jump here after finishing. a contains the increment
	;for the scraddr (0, 1 or 2 - value depends on width & left/right toggle)
		pop de:add e:ld e,a			;next scraddr position
		dec ixh
		jr z,txt_string_lp_end		;if width=2 or 6px,
			inc ixl 				;increment toggle to change side
		txt_string_lp_end:
		pop hl						;restore address in string
		bit 7,(hl)					;check if EOL was set
		inc hl						;next char in (or byte after) string
	ret nz							;return if EOL
		jr txt_string_lp

	txt_char6px_left:				;draw 6 px char starting left side
		ld a,(de):inc de			;get first bitmap
		ld (hl),a:inc l				;draw opaque (left side)
		ld a,(de)					;next bitmap
		and c:rla:rlca				;shift and isolate
		ld (hl),a					;draw opaque
		dec l						;restore initial scraddr for next line
		inc de						;next bitmap (for next line)
		call calc_nextscanline_hl
		djnz txt_char6px_left
		ld a,1 						;scraddr+=1
		jr txt_string_lp_cont

	txt_char6px_right:				;draw 6 (or 4) px char starting right side
		call txt_get_isolate_and_merge_right
		inc l						;and draw
		ld a,(de)					;next bitmap doesn't need to be modified
		ld (hl),a					;and is also opaque
		dec l:inc de
		call calc_nextscanline_hl
		djnz txt_char6px_right
	ld a,ixh						;4px -> scraddr+=1, 6px -> scraddr+=2
	jr txt_string_lp_cont			;"return"

	txt_char4px_left:				;draw 4 (or 2) px char starting left side
		ld a,(de)
		ld (hl),a
		inc de:inc de				;skip 2nd byte
		call calc_nextscanline_hl
		djnz txt_char4px_left
	ld a,ixh:and 1					;2px -> scraddr+=0, 4px -> scraddr+=1
	jr txt_string_lp_cont

	txt_char2px_right:				;draw 2 px char on right side
		call txt_get_isolate_and_merge_right
		inc de
		call calc_nextscanline_hl
		djnz txt_char2px_right
	ld a,1							;scraddr+=1
	jr txt_string_lp_cont

	txt_get_isolate_and_merge_right:;shortcut because that happens twice
		ld a,(de):inc de			;get first bitmap
		rra:rrca:and c				;shift and isolate
		or (hl)						;merge with 2 left pixels of this screenbyte
		ld (hl),a					;and draw
	ret

txt_write_this_string:
;write the string saved directly after the call
	pop hl							;get return address and use as string addr
	call txt_write_string
	jp (hl)							;return to code after string

txt_set_pen_2:						;just a shortcut because it happens often
	ld b,2

txt_set_pen:
;input 	b (pen 1 or 2)
	;check current pen reading the first byte of "0" character
	ld a,(__font_regular+1)			;bit 1 is 0 if pen 1, 1 if pen 2
	xor b							;xor with bit 1 of [1] or [2]
	bit 1,a
ret z								;don't swap if already this pen color

txt_swap_pen:
;swap the text color by directly changing the data in __font_regular
;destroys a
	push hl:push bc					;backup used regs
	ld HL,__font_regular
	ld c,CHARS_TOTAL
	txt_swap_pen_char_lp:
		inc hl						;don't overwrite the byte with width info
		ld b,14
		txt_swap_pen_bitmap_lp:
			ld a,(hl):rrd 			;exchanging nibbles changes foregrd color
			inc hl
			djnz txt_swap_pen_bitmap_lp
		dec c
		jr nz,txt_swap_pen_char_lp
	pop bc:pop hl
ret

txt_skip_string:
;move hl forward after the end of a string by looking for eol bit
;hl returns @ the position AFTER the string
	bit 7,(hl):inc hl
	jr z,txt_skip_string
ret


;##############
;# LARGE TEXT #
;##############
;
;Using the __font_big with 10x12px characters (3 bytes wide on screen).
;This font uses a compressed, monochrome format working as follows:
;data is in words (little endian), the character is drawn from top to bottom.
;most sgnificant 4 bits indicate how often this pixel line is repeated,
;the right 12 bits contain the actual pixel data, but shifted right by 1 bit.
;
;for the antialiasing effect, every bg px with at least 1 fg px is transformed
;to pen 3 using the following algorithm:
;1. OR the original with both its left and right shift -> DE
;2. calculate the bitmap for the "grey" nibbles by XORing BC (the "original")
;	with DE -> BC
;3. combine DE & BC to the 3 screenbytes using the nibbles of DE nibbles as
;right (pen 1) and of BC als left (pen 3)

txt_big_write:
;default output in screen line #c300
;	input
;hl=source text where 1st byte=x-coord (in scrbytes), 2nd byte=length of string
;	returns
;hl @ last byte of string, all others except IY corrupt
	ld b,#C3						;default hibyte of scraddr
	ld c,(hl)						;read x-coord = lowbyte of scraddr

txt_big_write_set_addr:
;write @ a custom scraddr, preset in bc
	inc hl
	ld a,(hl)						;read length
	inc hl

txt_big_write_set_len:
;write @ a custom scraddr & with custom length, preset in bc & a
	push bc							;backup scraddr for colouring later
	txt_big_write_lp:
		push af						;length counter
		ld a,(hl)					;get char (in ascii)
		push hl:push bc				;backup scraddr & string addr
		ld hl,__font_big
		sub ASCII0					;convert to bigtext font index
		jr z,txt_big_start
		cp 10:jr c,$+4:sub 4		;if letter, skip [-.?#]
		;search for character address (we can not multiply, because
		;the characters have all different data sizes)
		ld d,a						;char index = counter
		txt_big_search_letter_olp:
		xor a						;reset height counter
			txt_big_search_letter_ilp:
			add (hl)				;add repetition to counter (high nibble)
			inc hl:inc hl			;skip to next hibyte
			cp #BF					;repeat until total height > 11 (the low
			jr c,txt_big_search_letter_ilp	;nibbles can't cumulate over 15)
		dec d						;next character
		jr nz,txt_big_search_letter_olp

		txt_big_start:				;bc=screen dest, hl=sprite address
		ld ixl,12					;12 lines
			txt_big_write_char_lp:
			ld a,(hl):and #F0		;isolate repetition amount (in left nibble)
				txt_big_write_repeat:
				push af				;backup repetition counter
				push hl:push bc		;backup charline address & scraddr
				ld a,(hl):inc hl	;save bitpattern "right shift" version to AE
				ld e,(hl)			;(little endian!). now the antialiasing:
				ld h,a:ld l,e		;copy AE to HL
				add hl,hl			;shift left = "original" version
				ld b,h:ld c,l		;copy "original" to BC
				add hl,hl			;shift left = "left shift" version in HL
				or b:or h:ld d,a	;D = ORed hibytes of all 3 versions
				xor b:ld b,a		;XOR this with original hibyte & save to B
				ld a,e:or c:or l:ld e,a	;E = ORed lowbytes of all 3 versions
				xor c:ld c,a		;XOR this with original lobyte & save to B
				pop hl				;get scraddr (start with rightmost byte)
				ld (hl),c:ld a,e	;M-Cc, A-Ee
				rld					;-> M-ce, A-EC (lonibble C & lonibble E)
				dec l				;middle scrbyte
				ld (hl),e			;M-Ee, A-EC
				rrd					;M-CE, A-XC	 (hi E - hi C)
				dec l				;left scrbyte
				ld (hl),b:ld a,d
				rld					;(lo D - lo B)
				inc l:inc l			;return to right byte
				call calc_nextscanline_hl
				ld c,l:ld b,h		;get scraddr back to bc
				pop hl				;restore sprite line addr (same pixelline)
				dec ixl				;dec total line counter
				pop af				;restore repetition counter
				sub #10				;instead of dec (counter is in left nibble)
				jr nz,txt_big_write_repeat
			inc hl:inc hl			;go to next pixel line
			cp ixl					;check if all lines drawn (a=0)
			jr nz,txt_big_write_char_lp
		pop bc:inc c:inc c:inc c	;advance 3 scrbytes for next character
		pop hl:inc hl				;next char in string
		pop af:dec a				;restore & count down length of string
		jr nz,txt_big_write_lp
	;after finishing writing, draw the fancy colored lines
	ex (sp),hl						;get original scraddr & push textaddress
	ld a,c							;get last (rightmost) address lowbyte
	sub l:ld c,a					;calc & save length of string in scrbytes
	dec l:dec l						;go to first scrbyte of the string
	Addbytetoreg 5*#08,h			;start with go 5th lines of text
	ld e,5							;repaint 5 lines
	txt_big_color_line:
		ld d,l						;backup
		ld b,c						;load length
		txt_big_chng_color:
			ld a,(hl):rrd 			;exchanging nibbles changes foregrd color
			inc l
			djnz txt_big_chng_color
		ld l,d						;restore
		call calc_nextscanline_hl
		bit 2,e						;if 5 or 4, leave out a line
			call nz,calc_nextscanline_hl
		dec e
		jr nz,txt_big_color_line
	pop hl							;restore end address of string
ret



;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                               CUT SCENES
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


;########################
;# MISSION END SEQUENCE #
;########################

csc_display_dialogue:
;hl=dialogue page
	push hl
	call screen_restore_backup		;redraw background
	call avatar_status_set_default	;initialize avatar positions
	call screen_set_avatars			;and show them
	pop hl							;restore dialogue page
	ld a,(hl):inc hl				;set 1st speaker
	ld (_dialogue_speaker),a
	ld b,a:call txt_set_pen			;set txt to his color
	ld b,4							;current text line (init 5)
	csc_dialogue_mainloop:
		ld c,(hl):inc hl 			;read amount of lines
		inc c						;if eot
	jp z,input_press_key			;exit
		dec c						;restore c
		push hl:push bc
		;calc starting address for the bubble
		ld h,b:ld l,0				;hl=line number*#100
		srl h:rr l:srl h:rr l		;hl=line number*#40
	_dialogue_speaker equ $+1		;1=wiz, 2=bot
		ld a,FOOBAR:dec a			;load bubble for active speaker
		ld de,__bubble_data_wiz
		jr z,$+5
			ld de,__bubble_data_bot
		call draw_bubble_add_offset	;add base scraddr to hl
		push hl						;save for text starting address
		call draw_bubble
		call draw_bubble_add_offset	;add offset for bubble tip
		ld b,12						;12 pixel lines for tip
		csc_bubble_tip_lines:
			call draw_bubble_tip:inc l	;left byte
			call draw_bubble_tip:dec l	;right byte
			call calc_nextscanline_hl
			djnz csc_bubble_tip_lines
		pop hl:ld de,#D841:add hl,de;restore address for text & adjust
		ex de,hl					;scraddr in de for txt routine
		pop bc:pop hl				;restore line counter & text address
		csc_dialogue_lines_lp:
			push bc:push de
			call txt_write_string
			pop de
			Addbytetoreg #40,e		;next char line (de+#40)
			jr nc,$+3:inc d
			pop bc					;restore counters
			inc b:dec c				;total line count+, this bubble's lines-
			jr nz,csc_dialogue_lines_lp
		inc b						;skip 1 line (space for the bubbles)
		ld a,(_dialogue_speaker)	;change speaker
		xor 3:ld (_dialogue_speaker),a	;(toggle 1/2)
		call txt_swap_pen
		jr csc_dialogue_mainloop

csc_mission_end_animation:
	call screen_restore_backup
	ld a,(_curr_mission):cp 3
	jr nz,csc_mission_cont		;first Larcenas Legacy citation:
		ld hl,__juez_bitmap			;	only after level 3, juez appears before
		ld (_time_machine_source),hl;time machine
		call csc_machine_appears
		call screen_draw_mission_bg_to_backup
		call csc_machine_vanishes
		ld hl,__machine_bitmap
		ld (_time_machine_source),hl
	csc_mission_cont:
	ld a,SONG_TIMEMACHINE
	call sound_select_tune
	call csc_machine_appears
	ld a,SONG_SILENCE
	call sound_select_tune
	xor a:call csc_ramp				;a=0 -> draw the ramp
	ld a,SCRMODE_CUTSCENE			;refresh avatars @ current coords
	ld (_status_screen),a
	ld a,106						;106 "steps" to the machine
		csc_avatars_walk_2_machine:
		ld hl,__stats_wiz+AV_Y_COORD
		push af
		rra:jr c,csc_aw2m_no_anim	;only animate every other frame
		and #F						;every 16 frames,
		jr nz,csc_aw2m_walk		;	change y coord (up)
			dec (hl)				;change y wiz
			ld l,#10+AV_Y_COORD:dec (hl)	;and bot
		csc_aw2m_walk:
		ld l,AV_X_COORD:inc (hl)	;wiz forward
		ld l,__stats_bot+AV_X_COORD
		dec (hl)					;bot forward, but in other direction
		and 1:add AVATAR_LEFT_EVEN	;choose sprite type
		inc hl:ld (hl),a			;save - first bot
		sub 2						;wiz looks right
		ld l,AV_SPRITETYPE
		ld (hl),a					;save wiz sprite
		csc_aw2m_no_anim:
		ld a,5:call wait_for_interrupt	;wait for cathode ray to be @ bottom
		pop af:dec a
		jr nz,csc_avatars_walk_2_machine

	halt							;avatars are drawn one last time,
	call screen_set_info			;and not erased
	call draw_machine_full			;but machine has to be drawn over them
	ld a,4:call csc_ramp			;a=4 -> erase the ramp
	ld a,SFX_DING:ld (_sfx_to_play),a	;*ding* and
	ld de,#D59B:ld hl,(txadr_curr_year)	;display destination year
	call txt_write_string			;on timemachine screen
	ld hl,#C5DB:ld bc,#0aFF			;(grey line under year label)
		ld (hl),c:inc l:djnz $-2
	dec b:call wait_bx2_halts		;#ff*2
	ld a,SONG_TIMEMACHINE
	call sound_select_tune
	call screen_draw_mission_bg_to_backup
	call csc_machine_vanishes
	call screen_restore_backup
	ld b,-1:jp wait_bx2_halts


csc_ramp:
	ld (_csc_ramp_sub_jump),a
	ld hl,#DDE7						;bot's ramp start
	ld e,#D8						;wiz's ramp start
	ld b,#11						;width of the ramps & colored mask
		csc_ramp_lp:
		call wait_frameflyback
		ld c,#DB:call csc_ramp_piece	;colored middle line
		ld c,#FF:call csc_ramp_piece	;bottom line grey
		inc l						;bot's ramp next right
		dec e						;wiz's ramp next left
		ld a,7						;every 8 bytes
		and l						;go down one step (2 lines)
		ld a,-8						;go 1 lines up (next step)
		jr z,$+3:add a				;go 2 lines up (same line)
		add h:ld h,a				;apply
		djnz csc_ramp_lp
	ret

csc_ramp_piece:
;draw or erase one byte-wide piece of the ramp
	Addbytetoreg 8,h	;line down
	ld d,h
_csc_ramp_sub_jump equ $+1		;0=draw or 4=delete
	jr $+2
	;draw ramp:
	ld a,c
	ld (hl),a
	ld (de),a
ret
	;erase ramp (bitmap in c is not used)
	ex de,hl
	call screen_restore_bg_byte
	ex de,hl
	jp screen_restore_bg_byte

;#######################
;# PROLOGUE & EPILOGUE #
;#######################

csc_show_prologue:
	xor a:ld hl,__csc_intro_data
	call csc_avatar_cutscene
	xor a:call sound_select_tune 	;play level 1 tune during dialogue
	ld hl,__intro_dialogue:ld b,5	;b=amount of intro dialogue pages
	intro_pages_lp:
		push bc
		call csc_display_dialogue
		pop bc
		djnz intro_pages_lp
	call screen_set_info
	call setup_mission_direct
	jp main_loop

csc_show_epilogue:
	ld hl,csc_ramp:push hl
	ld (hl),OPCODE_RET					;no time machine ramp in space
	call item_delete_all
	ld a,7:ld hl,__csc_outro_data
	call csc_avatar_cutscene
	ld hl,__colors_header
	ld de,__curr_mission_colors
	ld bc,4:ldir
	call screen_copy_bg_color
	ld a,3:call sound_select_tune		;mission 4 tune is the happiest one
	ld a,OPCODE_RET
	ld (sound_select_tune),a 			;don't ever change this song till the end
	ld hl,__outro_dialogue
	call csc_display_dialogue
	ld hl,__txt_last_msg				;save the address of last message
	ld (txadr_curr_year),hl				;to the year shortcut (for the display)
	pop hl:ld (hl),OPCODE_LDnnA			;restore opcode and draw ramp
	call csc_mission_end_animation

	ld a,#76							;opcode HALT
	ld (_delay_clearscreen),a
	ld hl,#C000:ld c,200
	call clear_part_of_screen
	call input_press_key
	jp 0

csc_avatar_cutscene:
;	input
;a = 0 for intro, 7 for outro
;hl = scene data table
	push hl:push af
	ld (_curr_mission),a
	call txt_set_pen_2
	call screen_set_black				;a returns 0
	ld (_curr_level),a					;set level 0 (for prologue)
	inc a:ld (_curr_game_mode),a		;game mode fun
	pop af:or a
	call nz,setup_mission_w_dialogue	;if flag=7
	call setup_mission_direct			;can be done twice
	call setup_level
	;make avatars invisible
	ld a,-1
	ld (__stats_wiz+AV_SPRITETYPE),a
	ld (__stats_bot+AV_SPRITETYPE),a
	ld a,SONG_INTRO
	call sound_select_tune
	call draw_mission_bg
	call screen_save_backup

	ld a,SCRMODE_INTRO
	ld (_status_screen),a
	pop de:dec de
	csc_choreo_lp:
	;de points to event and data
	;hl points to Y coord of active avatar
		inc de:ld a,(de)
		cp 2:jr c,csc_init_avatar	;0 & 1
		cp #EF:jp c,csc_avatar_walks;1-#EF normal walk of active avatar
		inc a						;if a=#FF
	ret z
		push hl								;following events can modify hl
		inc a:jr z,csc_turn_avatar			;#FE
		inc a:jr z,csc_text					;#FD
		inc a:jr z,csc_timemachine_appears	;#FC
		inc a:jr z,csc_toggle_draw_machine	;#FB
		inc a:call z,screen_start_flash		;#FA
		push de
		inc a:call z,csc_draw_items_epilogue;#F9
		inc a:call z,csc_delete_level_map	;#F8
		pop de
		;else/afterwards wait
		inc de:ld a,(de)				;amount of frames to wait
		ld b,a:call wait_frameflyback:djnz $-3

	csc_end_special_operation:
	pop hl
	jr csc_choreo_lp

csc_init_avatar:
	ld hl,__stats_wiz+AV_SPRITETYPE
	or a
	jr z,$+4	;if it's bot, don't skip
		ld l,__stats_bot+AV_SPRITETYPE
	ld (hl),AVATAR_FRONT
	inc de:dec hl:ld a,(de):ld (hl),a 	;x coord
	inc de:dec hl:ld a,(de):ld (hl),a	;y coord
	jr csc_choreo_lp

csc_toggle_draw_machine:
	ld hl,_status_screen
	ld a,(hl):xor #80:ld (hl),a 		;swap machine fg bit
	jr csc_end_special_operation

csc_timemachine_appears:
	push de:call csc_machine_appears
	pop de:jr csc_end_special_operation

csc_text:
	inc de:push de
	call clear_status_line
	pop hl
	ld d,SCRBASE_STATUS/#100:ld e,(hl)	;get x address
	inc hl:call txt_write_string
	ex de,hl:dec de
	jr csc_end_special_operation

csc_turn_avatar:
	push de
	ld de,__csc_turn_data
	inc l:inc l						;spritetype
	ld c,8
		turn_anim_lp:
		ld a,(de):inc de:ld (hl),a	;read & set next sprite
		ld b,30:call wait_bx2_halts
		dec c:jr nz,turn_anim_lp
	pop de
	dec l:dec l						;y-coord
	jr csc_end_special_operation

csc_delete_level_map:
	xor a:ld hl,__curr_level_map+160
	dec l:ld (hl),a:jr nz,$-2
	call screen_draw_mission_bg_to_backup
	ret

csc_avatar_walks:
	inc de:push de
	push af 						;backup amount of steps
	ld a,(de)						;read movement info byte
	ld c,3:call csc_calc_value_init	;set sprite happy=0, right=3, left=4
	add a:jr nz,$+3:inc a:ld e,a	;convert to 0,7,9 and save base sprite
	ld c,OPCODE_INC_M				;set "base" opcode ([dec m]=[inc m]+1)
	call csc_calc_value				;isolate y opcode
	ld (_csc_walk_y_offset),a		;and SMC it
	call csc_calc_value				;isolate x opcode
	ld (_csc_walk_x_offset),a		;and SMC it
	ld a,d:rra:rra:and 3			;isolate slope value -> 2bit code:
	ld d,1							;	0 means 3, 1->7, 2->15, 3->31
	scf:rl d:dec a:jp p,$-4			;shift this value into d
	pop bc							;restore amount of steps -> b

	csc_walk_lp:
		push hl:push bc
		rr b:jr c,csc_walk_no_update;only animate @ even values
		ld a,d:and b 				;AND b with the slope-value
		jr nz,$+3					;if 0, change y
		_csc_walk_y_offset:			;or inc(hl) or dec(hl)
			nop						;apply change y
		inc hl						;-> x-coord
	_csc_walk_x_offset:	nop			;apply chanhge x
		inc hl						;-> sprite type
		ld a,e						;restore base sprite type
		rr b:sbc 0:ld (hl),a		;change even/odd according to b

		csc_walk_no_update:
		call wait_frameflyback
		pop bc:pop hl				;restore counter & avatar pointer
		djnz csc_walk_lp
	pop de							;restore curr data address
	jp csc_choreo_lp

	csc_calc_value:
		ld a,d:rra:rra				;shift 2 left
	csc_calc_value_init:
		ld d,a:and 3				;backup in d and isolate bits 0&1
	ret z							;if 0 leave it ("NOP")
		and 1:add c					;2->0 & add to base opcode/sprite
	ret

csc_draw_items_epilogue:
	ld a,TILE_ENEMY
	ld (__curr_level_map+151),a		;and cauldron
	ld hl,sprite_items_odd
	ld de,#E581:ld b,7
	ld c,2
	csc_draw_items_lp:
		push bc:push hl:push de
		call draw_item
		pop de:pop hl:pop bc
		Addbytetoreg 30,l
		Addbytetoreg 3,e
		djnz csc_draw_items_lp
		dec c
		ret z
		inc h:ld l,b
		ld de,#E5AA:ld b,7
		jr csc_draw_items_lp



;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                               INPUT PROCESSING
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


input_wait_key:
	halt
	ld a,(_user_input):or a			;wait until no key is pressed
	jr nz,input_wait_key

input_wait_key_wait:
	halt
	ld a,(_user_input):or a			;wait until a key is pressed
	jr z,input_wait_key_wait
	ret

input_press_key:
	push hl
	ld hl,input_scan_kb_lines
	ld (_input_routine),hl			;accept ANY key
	ld c,1
	ld hl,SCRBASE_GAME+#2C47		;address for bubble
	call draw_bubble_bot			;
	ld de,SCRBASE_GAME+#49A 		;
	call txt_set_pen_2
	ld hl,__text_press_key
	call txt_write_string
	call input_wait_key
	ld hl,input_read_active_device	;set back to selected input device
	ld (_input_routine),hl
	call clear_status_line
	pop hl
ret

input_scan_kb_lines:
;scan the whole keyboard and for input
;returns line in (scanned_keyline) and key bitmask in a
	call input_initialize_read
	ld c,#49						;start with line 9
		input_scan_lp:
		ld b,#F6:out (c),c			;out line
		ld b,#F4:in a,(c)			;in bitmask
		cpl:or a					;check if a=0
		jr nz,input_scan_keypress
		dec c:bit 5,c				;if c=#3F, all lines are scanned
		jr z,input_scan_lp
	input_scan_keypress:
	ld hl,scanned_keyline:ld (hl),c	;save line
	jr input_close_read

input_read_active_device:
;reads keys defined in input_keymap
;returns them in a & d, stored like in the joystick line, but inverted
;bit  5     4    3     2    1    0
;key abort fire right left down up
	call input_initialize_read
	ld a,(__text_input)		;get first character of input text
	ld hl,__keyboard_keymap			;by default, set keyboard
	rra								;if "K" (Keyboard), bit 0 is set
	jr c,$+5						;then skip
		ld hl,__joystick_keymap		;else load joystick map
	ld de,#0006						;d=output byte, e=counter
	input_read_next_key:
		call input_read_key_value
		jr z,$+3:scf				;if key is pressed, it's 1...
		rr d						;shift in d
		dec e						;count down the 6 bits
		jr nz,input_read_next_key
	ld a,d:rrca:rrca:ld d,a			;copy to a and complete full shift

_symmetric_mvt_toggle equ $+1		;symmetric movement
	jr input_close_read				;by default, skip this

	res 4,a							;disable fire button
	ld hl,_avatar_starting			;check if starting avatar
	bit 4,(hl)						;is bot next time
_sym_mvt_mission6:					;z/nz has to be inverted in mission 6
	jr nz,input_close_read
		xor %11100:ld d,a			;if so, invert fire,left & right
	;fall through

input_close_read:
	ld bc,#F782:out (c),c			;close port
	ld bc,#F600:out (c),c			;(reset write)
ret

input_read_key_value:
;returns nz if this key is pressed
	ld b,#F7:outi 					;set kb line
	ld b,#F4:in a,(c)				;read value
	cpl:and (hl):inc hl				;and with required bit
	ret

input_initialize_read:
	ld bc,#F40E:out (c),c
	ld b,#B6:in a,(c)
	and #30:ld c,a
	or #C0:out (c),a
	inc b:ld a,#92:out (c),a
ret

input_read_numbers:
;reads a number key (upper row AND f-keys) and returns it's ascii in a
	call input_initialize_read
	ld hl,__num_keymap				;the num and f key are consevutive
	ld d,20							;10 digits x 2 key groups
	input_read_next_num:
		call input_read_key_value
		jr nz,input_num_pressed		;finish if it matches
	dec d
	jr nz,input_read_next_num
	jr input_close_read				;no valid input
	input_num_pressed:
	ld a,d:add ASCII0*2-1:rra		;convert to "ASCII" code
	jr input_close_read


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                                MUSIC AND SFX
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

;(the main player routines by Targhan are in dd-sound.asm)

sound_select_tune:
;tune starts to play only if it's a nother than the one running
;input a=tune nr
	push hl
	ld hl,__text_music				;first check if music is on
	bit 3,(hl)						;difference between (O)"N" and (O)"F"(F)
	jr nz,$+4:ld a,SONG_SILENCE
	ld hl,_curr_tune:cp (hl)		;check if new tune
	ld (hl),a:ld hl,ddmusic			;setup in case call happens
	call nz,PLY_AKM_INIT 			;only if new tune
	pop hl
ret

sound_play_effect:
;play effect saved in _sfx_to_play, if there is any
_sfx_to_play equ $+1
	ld a,FOOBAR
	or a							;check if value set
ret z
	ld hl,__text_sfx				;check if sfx are on
	bit 3,(hl)						;the difference between (O)"N" and (O)"F"(F)
ret z
	ld hl,_current_sfx_channel		;rotate through the 3 channels
	dec (hl)
	jp p,set_sfx_channel
		ld (hl),2
	set_sfx_channel:
_current_sfx_channel equ $+1
	ld bc,#0002						;b=vol 0, c=channel (SMC)
	ld hl,_sfx_to_play:ld (hl),b	;reset byte for next time
	jp PLY_akm_PlaySoundEffect		;(a=sfx number)


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                                   INTERRUPTS
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

interrupt_handler:
	di
	push ix:push iy
	exx:ex af,af'
_curr_interrupt equ $+1				;counting through the interrupts
	ld a,0
	dec a:jp p,$+5
		ld a,5
	ld (_curr_interrupt),a			;save for next time
	jp z,interrupt5
	dec a:jr z,interrupt4
	dec a:jr z,interrupt3
	dec a:jr z,interrupt2
	dec a:jr z,interrupt1
	;fall through

interrupt0:
	ld bc,#7FAC:out (c),c			;mode 0
	ld c,#10:ld a,#54				;border 0 (in case we had a raster)
	out (c),c:out (c),a

_status_screen equ $+1
	ld a,FOOBAR:rra 				;STBIT_GAME_RUNNING in carry
	call c,draw_items_all
	jr interrupt_end

interrupt1:
	ld a,(_status_screen):and %1001	;STBIT_DRAW_AVATARS or STBIT_GAME_RUNNING
	call nz,draw_avatars_both
	jr interrupt_end

interrupt2:
	ld a,(_status_screen):push af
	call screen_change_under_header
_input_routine equ $+1						;read and save input
	call input_read_active_device
	ld (_user_input),a
	pop af									;Mrestore screen status
	rlca:jr nc,not_machine_fg
		ld hl,(__stats_wiz+AV_Y_COORD)		;draw the time machine
		call draw_machine_part_over_avatar	;over the sprites
		ld hl,(__stats_bot+AV_Y_COORD)
		call draw_machine_part_over_avatar
		jr interrupt_end
	not_machine_fg:
	rrca:push af
	bit STBIT_SHOW_ANIM,a
		call nz,anim_background_objects
	pop af
	rrca:jr nc,interrupt_end			;STBIT_GAME_RUNNING in carry
	call game_clocks_process		;returns with m set if item clock was 0
	call m,item_process_movement
	jr interrupt_end

interrupt3:							;SOUND (Arkos' AKM Player)
;for the sound routines, back up the other pair of registers, too
	exx:ex af,af'
	push af:push bc:push de:push hl
	call sound_play_effect
	call PLY_AKM_Play
	pop hl:pop de:pop bc:pop af
	exx:ex af,af'
	jr interrupt_end

interrupt4:
	call anim_avatar_faces
	ld a,(_status_screen):rra 		;STBIT_GAME_RUNNING in carry
	jr nc,interrupt_end
	call screen_japan_water
	call avatar_process_movement
	jr interrupt_end

interrupt5:
	call screen_change_under_gamefield
	ld a,(_status_screen):push af
	rra:call c,erase_items_all 		;STBIT_GAME_RUNNING in carry
	pop af:bit STBIT_DRAW_AVATARS,a
	call nz,erase_avatars_both
	;fall through

interrupt_end:
	pop iy:pop ix
	exx:ex af,af'
	ei
reti


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                                   INCLUDES, II
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ddmusic:
read "dd-sound.asm"
read "dd-data2.asm"

endfile equ $

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;                                   VARIABLES
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

;stored mostly in the unused areas of the backup screen

org #9600
__machine_bitmap:
ds TIMEMACHINE_WDTH*TIMEMACHINE_HGHT*2
org #9E00
__juez_bitmap:
ds TIMEMACHINE_WDTH*16

org #A600
__stats_avatars:
__stats_wiz:
	ds 16,0
__stats_bot:
	ds 16,0
_counter_item_streak:
	db 0
_counter_delay_new_item:
	db 0
_clock_item:
	db 0
_curr_tune:
	db 0
_clock_game_timer:
	db 0
_score_bcd:
	db 0,0,0
_points_to_add:
	db 0
_clock_anim_wiz_eyes:
	db 0
_clock_anim_bot_screen:
	db 0
anim_machine_delay:
	db 0
__curr_bg_color:
	ds 3,0
__curr_mission_colors:
	ds 4,0
__anim_sparkle_table:
	ds 16,0	;8 scraddresses (words)
	dw 0	;1 end of list 0

org #A700
__list_items:
	ds MAX_ITEMS*8,0
	;0 status/direction
	;1 y
	;2 x
	;3 spriteadr low
	;4 spriteadr high

__items_allowed_origins:
	db 0 	;first byte = length of table
	ds 24	;lo nibble = direction (1-4), hi nibble = origin region (0-6 or 0-3)
__items_to_erase:
	ds MAX_ITEMS*2+2,0
; more

org #A800
;don't change the order, access is hardcoded!!!
__curr_mission_tiles:
__curr_platforms:
ds #30,0
__curr_ladder:
ds #10,0
__curr_obstacles:
ds #C0,0

org #AE00
;must not cross page boundary
__curr_enemy_sprites:
__enemyR2:
ds 64,0
__enemyR1:
ds 64,0
__enemyR0:
ds 64,0
__enemies_mirrored:
ds 3*64,0
;L0, L1, L2

org #B600
__curr_level_map:
ds 16*11,0

org #BE00
__curr_bg_map:
ds 16*11,0
;explain enemies here
