;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;<    |'\   |'\   |  |  |  |'\               |     |'\   |'\    /'\  |  |'\    >
;<    |  \  | /   |  |  |  |  \              |     |  \  | /   |  |  |  |  \   >
;<    |  /  | \   |  |  |  |  /     '| |'\  /|     |  /  | \   |  |  |  |  /   >
;<    |_/   |  \  \_/   |  |_/     ( | | | |_|     |_/   |  \  \_/   |  |_/    >
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;<    A game for Amstrad CPC by Leosoft.       Code, gfx & music by Arnolde    >
;<                     === Entry for CPCRetrodev 2022 ===                      >
;vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;	dd-data2.asm - graphics data
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

__screen_dimension:
;values for crtc, read by init_start_program
;	64wide,	ver al,	hor al,	fine alignment
db 	1,#20,	2,#2A,	7,#1E,	5,5

;##############################################
;# GRAPHICS AND DATA FOR THE (SPEECH) BUBBLES #
;##############################################

__bubble_data_bot:
dw #F00c		;base screenaddress
db #47,#0F,#2E,#8C,#00,#13,#08,#00,#01,#8C,#00,#13,#47,#0F,#2E
dw -#801+BUBBLE_WDTH
db #00,#0E,#00,#01,#CC,#13,#00,#01,#CC,#23,#00,#01,#EE,#01,#00,#89
db #EE,#11,#00,#09,#FF,#00,#4D,#FF,#00,#8D,#FF,#88,#27,#FF,#88,#47
db #FF,#CC,#03,#FF,#CC,#23,#FF,#EE,#01
__bubble_data_wiz:
dw #F002		;base screenaddress
db #74,#F0,#E2,#C8,#00,#31,#80,#00,#10,#C8,#00,#31,#74,#F0,#E2
dw -#7FF ;offset for tip
db #00,#80,#00,#70,#00,#80,#33,#C8,#00,#80,#33,#C4,#00,#91,#77,#80
db #00,#90,#77,#88,#00,#B2,#FF,#00,#B1,#FF,#11,#E4,#FF,#11,#E2,#FF
db #33,#C0,#FF,#33,#C4,#FF,#77,#80,#FF


;#########
;# FONTS #
;#########

__font_regular:	;first byte = Width 0=2px,1=4px,2=6px
db #02,#75,#C4,#D8,#62,#A0,#A0,#A0,#A0,#D8,#62,#75,#C4,#00,#00 ;0 (3)
db #02,#32,#C8,#74,#C0,#50,#40,#10,#40,#10,#40,#10,#40,#00,#00 ;1 (4)
db #02,#F8,#E2,#80,#20,#11,#64,#F8,#E2,#80,#00,#F0,#E0,#00,#00
db #02,#F0,#E0,#10,#62,#31,#C4,#10,#62,#80,#20,#F8,#E2,#00,#00
db #02,#62,#A8,#C8,#20,#C4,#20,#F0,#E0,#00,#20,#00,#20,#00,#00
db #02,#F0,#E2,#80,#00,#F0,#E2,#00,#20,#80,#20,#F8,#E2,#00,#00
db #02,#F8,#E2,#80,#00,#F0,#E2,#80,#20,#80,#20,#F8,#E2,#00,#00 ;6 (9)
db #02,#F0,#E0,#00,#20,#10,#62,#10,#40,#31,#C4,#64,#80,#00,#00 ;7 (:
db #02,#F8,#E2,#80,#20,#F8,#E2,#80,#20,#80,#20,#F8,#E2,#00,#00 ;8 (;)
db #02,#F8,#E2,#80,#20,#80,#20,#F8,#E0,#00,#20,#F8,#E2,#00,#00 ;9 (<)
db #02,#00,#00,#00,#00,#00,#00,#F0,#E0,#00,#00,#00,#00,#00,#00 ;- (=)
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#80,#00,#00,#00 ;. (>)
db #02,#F8,#E2,#80,#20,#00,#20,#30,#E2,#22,#88,#20,#80,#00,#00 ;?
db #02,#EA,#88,#A0,#80,#EA,#A8,#B1,#E6,#90,#40,#E8,#A0,#00,#00 ;# (@)
db #02,#20,#80,#75,#C4,#50,#40,#F8,#E2,#D5,#64,#80,#20,#00,#00 ;A
db #02,#F0,#E2,#80,#20,#F0,#E2,#80,#20,#80,#20,#F0,#E2,#00,#00 ;B
db #02,#F8,#E2,#80,#20,#80,#00,#80,#00,#80,#20,#F8,#E2,#00,#00
db #02,#F1,#C4,#90,#62,#80,#20,#80,#20,#80,#20,#F0,#E2,#00,#00
db #02,#F0,#E0,#80,#00,#F0,#C0,#80,#00,#80,#00,#F0,#E0,#00,#00
db #02,#F0,#E0,#80,#00,#F0,#C0,#80,#00,#80,#00,#80,#00,#00,#00
db #02,#F8,#E2,#80,#20,#80,#00,#90,#60,#80,#20,#F8,#E0,#00,#00
db #02,#80,#20,#80,#20,#F0,#E0,#80,#20,#80,#20,#80,#20,#00,#00
db #01,#E0,#80,#40,#00,#40,#00,#40,#00,#40,#00,#E0,#80,#00,#00
db #02,#10,#60,#00,#20,#00,#20,#88,#20,#C4,#20,#70,#E2,#00,#00
db #02,#90,#62,#B1,#C4,#E2,#88,#A0,#80,#90,#40,#80,#20,#00,#00
db #02,#80,#00,#80,#00,#80,#00,#80,#00,#80,#00,#F0,#E0,#00,#00
db #02,#D5,#64,#F2,#E8,#F5,#E4,#A2,#A8,#80,#20,#80,#20,#00,#00
db #02,#C4,#20,#E2,#A8,#F5,#E4,#B2,#E8,#91,#64,#80,#20,#00,#00
db #02,#F8,#E2,#80,#20,#80,#20,#80,#20,#80,#20,#F8,#E2,#00,#00 ;O
db #02,#F0,#E2,#80,#20,#80,#20,#F0,#E2,#80,#00,#80,#00,#00,#00 ;P
db #02,#F8,#E2,#80,#20,#80,#20,#A2,#A8,#A0,#A0,#F8,#E2,#10,#62
db #02,#F0,#E2,#80,#20,#80,#20,#F0,#E2,#B1,#C4,#B2,#E8,#00,#00
db #02,#F8,#C0,#80,#00,#F8,#E2,#00,#20,#80,#20,#F8,#E2,#00,#00
db #02,#F0,#E0,#20,#80,#20,#80,#20,#80,#20,#80,#20,#80,#00,#00
db #02,#80,#20,#80,#20,#80,#20,#80,#20,#80,#20,#F8,#E2,#00,#00
db #02,#80,#20,#D5,#64,#D8,#62,#50,#40,#75,#C4,#20,#80,#00,#00
db #02,#80,#20,#80,#20,#A0,#A0,#FD,#E6,#FA,#EA,#50,#40,#00,#00
db #02,#80,#20,#D8,#62,#75,#C4,#75,#C4,#D8,#62,#80,#20,#00,#00
db #02,#80,#20,#80,#20,#D8,#62,#75,#C4,#20,#80,#20,#80,#00,#00
db #02,#F0,#E0,#10,#62,#31,#C4,#62,#88,#C4,#00,#F0,#E0,#00,#00 ;Z
db #00,#00,#00,#00,#00,#80,#00,#00,#00,#80,#00,#00,#00,#00,#00 ;: ;([)
db #02,#00,#00,#00,#20,#10,#40,#20,#80,#40,#00,#80,#00,#00,#00 ;/ (\)
db #01,#00,#00,#00,#00,#00,#00,#00,#00,#20,#80,#64,#80,#40,#00 ;, (])
db #00,#80,#00,#80,#00,#80,#00,#80,#00,#00,#00,#80,#00,#00,#00 ;! (^)
db #01,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00 ;spc (_)
db #00,#C4,#00,#80,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00 ;' (`)`
db #02,#00,#00,#F8,#E2,#00,#20,#F8,#E0,#80,#20,#F8,#E0,#00,#00 ;a
db #02,#80,#00,#F4,#E2,#C4,#20,#80,#20,#80,#20,#F0,#E2,#00,#00 ;b
db #02,#00,#00,#F8,#E2,#80,#20,#80,#00,#80,#20,#F8,#E2,#00,#00
db #02,#00,#20,#F9,#E4,#91,#64,#80,#20,#80,#20,#F8,#E0,#00,#00
db #02,#00,#00,#F8,#E2,#80,#20,#F0,#E0,#80,#00,#F8,#E2,#00,#00
db #01,#64,#80,#40,#00,#E0,#80,#40,#00,#40,#00,#40,#00,#00,#00
db #02,#00,#00,#F8,#E0,#80,#20,#80,#20,#F8,#E2,#00,#20,#F8,#E2
db #02,#80,#00,#F4,#E2,#C4,#20,#80,#20,#80,#20,#80,#20,#00,#00
db #00,#80,#00,#00,#00,#80,#00,#80,#00,#80,#00,#80,#00,#00,#00
db #01,#20,#80,#00,#00,#20,#80,#20,#80,#20,#80,#62,#88,#C4,#00
db #02,#80,#00,#90,#62,#B1,#C4,#E2,#88,#B2,#C8,#91,#64,#00,#00
db #00,#80,#00,#80,#00,#80,#00,#80,#00,#80,#00,#80,#00,#00,#00
db #02,#00,#00,#F2,#EA,#A0,#A0,#A0,#A0,#A0,#A0,#A0,#A0,#00,#00
db #02,#00,#00,#F4,#E2,#C4,#20,#80,#20,#80,#20,#80,#20,#00,#00
db #02,#00,#00,#F8,#E2,#80,#20,#80,#20,#80,#20,#F8,#E2,#00,#00
db #02,#00,#00,#F0,#E2,#80,#20,#80,#20,#C4,#20,#F4,#E2,#80,#00
db #02,#00,#00,#F8,#E0,#80,#20,#80,#20,#91,#64,#F9,#E4,#00,#20
db #02,#00,#00,#F4,#E2,#C4,#20,#80,#00,#80,#00,#80,#00,#00,#00
db #02,#00,#00,#F8,#C0,#80,#00,#F8,#E2,#00,#20,#F8,#E2,#00,#00
db #01,#40,#00,#40,#00,#E0,#80,#40,#00,#62,#88,#64,#80,#00,#00
db #02,#00,#00,#80,#20,#80,#20,#80,#20,#91,#64,#F9,#E4,#00,#00
db #02,#00,#00,#80,#20,#D5,#64,#D8,#62,#72,#C8,#20,#80,#00,#00
db #02,#00,#00,#80,#20,#A2,#A8,#A0,#A0,#F5,#E4,#FA,#EA,#00,#00
db #02,#00,#00,#80,#20,#D8,#62,#75,#C4,#D8,#62,#80,#20,#00,#00
db #02,#00,#00,#80,#20,#80,#20,#91,#64,#F9,#E4,#00,#20,#F8,#E2
db #02,#00,#00,#F0,#E0,#32,#C8,#20,#80,#62,#88,#F0,#E0,#00,#00 ;z
CHARS_TOTAL equ $-__font_regular/15

__font_big:
;in a compressed, monochrome format
db #10,#7C,#10,#FE,#11,#C7,#61,#83,#11,#C7,#10,#FE,#10,#7C	;0/O
db #10,#0C,#10,#1C,#10,#3C,#10,#6C,#10,#CC,#70,#0C ;1
db #10,#7C,#10,#FE,#11,#C7,#11,#83,#10,#03,#10,#07,#10,#7E,#10,#FC,#11,#C0,#11,#80,#21,#FF
db #11,#FF,#11,#FE,#10,#0C,#10,#18,#10,#30,#10,#7E,#10,#07,#10,#03,#11,#83,#11,#C7,#10,#FE,#10,#7C
db #20,#33,#20,#63,#20,#C3,#21,#FF,#40,#03
db #20,#FE,#20,#C0,#10,#FC,#10,#FE,#10,#07,#10,#03,#11,#83,#11,#C7,#10,#FE,#10,#7C
db #10,#7C,#10,#FE,#11,#C0,#11,#80,#11,#FC,#11,#FE,#11,#87,#21,#83,#11,#C7,#10,#FE,#10,#7C
db #21,#FF,#20,#03,#20,#06,#20,#0C,#20,#18,#20,#30
db #10,#7C,#10,#FE,#20,#C6,#10,#7C,#10,#FE,#11,#C7,#21,#83,#11,#C7,#10,#FE,#10,#7C
db #10,#7C,#10,#FE,#11,#C7,#21,#83,#11,#C3,#10,#FF,#10,#7F,#10,#03,#10,#07,#10,#FE,#10,#7C	;9
db #20,#10,#20,#38,#30,#6C,#20,#FE,#31,#83	;A
db #11,#FC,#11,#FE,#21,#87,#21,#FE,#11,#87,#21,#83,#11,#87,#11,#FE,#11,#FC ;B
db #10,#7C,#10,#FE,#11,#C7,#11,#83,#41,#80,#11,#83,#11,#C7,#10,#FE,#10,#7C ;C
db #11,#F0,#11,#FC,#11,#8E,#11,#86,#51,#83,#11,#87,#11,#FE,#11,#FC ;D
db #21,#FF,#21,#80,#21,#FC,#41,#80,#21,#FF ;E
db #21,#FF,#21,#80,#21,#FC,#61,#80 ;F
db #10,#7C,#10,#FE,#11,#C7,#11,#83,#21,#80,#21,#8F,#11,#83,#11,#C3,#10,#FF,#10,#7F ;G
db #41,#83,#21,#FF,#61,#83 ;H
db #20,#FC,#80,#30,#20,#FC	;I
db #41,#83,#21,#93,#20,#D6,#20,#FE,#10,#6C,#10,#44	;W
db #30,#00,#20,#C0,#30,#00,#20,#C0,#20,#00; :
db #A1,#80,#21,#FF	;L
db #11,#01,#11,#83,#11,#C7,#11,#EF,#11,#BB,#11,#93,#61,#83 ;
db #21,#83,#11,#C3,#11,#E3,#11,#B3,#11,#9B,#11,#8F,#11,#87,#41,#83
db #A0,#00,#20,#FE	;_
db #11,#FC,#11,#FE,#11,#87,#21,#83,#11,#87,#11,#FE,#11,#FC,#41,#80	;P
db #C0,#00	;space
db #11,#FC,#11,#FE,#11,#87,#21,#83,#11,#87,#11,#FE,#11,#FC,#11,#B0,#11,#B8,#11,#9F,#11,#8F ;R
db #10,#7C,#10,#FE,#20,#C0,#10,#FC,#10,#7E,#10,#07,#10,#03,#11,#83,#11,#C7,#10,#FE,#10,#7C
db #11,#FE,#11,#FE,#A0,#30
db #91,#83,#11,#C7,#10,#FE,#10,#7C
db #31,#83,#50,#C6,#20,#38,#20,#10	;V

;####################
;# BACKGROUND TILES #
;####################

align #4
__bg_meta_tiles:
;Every meta-tile is composed of 4 sub-tiles (indexed)
db #00,#00,#00,#00		;meta-tile 0
db #01,#02,#03,#04		;meta-tile 1
db #05,#06,#07,#08		;etc.
db #09,#0A,#0B,#0C
db #0D,#0E,#0F,#10,#11,#12,#13,#14,#15,#16,#17,#18,#19,#1A,#19,#1A
db #1B,#1A,#1B,#1A,#1C,#1C,#1D,#1D,#1E,#1E,#1F,#1F,#20,#21,#20,#21
db #22,#23,#24,#25,#26,#27,#28,#29,#27,#27,#2A,#2A,#27,#2B,#2C,#2D
db #2E,#2F,#30,#31,#32,#33,#34,#35,#36,#37,#36,#37,#37,#38,#37,#38
db #00,#39,#39,#00,#3A,#00,#00,#3A,#3B,#3C,#3D,#3E,#3F,#40,#41,#42
db #43,#44,#45,#46,#47,#48,#41,#49,#3A,#00,#4A,#3A,#3A,#00,#4B,#3A
db #4C,#4D,#4E,#4F,#50,#51,#52,#53,#00,#39,#39,#54,#00,#39,#39,#55
db #56,#56,#57,#57,#56,#58,#57,#59,#5A,#56,#5B,#57,#00,#19,#5C,#5D
db #5E,#00,#5F,#5C,#60,#61,#62,#63,#00,#00,#64,#65,#00,#00,#66,#67
db #00,#00,#68,#69,#00,#00,#5C,#5C,#6A,#6B,#6C,#00,#6D,#6E,#00,#6F
db #6E,#00,#6F,#00,#00,#6A,#00,#6C,#70,#71,#72,#73,#00,#00,#74,#75
db #76,#00,#77,#00,#00,#78,#00,#79,#00,#77,#00,#76,#7A,#00,#78,#00
db #7B,#70,#7C,#7D,#7E,#7F,#7B,#70,#80,#81,#82,#83,#84,#85,#86,#87
db #88,#88,#89,#89,#8A,#8A,#89,#89,#8B,#8C,#8D,#8E,#8F,#90,#91,#92
db #00,#00,#93,#94,#00,#00,#95,#96,#97,#98,#99,#9A,#57,#57,#95,#96
db #9B,#9C,#9D,#9E,#9F,#A0,#A1,#A2,#00,#00,#A1,#A2,#A3,#00,#A2,#9D
db #00,#00,#9D,#A4,#00,#A5,#A4,#A2,#A6,#A7,#A4,#A4,#A8,#A9,#A4,#A4
db #00,#00,#A4,#A4,#00,#00,#00,#AA,#AB,#AC,#AD,#AE,#00,#00,#AF,#00
db #85,#00,#B0,#00,#00,#84,#00,#B1,#B2,#B3,#B1,#B1,#B4,#B3,#B1,#B1
db #B5,#B6,#B7,#B8,#B9,#BA,#BB,#BC,#BB,#00,#BD,#00,#BE,#00,#BF,#BB
db #00,#00,#67,#00,#C0,#C1,#B1,#B1,#85,#84,#B1,#B1,#C2,#C3,#C4,#C4
db #BF,#BB,#C0,#C1,#C5,#BB,#C0,#C1,#BF,#C6,#C0,#C1,#C5,#C6,#C1,#C0
db #C0,#C1,#C1,#C0,#C7,#00,#00,#C8,#C9,#CA,#CB,#CC,#C9,#CD,#CB,#CE
db #CF,#D0,#D1,#D2,#00,#00,#D1,#D3,#CF,#D4,#00,#00,#D5,#D0,#D6,#D2
db #D5,#D7,#D6,#D8,#D9,#DA,#DB,#DC,#DD,#DE,#DF,#00,#00,#E0,#50,#E1
db #00,#C8,#00,#00

__bg_sub_tiles:
;8 bytes form 1 monochrome 8x8 tile
db #00,#00,#00,#00,#00,#00,#00,#00	;sub-tile 0
db #00,#00,#00,#01,#02,#05,#09,#10	;sub-tile 1 ... etc.
db #00,#1F,#68,#A4,#22,#A1,#91,#17,#1F,#20,#30,#48,#46,#41,#59,#59
db #89,#59,#25,#55,#8B,#C5,#3B,#07,#00,#F8,#06,#C5,#C9,#11,#11,#E1
db #00,#00,#00,#80,#40,#20,#10,#68,#31,#2A,#44,#4A,#53,#AC,#D0,#FF
db #68,#04,#3C,#C2,#06,#8A,#92,#E2,#DC,#A0,#D3,#A1,#AA,#A4,#9A,#91
db #9A,#9A,#82,#62,#12,#0C,#04,#F8,#E8,#89,#85,#44,#25,#16,#F8,#00
db #08,#90,#A0,#40,#80,#00,#00,#00,#47,#49,#51,#60,#43,#3C,#20,#16
db #FF,#0B,#35,#CA,#52,#22,#54,#8C,#16,#08,#04,#02,#01,#00,#00,#00
db #87,#88,#88,#93,#A3,#60,#1F,#00,#00,#01,#02,#04,#08,#11,#12,#12
db #C0,#20,#10,#08,#C4,#22,#12,#12,#14,#14,#14,#14,#14,#14,#14,#14
db #0A,#0A,#0A,#0A,#0A,#0A,#0A,#0A,#15,#14,#14,#14,#14,#14,#14,#14
db #5A,#0A,#0A,#0A,#0A,#0A,#0A,#0A,#16,#14,#14,#14,#14,#14,#14,#14
db #AA,#0A,#0A,#0A,#0A,#0A,#0A,#0A,#04,#04,#04,#04,#04,#04,#04,#04
db #90,#90,#90,#90,#90,#90,#90,#90,#84,#84,#84,#84,#84,#84,#84,#84
db #FF,#00,#00,#00,#FF,#00,#00,#00,#00,#00,#22,#55,#55,#88,#88,#88
db #88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#FF
db #11,#11,#11,#11,#11,#11,#11,#11,#44,#44,#44,#44,#44,#44,#44,#44
db #7F,#40,#7F,#40,#40,#40,#7F,#20,#FF,#01,#FF,#01,#01,#01,#FF,#02
db #1F,#04,#04,#04,#04,#04,#04,#04,#FC,#90,#90,#90,#90,#90,#90,#90
db #00,#00,#00,#00,#01,#01,#01,#01,#00,#00,#00,#00,#FF,#00,#00,#00
db #01,#01,#01,#01,#01,#03,#05,#09,#00,#00,#FF,#00,#00,#38,#44,#44
db #00,#00,#FF,#00,#00,#00,#00,#00,#00,#00,#00,#00,#C0,#40,#40,#40
db #00,#00,#FF,#00,#00,#0E,#11,#11,#40,#40,#C0,#40,#40,#60,#50,#48
db #00,#00,#00,#00,#00,#00,#01,#02,#01,#06,#18,#20,#40,#80,#03,#04
db #04,#08,#08,#10,#10,#20,#20,#20,#08,#12,#10,#14,#10,#09,#04,#03
db #80,#60,#18,#04,#02,#01,#C0,#20,#00,#00,#00,#00,#00,#00,#80,#40
db #90,#08,#28,#08,#48,#10,#20,#C0,#20,#10,#10,#08,#08,#04,#04,#04
db #90,#90,#90,#9F,#90,#90,#90,#9F,#00,#00,#00,#FF,#00,#00,#00,#FF
db #09,#09,#09,#F9,#09,#09,#09,#F9,#01,#02,#04,#08,#10,#20,#40,#80
db #80,#40,#20,#10,#08,#04,#02,#01,#00,#FF,#00,#00,#FF,#00,#FF,#00
db #00,#00,#00,#00,#FF,#00,#FF,#00,#04,#00,#08,#00,#F0,#00,#00,#FF
db #20,#00,#10,#00,#0F,#00,#00,#FF,#00,#FF,#00,#20,#00,#10,#00,#0F
db #00,#FF,#00,#04,#00,#08,#00,#F0,#00,#00,#FF,#00,#FF,#00,#00,#00
db #00,#00,#FF,#00,#FF,#42,#00,#81,#10,#10,#08,#08,#FF,#00,#FF,#00
db #00,#00,#00,#00,#E0,#20,#E0,#20,#02,#00,#04,#00,#F8,#00,#00,#FF
db #10,#10,#08,#08,#04,#04,#02,#FF,#02,#FE,#01,#01,#00,#00,#00,#00
db #00,#00,#00,#00,#80,#80,#40,#40,#20,#20,#FF,#00,#FF,#40,#00,#80
db #00,#00,#80,#80,#80,#40,#20,#20,#00,#00,#00,#00,#00,#00,#00,#FE
db #00,#00,#00,#00,#07,#04,#07,#04,#08,#08,#10,#10,#FF,#00,#FF,#00
db #08,#08,#10,#10,#20,#20,#40,#FF,#40,#00,#20,#00,#1F,#00,#00,#FF
db #00,#00,#00,#00,#00,#01,#01,#02,#40,#7F,#80,#80,#80,#00,#00,#00
db #04,#04,#FF,#00,#FF,#00,#00,#01,#00,#00,#FF,#00,#FF,#82,#00,#01
db #00,#00,#01,#01,#03,#02,#05,#04,#00,#00,#00,#00,#00,#00,#00,#7F
db #FF,#00,#55,#00,#FF,#00,#00,#00,#00,#00,#00,#FF,#00,#AA,#00,#FF
db #FE,#02,#56,#02,#FE,#04,#04,#04,#04,#04,#04,#FE,#02,#AA,#02,#FE
db #7F,#40,#55,#40,#7F,#20,#20,#20,#20,#20,#20,#7F,#40,#6A,#40,#7F
db #00,#00,#00,#00,#00,#00,#00,#FF,#02,#02,#02,#02,#02,#02,#02,#FF
db #20,#20,#20,#20,#20,#20,#20,#20,#20,#40,#40,#40,#40,#40,#40,#FF
db #00,#00,#7D,#7C,#FE,#FE,#FE,#FE,#00,#00,#BE,#3E,#7F,#7F,#7F,#7F
db #FE,#FE,#FE,#FE,#FE,#FE,#FE,#FF,#7F,#7F,#7F,#7F,#7F,#7F,#7F,#FF
db #00,#00,#00,#00,#1F,#35,#2A,#21,#00,#00,#00,#00,#FF,#22,#88,#40
db #00,#00,#00,#00,#FF,#04,#02,#08,#00,#00,#00,#00,#00,#F8,#54,#AC
db #00,#00,#00,#01,#FE,#88,#22,#00,#00,#00,#00,#FF,#20,#80,#10,#00
db #0D,#1A,#14,#29,#24,#30,#20,#24,#00,#40,#00,#00,#00,#00,#00,#00
db #50,#60,#40,#48,#40,#40,#40,#40,#02,#00,#00,#04,#00,#00,#00,#00
db #50,#A8,#18,#8C,#24,#0C,#44,#14,#0A,#02,#06,#02,#02,#02,#02,#02
db #40,#40,#40,#40,#40,#40,#40,#40,#02,#02,#02,#02,#02,#02,#01,#01
db #40,#80,#80,#80,#80,#80,#80,#7F,#01,#01,#01,#01,#01,#01,#01,#FE
db #00,#00,#00,#00,#1F,#2A,#55,#48,#00,#00,#00,#00,#00,#FC,#56,#AA
db #80,#88,#80,#80,#80,#A0,#80,#80,#80,#80,#80,#A0,#80,#80,#80,#80
db #01,#05,#01,#01,#01,#01,#11,#01,#01,#01,#01,#09,#01,#01,#01,#01
db #01,#01,#01,#11,#01,#01,#01,#01,#02,#02,#02,#02,#02,#02,#02,#02
db #02,#02,#02,#02,#02,#02,#07,#07,#40,#40,#40,#40,#40,#40,#E0,#E0
db #1F,#0B,#02,#02,#02,#02,#02,#02,#F8,#D0,#40,#40,#40,#40,#40,#40
db #00,#00,#00,#00,#03,#0C,#10,#20,#00,#00,#00,#00,#C0,#30,#08,#04
db #40,#40,#80,#80,#80,#80,#80,#80,#02,#02,#01,#01,#01,#01,#01,#01
db #80,#80,#80,#80,#80,#80,#80,#80,#01,#01,#01,#01,#01,#01,#01,#01
db #80,#80,#80,#80,#FF,#00,#00,#00,#01,#01,#01,#01,#FF,#00,#00,#00
db #FF,#00,#00,#00,#00,#00,#00,#FF,#00,#FF,#00,#00,#00,#00,#00,#FF
db #FF,#00,#FF,#55,#00,#00,#00,#00,#00,#04,#00,#04,#00,#04,#00,#04
db #00,#20,#00,#20,#00,#20,#00,#20,#00,#04,#00,#57,#04,#57,#00,#04
db #00,#20,#00,#EA,#20,#EA,#00,#20,#0F,#08,#08,#08,#08,#08,#08,#08
db #F0,#10,#10,#10,#10,#10,#10,#10,#0F,#00,#00,#57,#04,#57,#00,#04
db #F0,#00,#00,#EA,#20,#EA,#00,#20,#00,#00,#00,#57,#04,#57,#00,#04
db #00,#00,#00,#EA,#20,#EA,#00,#20,#4A,#CE,#00,#00,#00,#00,#00,#00
db #52,#73,#00,#00,#00,#00,#00,#00,#07,#04,#02,#01,#00,#00,#00,#00
db #E0,#20,#40,#80,#00,#00,#00,#00,#4A,#CE,#00,#04,#00,#04,#00,#04
db #52,#73,#00,#20,#00,#20,#00,#20,#00,#00,#00,#00,#00,#00,#03,#FC
db #00,#00,#00,#00,#07,#38,#C0,#00,#80,#60,#1C,#03,#00,#00,#00,#00
db #00,#00,#00,#FF,#E6,#80,#80,#80,#00,#00,#00,#00,#E0,#1C,#03,#00
db #00,#00,#00,#00,#00,#00,#C0,#3F,#00,#00,#00,#FF,#67,#01,#01,#01
db #01,#06,#38,#C0,#00,#00,#00,#00,#08,#08,#04,#04,#04,#02,#02,#02
db #00,#00,#00,#FF,#66,#00,#00,#00,#20,#20,#10,#10,#08,#08,#04,#02
db #00,#03,#1C,#E0,#00,#00,#00,#00,#60,#80,#00,#00,#00,#00,#00,#00
db #06,#01,#00,#00,#00,#00,#00,#00,#00,#C0,#38,#07,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#01,#06,#18,#08,#68,#29,#5E,#0C,#12,#7F,#40
db #00,#80,#40,#80,#00,#00,#80,#80,#40,#40,#7F,#90,#10,#10,#08,#08
db #80,#80,#80,#60,#18,#07,#00,#00,#00,#00,#00,#00,#00,#00,#C0,#38
db #FF,#81,#81,#FF,#91,#91,#91,#FF,#FF,#80,#80,#FF,#88,#88,#88,#FF
db #7F,#40,#40,#40,#40,#40,#40,#00,#FE,#02,#02,#02,#02,#02,#02,#00
db #BF,#A0,#A0,#A0,#A0,#A0,#A0,#80,#AA,#55,#2B,#04,#04,#26,#26,#1E
db #88,#49,#8A,#0A,#0C,#1C,#18,#30,#06,#06,#06,#1F,#E8,#A0,#10,#01
db #30,#60,#60,#FE,#01,#80,#04,#10,#00,#14,#08,#24,#52,#24,#08,#01
db #84,#48,#30,#10,#90,#12,#9C,#18,#00,#54,#A8,#54,#2E,#04,#08,#5C
db #11,#16,#1C,#48,#08,#88,#08,#28,#00,#00,#00,#00,#00,#90,#44,#A0
db #00,#00,#00,#00,#00,#00,#00,#02,#09,#04,#10,#24,#12,#45,#2B,#01
db #00,#00,#00,#10,#00,#01,#00,#00,#00,#20,#00,#00,#04,#00,#00,#00
db #11,#AA,#44,#00,#00,#20,#51,#8E,#11,#AA,#44,#00,#00,#84,#4A,#31
db #00,#00,#08,#14,#22,#C1,#00,#00,#FF,#04,#2A,#04,#92,#32,#28,#40
db #FF,#04,#22,#01,#54,#40,#28,#02,#00,#00,#01,#00,#00,#00,#20,#00
db #00,#00,#40,#00,#00,#01,#00,#00,#00,#03,#0C,#10,#20,#20,#40,#40
db #00,#C0,#30,#08,#04,#04,#02,#02,#40,#40,#20,#20,#10,#0C,#03,#00
db #02,#02,#04,#04,#08,#30,#C0,#00,#00,#C0,#30,#00,#40,#80,#80,#80
db #80,#80,#80,#40,#00,#30,#C0,#00,#1F,#00,#00,#00,#00,#00,#00,#00
db #FC,#80,#83,#82,#81,#81,#FF,#80,#00,#00,#00,#00,#00,#00,#00,#1F
db #80,#FF,#81,#81,#82,#83,#80,#FC,#00,#00,#00,#00,#00,#00,#00,#FC
db #FC,#00,#00,#00,#00,#00,#00,#00,#1F,#00,#80,#80,#40,#40,#FF,#00
db #00,#FF,#40,#40,#80,#80,#00,#1F,#FC,#80,#80,#80,#80,#80,#80,#80
db #80,#80,#80,#80,#80,#80,#80,#FC,#07,#04,#87,#82,#42,#42,#FE,#00
db #E0,#20,#E3,#42,#61,#41,#7F,#00,#00,#FE,#42,#4A,#82,#87,#04,#07
db #00,#7F,#41,#71,#42,#E3,#20,#E0,#00,#00,#00,#1F,#74,#A1,#48,#82
db #00,#00,#FF,#20,#80,#00,#00,#00,#50,#00,#80,#10,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#01,#07,#0A,#14,#2A,#50,#AA,#50,#20,#88

;##################
;# AVATAR SPRITES #
;##################

__Spr_Wiz_Front:
db #00,#8F,#1F,#00,#11,#0F,#0F,#88,#11,#0F,#0F,#88,#01,#0F,#0F,#08
db #23,#6F,#6F,#4C,#03,#2D,#4B,#0C,#13,#0F,#0F,#8C,#11,#EF,#7F,#88
db #11,#FF,#FF,#88,#11,#EF,#7F,#88,#33,#FF,#FF,#CC,#74,#FF,#FF,#E2
db #70,#FF,#FF,#E0,#F8,#F7,#FE,#F1,#F0,#F7,#FE,#F0,#F0,#F3,#FC,#F2
db #F0,#F9,#F8,#FC,#F7,#F0,#C3,#F8,#9E,#F0,#C3,#F8,#96,#F0,#F0,#F8
db #F0,#F0,#F0,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#01,#0E,#07,#08
__Spr_Wiz_happy:
db #00,#8F,#1F,#00,#11,#0F,#0F,#88,#11,#0F,#0F,#88,#01,#6F,#6F,#08
db #2F,#2D,#4B,#4F,#2F,#0F,#0F,#4F,#3F,#EF,#7F,#CF,#D1,#7F,#EF,#B8
db #D1,#BF,#DF,#B8,#F1,#CF,#3F,#F8,#F1,#FF,#FF,#F8,#F0,#FF,#FF,#F0
db #F8,#FF,#FF,#F1,#74,#F7,#FE,#E0,#74,#F7,#FE,#E0,#F8,#F3,#FC,#E0
db #F8,#F1,#F8,#E0,#F0,#F0,#F0,#E0,#F0,#F0,#F0,#E0,#F0,#F0,#F0,#E2
db #F0,#F0,#F0,#E2,#00,#2E,#47,#00,#00,#06,#06,#00,#01,#2E,#47,#08
__Spr_Wiz_dead:
db #00,#00,#00,#00,#00,#FF,#FF,#00,#11,#8F,#1F,#88,#23,#0F,#0F,#4C
db #23,#09,#09,#4C,#23,#09,#09,#4C,#11,#0F,#0F,#88,#00,#AE,#57,#00
db #00,#8C,#13,#00,#00,#47,#2E,#00,#00,#23,#4C,#00,#23,#0F,#0F,#4C
db #02,#01,#08,#26,#13,#0F,#0F,#AE,#02,#01,#08,#26,#02,#8F,#1F,#26
db #02,#01,#08,#4C,#02,#47,#2F,#88,#13,#01,#19,#00,#23,#57,#AE,#00
db #00,#02,#04,#00,#00,#02,#04,#00,#00,#02,#04,#00,#00,#0E,#07,#00
__Spr_Wiz_Climb1:
db #11,#0F,#1F,#00,#27,#0F,#0F,#88,#27,#0F,#0F,#88,#FB,#0F,#1F,#88
db #F3,#0F,#1F,#C8,#87,#0F,#0F,#2C,#C3,#0F,#0F,#7C,#EB,#0F,#0F,#74
db #E8,#F8,#F1,#71,#71,#F0,#F0,#EA,#72,#F0,#F0,#C4,#74,#F0,#F0,#C0
db #70,#F0,#F0,#E2,#F8,#F0,#F0,#E2,#F0,#F0,#F0,#E0,#F0,#F0,#F0,#F1
db #F0,#F0,#F0,#F1,#F0,#F4,#F2,#F0,#F0,#F0,#F0,#F0,#F0,#F8,#F4,#F0
db #FC,#F0,#F0,#F0,#00,#9E,#F0,#F0,#00,#06,#01,#3C,#00,#0E,#00,#33
__Spr_Wiz_Climb2:
db #00,#8F,#0F,#88,#11,#0F,#0F,#4E,#11,#0F,#0F,#4E,#11,#8F,#0F,#FD
db #31,#8F,#0F,#FC,#43,#0F,#0F,#1E,#E3,#0F,#0F,#3C,#E2,#0F,#0F,#7D
db #E8,#F8,#F1,#71,#75,#F0,#F0,#E8,#32,#F0,#F0,#E4,#30,#F0,#F0,#E2
db #74,#F0,#F0,#E0,#74,#F0,#F0,#F1,#70,#F0,#F0,#F0,#F8,#F0,#F0,#F0
db #F8,#F0,#F0,#F0,#F0,#F4,#F2,#F0,#F0,#F0,#F0,#F0,#F0,#F2,#F1,#F0
db #F0,#F0,#F0,#F3,#F0,#F0,#97,#00,#C3,#08,#06,#00,#CC,#00,#07,#00
__Spr_Wiz_Right_even:
db #11,#0F,#2E,#00,#23,#0F,#0E,#00,#03,#0F,#1F,#00,#03,#0F,#0F,#00
db #13,#0F,#6F,#88,#12,#0F,#2D,#88,#23,#8F,#0F,#4C,#33,#EF,#0F,#0C
db #32,#FF,#FF,#88,#30,#FF,#EF,#08,#74,#F7,#FF,#88,#74,#F7,#FF,#88
db #74,#F1,#FF,#88,#70,#F0,#F7,#CC,#70,#E3,#7B,#CC,#70,#E3,#79,#CC
db #70,#F2,#F0,#CC,#70,#F4,#F0,#80,#70,#F0,#F0,#80,#70,#F0,#F0,#80
db #70,#F0,#F0,#80,#70,#F0,#F0,#80,#70,#F0,#F0,#80,#03,#0C,#00,#00
__Spr_Wiz_Right_odd:
db #00,#47,#0F,#88,#00,#8F,#0F,#08,#00,#0F,#0F,#4C,#00,#0F,#0F,#0C
db #00,#4F,#1F,#AE,#00,#4B,#0F,#A6,#00,#AF,#0F,#1F,#00,#FF,#8F,#0F
db #00,#FB,#FF,#EE,#00,#F3,#FF,#8E,#11,#F1,#FF,#EE,#11,#F1,#FF,#EE
db #11,#F0,#F7,#EE,#10,#F0,#F1,#FF,#10,#F0,#F0,#FF,#10,#F0,#9E,#F7
db #10,#F0,#9E,#F3,#10,#F0,#F8,#E0,#10,#F1,#F0,#E0,#10,#F0,#F0,#E0
db #10,#F0,#F0,#E0,#10,#F0,#F0,#E0,#10,#F0,#F0,#E0,#00,#00,#07,#08
__Spr_Wiz_Left_even:
db #11,#0F,#2E,#00,#01,#0F,#1F,#00,#23,#0F,#0F,#00,#03,#0F,#0F,#00
db #57,#8F,#2F,#00,#56,#0F,#0F,#00,#8F,#0F,#5F,#00,#0F,#1F,#FF,#00
db #77,#FF,#FC,#00,#17,#FF,#FC,#00,#77,#FF,#F8,#88,#77,#FF,#F8,#88
db #77,#FE,#F0,#88,#FF,#F8,#F0,#80,#FF,#F0,#F0,#80,#CF,#F0,#F0,#80
db #CF,#7F,#F0,#80,#70,#7C,#F0,#80,#70,#F4,#F0,#80,#70,#F4,#F0,#80
db #70,#F4,#F0,#80,#70,#F0,#F0,#80,#70,#F0,#F0,#80,#01,#0E,#00,#00
__Spr_Wiz_Left_odd:
db #00,#47,#0F,#88,#00,#07,#0F,#4C,#00,#8F,#0F,#0C,#00,#0F,#0F,#0C
db #11,#6F,#0F,#8C,#11,#4B,#0F,#0C,#23,#0F,#1F,#4C,#03,#0F,#7F,#CC
db #11,#FF,#FF,#C0,#01,#7F,#FF,#C0,#11,#FF,#FE,#E2,#11,#FF,#FE,#E2
db #11,#FF,#F8,#E2,#33,#FE,#F0,#E0,#33,#3C,#F0,#E0,#33,#1F,#FC,#E0
db #33,#D3,#F0,#E0,#10,#F1,#F0,#E0,#10,#F1,#F0,#E0,#10,#F1,#F0,#E0
db #10,#F0,#F0,#E0,#10,#F0,#F0,#E0,#10,#F0,#F0,#E0,#00,#00,#03,#0C
;BOT (DROID)
;align #10
__Spr_Bot_Front:
db #00,#F8,#F1,#00,#11,#F0,#F0,#88,#32,#F0,#F0,#C4,#74,#F0,#F0,#E2
db #71,#FF,#FF,#E8,#71,#6A,#4A,#E8,#71,#4A,#6A,#E8,#71,#FF,#FF,#E8
db #74,#F0,#F0,#E2,#00,#FF,#FF,#00,#47,#0F,#0F,#6A,#07,#0F,#0F,#A4
db #25,#0F,#1E,#1E,#25,#0F,#0F,#A4,#25,#0F,#0F,#4A,#25,#0F,#0F,#4A
db #70,#0F,#0F,#4A,#52,#0F,#0F,#4A,#52,#0F,#0F,#4A,#07,#0F,#0F,#0E
db #34,#0F,#0F,#C2,#34,#0F,#0F,#C2,#30,#00,#00,#C0,#30,#00,#00,#C0
__Spr_Bot_happy:
db #11,#F0,#F0,#88,#32,#F0,#F0,#C4,#74,#F0,#F0,#E2,#FB,#FF,#FF,#FD
db #EB,#69,#69,#7D,#FA,#3C,#3C,#7D,#FA,#96,#96,#F5,#FB,#FF,#FF,#FD
db #F8,#F0,#F0,#F1,#FE,#5A,#5A,#E2,#65,#A5,#A5,#E0,#DA,#5A,#5A,#B4
db #A5,#A5,#B4,#5A,#78,#5A,#5A,#B4,#A5,#A5,#A5,#E1,#78,#5A,#5A,#5A
db #F0,#A5,#A5,#E1,#D2,#D2,#5A,#5A,#A5,#A5,#A5,#E1,#5A,#5A,#5A,#5A
db #F4,#AD,#B5,#E3,#CB,#D2,#5A,#3D,#CB,#A5,#B4,#3D,#74,#88,#11,#E2
__Spr_Bot_dead:
db #00,#F8,#F1,#00,#11,#80,#10,#88,#32,#00,#00,#C4,#64,#00,#00,#62
db #51,#FF,#FF,#A8,#51,#00,#00,#A8,#51,#00,#00,#A8,#51,#FF,#FF,#A8
db #74,#00,#00,#E2,#11,#00,#00,#88,#71,#00,#00,#E8,#40,#00,#00,#20
db #40,#00,#88,#20,#40,#11,#00,#20,#40,#22,#00,#20,#40,#77,#EE,#20
db #40,#00,#44,#20,#40,#00,#88,#20,#40,#11,#00,#20,#40,#00,#00,#20
db #40,#00,#00,#20,#73,#F0,#F0,#EC,#30,#00,#00,#C0,#30,#00,#00,#C0
__Spr_Bot_Climb1:
db #00,#00,#00,#EA,#00,#F8,#F1,#F5,#B1,#F0,#F0,#BA,#B2,#F0,#F0,#F5
db #F4,#F0,#F0,#E0,#F8,#F0,#F0,#E4,#70,#F0,#F0,#E4,#70,#F0,#F0,#E4
db #74,#F0,#F0,#E4,#73,#FF,#FF,#EC,#43,#0F,#0F,#2C,#07,#0F,#0F,#0E
db #37,#CF,#8F,#8E,#07,#5F,#5F,#4E,#07,#8F,#9F,#4E,#17,#1F,#5F,#4E
db #27,#1F,#5F,#4E,#37,#CF,#8F,#8E,#07,#0F,#0F,#0E,#07,#0F,#0F,#C2
db #34,#0F,#0F,#C2,#34,#0F,#0F,#C2,#30,#00,#00,#C0,#30,#00,#00,#00
__Spr_Bot_Climb2:
db #A0,#00,#00,#44,#A0,#74,#F0,#EA,#E4,#F8,#F0,#F5,#FB,#F0,#F0,#F2
db #72,#F0,#F0,#F1,#72,#F0,#F0,#E0,#72,#F0,#F0,#E0,#72,#F0,#F0,#E0
db #51,#F0,#F0,#E2,#40,#FF,#FF,#EC,#43,#0F,#0F,#2C,#07,#0F,#0F,#0E
db #37,#CF,#8F,#8E,#07,#5F,#5F,#4E,#07,#8F,#9F,#4E,#17,#1F,#5F,#4E
db #27,#1F,#5F,#4E,#37,#CF,#8F,#8E,#07,#0F,#0F,#0E,#34,#0F,#0F,#0E
db #34,#0F,#0F,#C2,#34,#0F,#0F,#C2,#30,#00,#00,#C0,#00,#00,#00,#C0
__Spr_Bot_Right_even:
db #11,#F0,#E2,#00,#32,#F0,#F1,#00,#74,#F0,#F0,#88,#70,#F0,#F0,#80
db #70,#F0,#F7,#88,#70,#F0,#C7,#80,#70,#F0,#F4,#08,#70,#F0,#F7,#88
db #70,#F0,#F0,#80,#11,#FF,#EE,#00,#03,#0F,#0F,#00,#16,#87,#0F,#08
db #07,#C3,#0F,#08,#07,#69,#0F,#08,#47,#3C,#E1,#08,#27,#1E,#87,#08
db #27,#0F,#C3,#08,#27,#0F,#69,#08,#47,#0F,#0F,#08,#07,#78,#87,#08
db #07,#F0,#C3,#08,#07,#F3,#C3,#08,#03,#F0,#C3,#00,#00,#70,#80,#00
__Spr_Bot_Right_odd:
db #00,#74,#F0,#88,#00,#F8,#F0,#C4,#11,#F0,#F0,#E2,#10,#F0,#F0,#E0
db #10,#F0,#F1,#EE,#10,#F0,#F1,#2C,#10,#F0,#F1,#C2,#10,#F0,#F1,#EE
db #10,#F0,#F0,#E0,#00,#77,#FF,#88,#00,#0F,#0F,#0C,#01,#69,#0F,#0E
db #01,#3C,#0F,#0E,#01,#1E,#87,#0E,#11,#0F,#F0,#0E,#01,#8F,#5A,#86
db #01,#8F,#69,#0E,#01,#8F,#3C,#0E,#11,#0F,#E1,#0E,#01,#1E,#F0,#0E
db #01,#1E,#F4,#0E,#01,#1E,#F4,#0E,#00,#1E,#F0,#0C,#00,#00,#E0,#00
__Spr_Bot_Left_even:
db #11,#F0,#E2,#00,#32,#F0,#F1,#00,#74,#F0,#F0,#88,#70,#F0,#F0,#80
db #77,#F8,#F0,#80,#43,#F8,#F0,#80,#34,#F8,#F0,#80,#77,#F8,#F0,#80
db #70,#F0,#F0,#80,#11,#FF,#EE,#00,#03,#0F,#0F,#00,#16,#0F,#0F,#08
db #25,#87,#0F,#08,#43,#4B,#1F,#88,#25,#87,#0F,#08,#16,#4B,#0F,#88
db #07,#2D,#1F,#88,#07,#1E,#1F,#08,#07,#0F,#1F,#88,#07,#78,#87,#08
db #07,#F0,#C3,#08,#07,#F3,#C3,#08,#03,#F0,#C3,#00,#00,#70,#80,#00
__Spr_Bot_Left_odd:
db #00,#74,#F0,#88,#00,#F8,#F0,#C4,#11,#F0,#F0,#E2,#10,#F0,#F0,#E0
db #11,#FE,#F0,#E0,#10,#3E,#F0,#E0,#01,#F2,#F0,#E0,#11,#FE,#F0,#E0
db #10,#F0,#F0,#E0,#00,#77,#FF,#88,#00,#0F,#0F,#0C,#01,#0F,#0F,#0E
db #01,#4B,#0F,#0E,#01,#A5,#0F,#6E,#10,#1E,#0F,#0E,#01,#A5,#0F,#2E
db #01,#5A,#0F,#6E,#01,#0F,#0F,#4E,#01,#1E,#C3,#6E,#01,#3C,#E1,#0E
db #01,#3C,#E9,#0E,#01,#3C,#E9,#0E,#00,#3C,#E1,#0C,#00,#10,#C0,#00


;################
;# ITEM SPRITES #
;################

;corresponding wiz and bit sprites must always be 1 page apart
align #200
sprite_items_even:
;Sprites for Wiz
wizitems_hi equ $/#100
db #74,#F0,#88,#C4,#E1,#E9,#F0,#B4,#C0,#48,#F0,#B4,#F0,#78,#C0
db #C4,#F0,#F8,#32,#F1,#00,#00,#F0,#30,#30,#F0,#00,#00,#F1,#32
db #00,#77,#C0,#C4,#F8,#11,#32,#F1,#C4,#C4,#F2,#74,#74,#F4,#C4
db #80,#F8,#F8,#F9,#F0,#88,#00,#F1,#FA,#F8,#E6,#00,#00,#88,#FF
db #73,#11,#C8,#C0,#FE,#70,#70,#F0,#C0,#84,#F0,#70,#70,#F0,#0C
db #84,#E1,#70,#74,#F0,#4C,#4C,#E1,#74,#32,#D2,#88,#00,#F1,#11
db #FF,#00,#00,#00,#CC,#7A,#BE,#EA,#00,#00,#FA,#DF,#FB,#7E,#88
db #C8,#BE,#76,#75,#FE,#C8,#C8,#E1,#33,#11,#FF,#4C,#8C,#F8,#00
db #23,#1F,#00,#4C,#E1,#9E,#78,#F0,#84,#84,#F0,#78,#9E,#E1,#4C
db #C4,#1E,#E9,#F8,#F0,#C4,#88,#F0,#74,#32,#F1,#00,#00,#E2,#11
db #00,#00,#00,#88,#32,#75,#52,#E1,#80,#80,#F1,#72,#F0,#F0,#C0
db #C0,#F0,#F0,#C3,#0F,#C0,#C4,#F0,#F8,#74,#F0,#88,#00,#E0,#10
db #22,#02,#00,#88,#80,#44,#A0,#A0,#40,#00,#48,#10,#61,#3C,#44
db #00,#48,#98,#20,#A0,#80,#00,#91,#08,#20,#00,#00,#00,#15,#11
__item_special_1up:
db #33,#9F,#88,#CC,#1F,#77,#67,#1F,#CC,#CC,#9F,#67,#77,#9F,#CC
db #C4,#F4,#75,#75,#F5,#C4,#C4,#F4,#75,#74,#F5,#CC,#88,#FF,#33
__life_symbol_Wiz:
db #66,#CC,#F9,#E2,#F2,#E0,#F0,#E0,#F8,#E2,#74,#C4,#32,#88

;!!! corresponding wiz and bit sprites must always be 1 page apart !!!
;Sprites for Bot
align #100
db #01,#88,#00,#00,#2E,#13,#27,#0F,#88,#0C,#0F,#5F,#AF,#0F,#0C
db #0C,#0F,#5F,#AF,#CF,#0C,#0C,#3F,#4F,#07,#0F,#CC,#0C,#0F,#03
db #11,#2E,#00,#00,#E0,#10,#00,#0C,#00,#00,#2E,#11,#23,#1F,#00
db #4C,#0F,#AD,#4B,#0F,#0C,#0C,#0F,#4B,#AD,#0F,#4C,#88,#0F,#47
db #02,#0A,#08,#8C,#0A,#46,#04,#26,#04,#04,#46,#06,#46,#0A,#4C
db #08,#26,#02,#03,#15,#08,#00,#07,#23,#01,#3F,#00,#00,#4C,#11
db #11,#8F,#88,#08,#0F,#47,#8F,#2B,#4C,#0C,#11,#1F,#2E,#00,#0C
db #0C,#00,#0C,#1F,#11,#0C,#0C,#AB,#8F,#47,#0F,#4C,#88,#0F,#23
db #11,#EE,#00,#00,#1F,#23,#57,#EF,#88,#4C,#8F,#8F,#8F,#EF,#4C
db #4C,#2F,#9F,#9F,#2F,#4C,#88,#4F,#47,#23,#1F,#00,#00,#EE,#11
db #2E,#00,#00,#00,#88,#6D,#19,#A6,#00,#88,#47,#08,#08,#11,#0C
db #04,#00,#08,#08,#00,#04,#04,#00,#1F,#23,#2E,#04,#84,#65,#00
db #50,#50,#00,#08,#0F,#0F,#7F,#FF,#08,#08,#6F,#4F,#87,#CF,#08
db #08,#8F,#97,#3F,#1F,#08,#08,#FF,#7F,#0F,#0F,#08,#00,#50,#50
__item_special_Bomb:
db #74,#C0,#00,#00,#0E,#6A,#84,#0E,#00,#88,#4F,#23,#47,#0F,#4C
db #0C,#0F,#07,#27,#0F,#0C,#0C,#0F,#27,#57,#0F,#4C,#88,#0F,#23
d;__dead_symbol_wiz:
db #66,#CC,#99,#22,#88,#22,#88,#22,#44,#44,#22,#88,#11,#00

;!!! corresponding wiz and bit sprites must always be 1 page apart !!!
;wiz:
align #100
sprite_items_odd:
db #11,#F0,#E2,#B5,#B4,#32,#30,#E1,#F0,#D2,#F0,#21,#30,#D2,#F0
db #F1,#F0,#32,#00,#F8,#C4,#C0,#F0,#00,#00,#F0,#C0,#C4,#F8,#00
db #00,#11,#FC,#F1,#76,#00,#00,#F8,#F5,#F9,#F0,#11,#11,#F1,#F1
db #E0,#F2,#32,#32,#F4,#E2,#C4,#F8,#32,#32,#F1,#88,#00,#EE,#33
db #10,#CC,#76,#F8,#F3,#10,#10,#F0,#F0,#E1,#F0,#10,#10,#F0,#C3
db #A5,#F0,#10,#11,#F0,#D3,#97,#F0,#11,#00,#F8,#6A,#C4,#74,#00
db #33,#CC,#00,#00,#FB,#12,#23,#FA,#88,#C8,#7E,#33,#32,#DF,#EA
db #FA,#EB,#11,#11,#F7,#FA,#B6,#FC,#00,#00,#77,#DF,#E3,#32,#00
db #00,#8F,#4C,#97,#78,#23,#12,#F0,#E1,#E1,#F0,#12,#23,#78,#97
db #79,#87,#32,#32,#F0,#F1,#E2,#F0,#11,#00,#F8,#C4,#88,#74,#00
db #00,#00,#00,#EA,#C4,#11,#10,#78,#A4,#E4,#F8,#10,#30,#F0,#F0
db #F0,#F0,#30,#30,#0F,#3C,#F1,#F0,#32,#11,#F0,#E2,#80,#70,#00
db #00,#88,#08,#22,#20,#11,#20,#A0,#90,#00,#52,#00,#10,#87,#D1
db #00,#52,#22,#00,#A0,#A0,#44,#20,#02,#00,#80,#00,#44,#45,#00
db #00,#EF,#6E,#7F,#CF,#11,#11,#8F,#7F,#7F,#AF,#11,#11,#EF,#7F
db #F1,#F5,#11,#11,#F5,#F5,#F1,#F5,#11,#11,#F1,#F7,#EE,#FF,#00
__dead_symbol_bot:
db #33,#66,#77,#FF,#44,#11,#44,#11,#44,#11,#44,#11,#77,#FF

;bot:
;!!! corresponding wiz and bit sprites must always be 1 page apart !!!
align #100
db #00,#26,#00,#88,#4F,#00,#01,#8F,#2E,#0F,#4F,#13,#23,#8F,#0F
db #0F,#4F,#13,#23,#BF,#0F,#CF,#0F,#13,#01,#0F,#3F,#0F,#0F,#00
db #00,#47,#88,#80,#70,#00,#00,#03,#00,#88,#47,#00,#00,#8F,#4C
db #1F,#87,#23,#12,#0F,#0F,#0F,#0F,#12,#23,#87,#1F,#2E,#0F,#11
db #00,#0A,#0A,#2B,#0A,#11,#01,#01,#89,#09,#19,#01,#11,#0A,#1B
db #8A,#09,#00,#00,#0D,#46,#0C,#8D,#00,#00,#07,#CC,#00,#57,#00
db #00,#67,#2E,#0E,#0F,#11,#23,#0E,#9F,#47,#4C,#03,#03,#88,#03
db #03,#00,#03,#03,#4C,#47,#8F,#2E,#23,#11,#0F,#1F,#2E,#8F,#00
db #00,#77,#88,#4C,#8F,#00,#11,#7F,#AE,#1F,#2F,#23,#23,#3F,#9F
db #9F,#4F,#23,#23,#4F,#9F,#2E,#1F,#11,#00,#8F,#4C,#88,#77,#00
db #03,#88,#00,#00,#A6,#13,#02,#65,#88,#2E,#11,#02,#02,#00,#47
db #01,#00,#02,#02,#00,#01,#01,#4C,#03,#00,#8F,#89,#A5,#11,#00
db #10,#50,#40,#0E,#0F,#03,#13,#FF,#CE,#8E,#1F,#13,#21,#3F,#0E
db #0E,#6F,#21,#03,#CF,#4E,#CE,#FF,#13,#03,#0F,#0E,#40,#50,#10
db #11,#F0,#00,#08,#8B,#12,#21,#03,#08,#2E,#9F,#00,#11,#0F,#1F
db #0F,#0F,#01,#01,#8F,#0F,#0F,#8F,#01,#11,#4F,#1F,#2E,#8F,#00
__life_symbol_Bot:
db #30,#60,#07,#0F,#07,#8F,#17,#0F,#37,#EF,#07,#4F,#07,#8F


;################
;# STARTUP DATA #
;################
;this has to stay @ the end, it might be overwritten after initialization

Game_Header:
db #00,#01,#3C,#02,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#44,#F3,#E6,#00,#00
db #00,#16,#3C,#29,#00,#00,#00,#00,#00,#F0,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#F0,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#51,#F3,#F3,#00,#00
db #00,#3C,#3C,#3C,#02,#00,#00,#00,#F0,#D0,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#F0,#D0,#00,#00,#00,#00,#00,#82,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#D9,#F3,#F3,#88,#00
db #00,#3C,#3C,#3C,#02,#00,#00,#C0,#C0,#80,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#50,#80
db #C0,#C0,#80,#00,#00,#00,#00,#05,#27,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#F3,#F3,#F3,#A2,#00
db #01,#3C,#3C,#3C,#28,#00,#00,#40,#C0,#A0,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#E0,#80
db #40,#C0,#A0,#00,#00,#00,#00,#1B,#33,#0A,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#44,#F3,#F3,#F3,#E6,#00
db #14,#3C,#3C,#3C,#29,#00,#00,#00,#C0,#A0,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#C0,#A0
db #00,#C0,#A0,#00,#00,#00,#41,#9B,#11,#CB,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#44,#F3,#F3,#F3,#E6,#00
db #16,#3C,#3C,#3C,#29,#00,#00,#00,#40,#D0,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#D0,#00
db #00,#40,#D0,#00,#00,#00,#05,#67,#45,#63,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#51,#F3,#F3,#F3,#F3,#00
db #16,#3C,#3C,#3C,#3C,#00,#00,#00,#00,#C0,#A0,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#C0,#A0,#00,#00,#05,#22,#00,#27,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#51,#F3,#F3,#F3,#F3,#00
db #56,#BC,#3C,#FF,#3C,#02,#00,#00,#00,#E0,#D0,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#E0,#D0,#00,#00,#05,#22,#00,#27,#00,#55,#FF,#0C,#0C,#20
db #55,#FF,#0C,#0C,#20,#00,#00,#75,#AE,#18,#00,#FF,#55,#FF,#0C,#0C,#20,#00,#CC,#CC,#CC,#D9,#F3,#00
db #16,#7C,#3C,#7D,#FF,#02,#00,#00,#E0,#C0,#C0,#A0,#50,#C0,#C0,#E4,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#E0,#C0,#D1,#A0,#00,#05,#22,#00,#27,#00,#55,#0C,#0C,#0C,#18
db #55,#0C,#0C,#0C,#18,#00,#10,#AE,#0C,#0C,#20,#AE,#55,#0C,#0C,#0C,#18,#00,#CC,#CC,#CC,#D9,#F3,#00
db #16,#94,#3C,#3C,#3C,#02,#00,#50,#C0,#D0,#D1,#E4,#C0,#C0,#E0,#D1,#F0,#C0,#C0,#80,#D1,#E0,#D1,#A2
db #50,#C0,#D0,#D1,#F0,#00,#05,#22,#00,#63,#00,#04,#0C,#0C,#0C,#18
db #04,#0C,#0C,#0C,#0C,#00,#24,#0C,#0C,#0C,#20,#0C,#04,#0C,#0C,#0C,#18,#00,#73,#5D,#CF,#D9,#F3,#00
db #16,#94,#3C,#7D,#B4,#28,#00,#E4,#C0,#A0,#E0,#F2,#C0,#80,#00,#C0,#A2,#E0,#C0,#A0,#C0,#F2,#C0,#A2
db #E0,#C0,#A0,#E0,#F2,#00,#41,#27,#45,#63,#00,#10,#30,#30,#0C,#0C
db #10,#30,#30,#24,#0C,#10,#0C,#18,#30,#24,#08,#0C,#10,#30,#30,#0C,#0C,#00,#73,#5D,#CF,#D9,#F3,#00
db #55,#3C,#3C,#3C,#3C,#29,#00,#E0,#D0,#00,#40,#E6,#E0,#80,#00,#E0,#A2,#E0,#D0,#00,#E0,#A2,#E0,#A2
db #E0,#D0,#00,#40,#F2,#00,#00,#1B,#11,#8A,#00,#00,#00,#00,#24,#0C
db #00,#00,#00,#10,#0C,#10,#0C,#20,#00,#04,#08,#0C,#00,#00,#00,#24,#0C,#00,#94,#ED,#C0,#D9,#F3,#00
db #55,#3C,#3C,#3C,#3C,#3C,#00,#C8,#D0,#00,#44,#D1,#E0,#80,#00,#E0,#A2,#E0,#D0,#00,#E0,#A2,#E0,#F2
db #C0,#D0,#00,#44,#C4,#00,#00,#45,#9B,#0A,#00,#00,#00,#00,#10,#0C
db #00,#00,#00,#04,#0C,#04,#18,#00,#00,#04,#08,#0C,#00,#00,#00,#10,#0C,#00,#94,#ED,#C0,#D9,#F3,#00
db #55,#BE,#3C,#3C,#7C,#3C,#00,#C0,#A0,#00,#44,#D1,#E0,#80,#00,#E0,#80,#C8,#88,#00,#E0,#80,#E0,#D0
db #C0,#A0,#00,#44,#C0,#00,#00,#11,#27,#05,#33,#0A,#00,#00,#00,#0C
db #00,#00,#10,#24,#18,#04,#18,#00,#00,#04,#08,#0C,#00,#00,#00,#00,#0C,#00,#EF,#A6,#5C,#D9,#F3,#00
db #55,#BE,#3C,#7D,#FF,#00,#00,#C0,#A0,#00,#50,#C0,#E0,#80,#50,#C0,#F0,#C0,#A0,#00,#E0,#80,#E0,#D0
db #C0,#A0,#00,#50,#C0,#00,#00,#33,#0A,#00,#9B,#82,#00,#00,#00,#0C
db #00,#10,#24,#0C,#18,#04,#08,#00,#00,#04,#08,#0C,#00,#00,#00,#00,#0C,#00,#EF,#A6,#5C,#D9,#F3,#00
db #55,#FF,#3C,#FF,#FF,#00,#00,#C0,#A0,#00,#50,#C0,#E0,#D0,#E0,#D0,#50,#C0,#A0,#00,#E0,#80,#E0,#D0
db #C0,#A0,#00,#50,#C0,#00,#11,#67,#0A,#00,#11,#00,#00,#00,#00,#0C
db #10,#24,#0C,#0C,#20,#04,#08,#00,#00,#04,#08,#0C,#00,#00,#00,#00,#0C,#00,#CC,#CC,#CC,#D9,#F3,#00
db #55,#FF,#FF,#FF,#FC,#00,#00,#C0,#A0,#00,#50,#C0,#E0,#C0,#C0,#A0,#50,#C0,#A0,#00,#E0,#80,#E0,#D0
db #C0,#A0,#00,#50,#C0,#00,#1B,#27,#8A,#00,#9B,#00,#00,#00,#10,#0C
db #04,#0C,#0C,#18,#00,#04,#08,#00,#00,#04,#08,#0C,#00,#00,#00,#10,#0C,#00,#CC,#CC,#CC,#D9,#F3,#00
db #15,#FF,#FF,#FF,#FF,#00,#00,#C0,#A0,#00,#44,#C0,#E0,#80,#E0,#80,#50,#C0,#A0,#00,#E0,#80,#E0,#D0
db #C0,#A0,#00,#44,#C0,#00,#33,#0A,#22,#00,#67,#00,#00,#00,#24,#0C
db #04,#0C,#18,#30,#00,#04,#08,#00,#00,#04,#08,#0C,#00,#00,#00,#24,#0C,#00,#51,#F3,#F3,#F3,#F3,#00
db #00,#FF,#FF,#FF,#FF,#00,#00,#C8,#88,#00,#44,#D0,#E0,#80,#40,#D0,#50,#C0,#88,#00,#E0,#80,#E0,#D0
db #C0,#88,#00,#44,#C4,#05,#33,#0A,#27,#05,#63,#00,#00,#10,#0C,#18
db #04,#18,#10,#0C,#20,#04,#08,#00,#00,#24,#08,#0C,#00,#00,#10,#0C,#18,#00,#51,#F3,#F3,#F3,#F3,#00
db #00,#D5,#FF,#FF,#FF,#00,#00,#E0,#D0,#00,#E0,#D0,#E0,#80,#50,#C0,#50,#C8,#80,#00,#E0,#80,#E0,#80
db #E0,#D0,#00,#E0,#D0,#05,#67,#0A,#67,#45,#22,#00,#00,#24,#0C,#18
db #04,#08,#10,#0C,#20,#04,#08,#00,#00,#0C,#20,#0C,#00,#00,#24,#0C,#18,#00,#51,#F3,#F3,#F3,#F3,#00
db #50,#D5,#FF,#FF,#FF,#2A,#00,#E0,#D0,#00,#E0,#80,#E0,#80,#50,#C0,#A0,#E0,#D0,#50,#C0,#80,#E0,#80
db #E0,#D0,#00,#E0,#80,#C7,#67,#00,#9B,#11,#8A,#00,#30,#0C,#0C,#20
db #04,#08,#00,#24,#18,#04,#18,#00,#04,#0C,#20,#0C,#00,#10,#0C,#0C,#20,#00,#00,#15,#3F,#3F,#00,#00
db #50,#C0,#FF,#FF,#FF,#2A,#00,#44,#C0,#F0,#C0,#A0,#E0,#80,#00,#E0,#80,#E0,#C0,#E0,#C0,#80,#E0,#80
db #40,#C0,#F0,#C0,#A0,#93,#27,#00,#1B,#1B,#0A,#04,#0C,#0C,#18,#00
db #04,#08,#00,#24,#18,#10,#0C,#0C,#0C,#18,#00,#0C,#04,#0C,#0C,#18,#00,#00,#00,#15,#3F,#3F,#00,#00
db #40,#C0,#FF,#FF,#FF,#BF,#00,#50,#C0,#C0,#D0,#00,#E0,#80,#00,#E0,#D0,#40,#C0,#C0,#E0,#80,#E0,#80
db #50,#C0,#C0,#D0,#00,#93,#27,#00,#11,#0F,#00,#04,#0C,#0C,#20,#00
db #04,#08,#00,#10,#0C,#30,#0C,#0C,#0C,#20,#00,#0C,#04,#0C,#0C,#20,#00,#00,#10,#0C,#0C,#0C,#18,#00
db #40,#F0,#D5,#FF,#FF,#BF,#00,#00,#E0,#D0,#A0,#00,#F0,#A0,#00,#50,#C0,#A0,#E0,#80,#F0,#A0,#F0,#A0
db #00,#E0,#D0,#A0,#00,#93,#27,#00,#00,#63,#00,#04,#0C,#18,#00,#00
db #04,#08,#00,#10,#0C,#20,#24,#0C,#18,#00,#00,#0C,#04,#0C,#18,#00,#00,#00,#24,#0C,#0C,#0C,#0C,#20
db #F0,#C0,#C0,#FF,#FF,#BF,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#E0,#D0,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#C7,#67,#00,#05,#67,#00,#10,#30,#20,#00,#00
db #10,#20,#00,#10,#30,#20,#10,#30,#20,#00,#00,#30,#10,#30,#20,#00,#00,#00,#24,#0C,#1C,#0C,#0C,#20
db #E0,#C0,#C0,#D5,#FF,#BF,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#50,#C0,#80,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#05,#67,#00,#4F,#9B,#0A,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0C,#0C,#79,#2C,#0C,#08
db #E0,#C0,#C0,#C0,#FF,#BF,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#05,#33,#0F,#67,#93,#0A,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0C,#1C,#B6,#B6,#0C,#08
db #E0,#C0,#C0,#C0,#FF,#AA,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#1B,#33,#27,#05,#67,#0A,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0C,#79,#2C,#79,#2C,#08
db #E0,#C0,#C0,#C0,#D5,#2A,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#05,#1B,#0A,#00,#9B,#33,#22,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0C,#1C,#B6,#B6,#0C,#08
db #E0,#C0,#C0,#C0,#C0,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#C3,#82,#00,#41,#82,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0C,#0C,#79,#2C,#0C,#08


__Half_TimeMachine:
;slightly compressed:
;if value < 9 -> that much zeroes

db 5,#76,#F0,#F0
db 3,#11,#F8,#F0,#F0,#F0
db 2,#11,#F8,#F0,#F0,#F0,#F0
db 2,#74,#F0,#F0,#F0,#F0,#F0
db 1,#11,#F0,#F0,#F3,#FF,#FF,#FF
db 1,#32,#F0,#F7,4
db 1,#74,#F1,5
db 1,#F8,#E2,5
db 1,#F0,#C4,5
db #11,#F0,#88,5
db #10,#F0,6
db #32,#F1,6
db #30,#E0,6
db #74,#E2,#88,5
db #74,#C0,6
db #70,#C0,6
db #70,#C4,6
db #F8,#C5,6
db #F8,#C4,6
db #F0,#80,6
db #F0,#82,6
db #F0,#80,6
db #F0,#C5,6
db #F0,#C4,#88,5
db #F0,#F3,6
db #F0,#F0,#FF,#FF,#FF,#FF,#FF,#FF
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F8,#F1,#FF,#FF,#FF,#FF,#FF,#FF
db #F8,#F3,6
db #70,#E2,6
db #74,#E2,#88,5
db #30,#F1,#44,5
db #32,#F0,#88,5
db #11,#F0,#E6,5
db 1,#F8,#F1,#FF,#FF,#FF,#FF,#FF
db 1,#74,#F0,#F0,#F0,#F0,#F0,#F0
db 1,#11,#F0,#F0,#F0,#F0,#F0,#F0
db 2,#74,#F0,#F0,#F0,#F0,#F0
db 2,#11,#F0,#F0,#F0,#F0,#F0
db 2,#11,#0F,#7E,#F0,#F0,#F0
db 2,#47,#0F,#88,2,#47
db 1,#11,#0F,#1F,3,#8F

__Half_Juez:
db 5,#33,#FF,#FF, 5,#FC,#F0,#F0
db 4,#33,#F0,#F0,#F0, 4,#FC,#F0,#F0,#F0
db 3,#33,#FF,#FC,#F0,#F0, 3,#33,#F0,#FF,#FF,#F0
db 3,#33,#F0,#CF,#3F,#FF, 3,#FF,#FF,#F3,#FF,#FF
db 3,#FC,#F0,#FC,#F0,#CF, 3,#FC,#F0,#FC,#F0,#CF
db 3,#FF,#FF,#3F,#FF,#0F, 3,#FC,#F3,#0F,#0F,#0F
db 3,#FC,#F3,#CF,#0F,#FF, 3,#FF,#FF,#CF,#0F,#CF
db 5,#33,#0F,#0F, 5,#FF,#FF,#FF
db 4,#33,#FF,#CF,#3C, 4,#FF,#FF,#FF,#3C
db 4,#FF,#FF,#FF,#3C, 4,#FF,#FF,#FF,#3C
db 4,#FF,#FC,#FF,#3C, 4,#FF,#FC,#FF,#0F
db 4,#FF,#FC,#FF,#FF, 4,#FF,#FC,#FF,#FF
db 4,#FF,#FC,#FF,#FF, 4,#CF,#3C,#FF,#FF
db 4,#FF,#3C,#FF,#FF, 4,#33,#FC,#FF,#FF
db 5,#30,#F0,#F0, 5,#FF,#FF,#CC
db 5,#FF,#FF,1, 5,#33,#FF,1
